export declare const AdScheduleInfo: {
    start_minute: string;
    end_minute: string;
    start_hour: string;
    end_hour: string;
    day_of_week: string;
};
export declare const AffiliateLocationFeedItem: {
    business_name: string;
    address_line1: string;
    address_line2: string;
    city: string;
    province: string;
    postal_code: string;
    country_code: string;
    phone_number: string;
    chain_id: string;
    chain_name: string;
};
export declare const AgeRangeInfo: {
    type: string;
};
export declare const AdTextAsset: {
    text: string;
    pinned_field: string;
};
export declare const AdImageAsset: {
    asset: string;
};
export declare const AdVideoAsset: {
    asset: string;
};
export declare const AdMediaBundleAsset: {
    asset: string;
};
export declare const AppAdInfo: {
    mandatory_ad_text: {
        text: string;
        pinned_field: string;
    };
    headlines: {
        text: string;
        pinned_field: string;
    };
    descriptions: {
        text: string;
        pinned_field: string;
    };
    images: {
        asset: string;
    };
    youtube_videos: {
        asset: string;
    };
    html_5_media_bundles: {
        asset: string;
    };
};
export declare const AppEngagementAdInfo: {
    headlines: {
        text: string;
        pinned_field: string;
    };
    descriptions: {
        text: string;
        pinned_field: string;
    };
    images: {
        asset: string;
    };
    videos: {
        asset: string;
    };
};
export declare const CustomParameter: {
    key: string;
    value: string;
};
export declare const AppFeedItem: {
    link_text: string;
    app_id: string;
    app_store: string;
    final_urls: string;
    final_mobile_urls: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    final_url_suffix: string;
};
export declare const AppPaymentModelInfo: {
    type: string;
};
export declare const UserListActionInfo: {
    conversion_action: string;
    remarketing_action: string;
};
export declare const BasicUserListInfo: {
    actions: {
        conversion_action: string;
        remarketing_action: string;
    };
};
export declare const BidModifierSimulationPoint: {
    bid_modifier: string;
    biddable_conversions: string;
    biddable_conversions_value: string;
    clicks: string;
    cost_micros: string;
    impressions: string;
    top_slot_impressions: string;
    parent_biddable_conversions: string;
    parent_biddable_conversions_value: string;
    parent_clicks: string;
    parent_cost_micros: string;
    parent_impressions: string;
    parent_top_slot_impressions: string;
    parent_required_budget_micros: string;
};
export declare const BidModifierSimulationPointList: {
    points: {
        bid_modifier: string;
        biddable_conversions: string;
        biddable_conversions_value: string;
        clicks: string;
        cost_micros: string;
        impressions: string;
        top_slot_impressions: string;
        parent_biddable_conversions: string;
        parent_biddable_conversions_value: string;
        parent_clicks: string;
        parent_cost_micros: string;
        parent_impressions: string;
        parent_top_slot_impressions: string;
        parent_required_budget_micros: string;
    };
};
export declare const CallFeedItem: {
    phone_number: string;
    country_code: string;
    call_tracking_enabled: string;
    call_conversion_action: string;
    call_conversion_tracking_disabled: string;
    call_conversion_reporting_state: string;
};
export declare const CallOnlyAdInfo: {
    country_code: string;
    phone_number: string;
    business_name: string;
    headline1: string;
    headline2: string;
    description1: string;
    description2: string;
    call_tracked: string;
    disable_call_conversion: string;
    phone_number_verification_url: string;
    conversion_action: string;
    conversion_reporting_state: string;
};
export declare const CalloutFeedItem: {
    callout_text: string;
};
export declare const CarrierInfo: {
    carrier_constant: string;
};
export declare const ClickLocation: {
    city: string;
    country: string;
    metro: string;
    most_specific: string;
    region: string;
};
export declare const Commission: {
    commission_rate_micros: string;
};
export declare const ContentLabelInfo: {
    type: string;
};
export declare const CpcBidSimulationPoint: {
    cpc_bid_micros: string;
    biddable_conversions: string;
    biddable_conversions_value: string;
    clicks: string;
    cost_micros: string;
    impressions: string;
    top_slot_impressions: string;
};
export declare const CpcBidSimulationPointList: {
    points: {
        cpc_bid_micros: string;
        biddable_conversions: string;
        biddable_conversions_value: string;
        clicks: string;
        cost_micros: string;
        impressions: string;
        top_slot_impressions: string;
    };
};
export declare const CpvBidSimulationPoint: {
    cpv_bid_micros: string;
    cost_micros: string;
    impressions: string;
    views: string;
};
export declare const CpvBidSimulationPointList: {
    points: {
        cpv_bid_micros: string;
        cost_micros: string;
        impressions: string;
        views: string;
    };
};
export declare const CriterionCategoryChannelAvailability: {
    availability_mode: string;
    advertising_channel_type: string;
    advertising_channel_sub_type: string;
    include_default_channel_sub_type: string;
};
export declare const CriterionCategoryLocaleAvailability: {
    availability_mode: string;
    country_code: string;
    language_code: string;
};
export declare const CriterionCategoryAvailability: {
    channel: {
        availability_mode: string;
        advertising_channel_type: string;
        advertising_channel_sub_type: string;
        include_default_channel_sub_type: string;
    };
    locale: {
        availability_mode: string;
        country_code: string;
        language_code: string;
    };
};
export declare const CrmBasedUserListInfo: {
    app_id: string;
    upload_key_type: string;
    data_source_type: string;
};
export declare const CustomAffinityInfo: {
    custom_affinity: string;
};
export declare const CustomIntentInfo: {
    custom_intent: string;
};
export declare const DateRange: {
    start_date: string;
    end_date: string;
};
export declare const DeviceInfo: {
    type: string;
};
export declare const DisplayUploadAdInfo: {
    display_upload_product_type: string;
    media_bundle: {
        asset: string;
    };
};
export declare const EnhancedCpc: {};
export declare const ExpandedDynamicSearchAdInfo: {
    description: string;
    description2: string;
};
export declare const ExpandedTextAdInfo: {
    headline_part1: string;
    headline_part2: string;
    headline_part3: string;
    description: string;
    description2: string;
    path1: string;
    path2: string;
};
export declare const ExplorerAutoOptimizerSetting: {
    opt_in: string;
};
export declare const FinalAppUrl: {
    os_type: string;
    url: string;
};
export declare const FrequencyCapKey: {
    level: string;
    event_type: string;
    time_unit: string;
    time_length: string;
};
export declare const FrequencyCapEntry: {
    key: {
        level: string;
        event_type: string;
        time_unit: string;
        time_length: string;
    };
    cap: string;
};
export declare const ConstantOperand: {
    string_value: string;
    long_value: string;
    boolean_value: string;
    double_value: string;
};
export declare const FeedAttributeOperand: {
    feed_id: string;
    feed_attribute_id: string;
};
export declare const RequestContextOperand: {
    context_type: string;
};
export declare const ConstantOperand: {
    string_value: string;
    long_value: string;
    boolean_value: string;
    double_value: string;
};
export declare const FeedAttributeOperand: {
    feed_id: string;
    feed_attribute_id: string;
};
export declare const FunctionOperand: {
    matching_function: {
        function_string: string;
        operator: string;
        left_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
        right_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
    };
};
export declare const RequestContextOperand: {
    context_type: string;
};
export declare const Operand: {
    constant_operand: {
        string_value: string;
        long_value: string;
        boolean_value: string;
        double_value: string;
    };
    feed_attribute_operand: {
        feed_id: string;
        feed_attribute_id: string;
    };
    function_operand: null;
    request_context_operand: {
        context_type: string;
    };
};
export declare const MatchingFunction: {
    function_string: string;
    operator: string;
    left_operands: {
        constant_operand: {
            string_value: string;
            long_value: string;
            boolean_value: string;
            double_value: string;
        };
        feed_attribute_operand: {
            feed_id: string;
            feed_attribute_id: string;
        };
        function_operand: null;
        request_context_operand: {
            context_type: string;
        };
    };
    right_operands: {
        constant_operand: {
            string_value: string;
            long_value: string;
            boolean_value: string;
            double_value: string;
        };
        feed_attribute_operand: {
            feed_id: string;
            feed_attribute_id: string;
        };
        function_operand: null;
        request_context_operand: {
            context_type: string;
        };
    };
};
export declare const GenderInfo: {
    type: string;
};
export declare const GmailTeaser: {
    headline: string;
    description: string;
    business_name: string;
    logo_image: string;
};
export declare const DisplayCallToAction: {
    text: string;
    text_color: string;
    url_collection_id: string;
};
export declare const ProductImage: {
    product_image: string;
    description: string;
    display_call_to_action: {
        text: string;
        text_color: string;
        url_collection_id: string;
    };
};
export declare const ProductVideo: {
    product_video: string;
};
export declare const GmailAdInfo: {
    teaser: {
        headline: string;
        description: string;
        business_name: string;
        logo_image: string;
    };
    header_image: string;
    marketing_image: string;
    marketing_image_headline: string;
    marketing_image_description: string;
    marketing_image_display_call_to_action: {
        text: string;
        text_color: string;
        url_collection_id: string;
    };
    product_images: {
        product_image: string;
        description: string;
        display_call_to_action: {
            text: string;
            text_color: string;
            url_collection_id: string;
        };
    };
    product_videos: {
        product_video: string;
    };
};
export declare const HotelAdInfo: {};
export declare const HotelAdvanceBookingWindowInfo: {
    min_days: string;
    max_days: string;
};
export declare const HotelCalloutFeedItem: {
    text: string;
    language_code: string;
};
export declare const HotelCheckInDayInfo: {
    day_of_week: string;
};
export declare const HotelDateSelectionTypeInfo: {
    type: string;
};
export declare const HotelLengthOfStayInfo: {
    min_nights: string;
    max_nights: string;
};
export declare const ImageAdInfo: {
    pixel_width: string;
    pixel_height: string;
    image_url: string;
    preview_pixel_width: string;
    preview_pixel_height: string;
    preview_image_url: string;
    mime_type: string;
    name: string;
    media_file: string;
    data: string;
    ad_id_to_copy_image_from: string;
};
export declare const ImageDimension: {
    height_pixels: string;
    width_pixels: string;
    url: string;
};
export declare const ImageAsset: {
    data: string;
    file_size: string;
    mime_type: string;
    full_size: {
        height_pixels: string;
        width_pixels: string;
        url: string;
    };
};
export declare const IncomeRangeInfo: {
    type: string;
};
export declare const InteractionTypeInfo: {
    type: string;
};
export declare const IpBlockInfo: {
    ip_address: string;
};
export declare const KeywordPlanHistoricalMetrics: {
    avg_monthly_searches: string;
    competition: string;
};
export declare const LanguageInfo: {
    language_constant: string;
};
export declare const LegacyAppInstallAdInfo: {
    app_id: string;
    app_store: string;
    headline: string;
    description1: string;
    description2: string;
};
export declare const LegacyResponsiveDisplayAdInfo: {
    short_headline: string;
    long_headline: string;
    description: string;
    business_name: string;
    allow_flexible_color: string;
    accent_color: string;
    main_color: string;
    call_to_action_text: string;
    logo_image: string;
    square_logo_image: string;
    marketing_image: string;
    square_marketing_image: string;
    format_setting: string;
    price_prefix: string;
    promo_text: string;
};
export declare const HotelIdInfo: {
    value: string;
};
export declare const HotelClassInfo: {
    value: string;
};
export declare const HotelCountryRegionInfo: {
    country_region_criterion: string;
};
export declare const HotelStateInfo: {
    state_criterion: string;
};
export declare const HotelCityInfo: {
    city_criterion: string;
};
export declare const ProductBiddingCategoryInfo: {
    id: string;
    country_code: string;
    level: string;
};
export declare const ProductBrandInfo: {
    value: string;
};
export declare const ProductChannelInfo: {
    channel: string;
};
export declare const ProductChannelExclusivityInfo: {
    channel_exclusivity: string;
};
export declare const ProductConditionInfo: {
    condition: string;
};
export declare const ProductCustomAttributeInfo: {
    value: string;
    index: string;
};
export declare const ProductItemIdInfo: {
    value: string;
};
export declare const ProductTypeInfo: {
    value: string;
    level: string;
};
export declare const UnknownListingDimensionInfo: {};
export declare const ListingDimensionInfo: {
    hotel_id: {
        value: string;
    };
    hotel_class: {
        value: string;
    };
    hotel_country_region: {
        country_region_criterion: string;
    };
    hotel_state: {
        state_criterion: string;
    };
    hotel_city: {
        city_criterion: string;
    };
    product_bidding_category: {
        id: string;
        country_code: string;
        level: string;
    };
    product_brand: {
        value: string;
    };
    product_channel: {
        channel: string;
    };
    product_channel_exclusivity: {
        channel_exclusivity: string;
    };
    product_condition: {
        condition: string;
    };
    product_custom_attribute: {
        value: string;
        index: string;
    };
    product_item_id: {
        value: string;
    };
    product_type: {
        value: string;
        level: string;
    };
    unknown_listing_dimension: {};
};
export declare const ListingGroupInfo: {
    type: string;
    case_value: {
        hotel_id: {
            value: string;
        };
        hotel_class: {
            value: string;
        };
        hotel_country_region: {
            country_region_criterion: string;
        };
        hotel_state: {
            state_criterion: string;
        };
        hotel_city: {
            city_criterion: string;
        };
        product_bidding_category: {
            id: string;
            country_code: string;
            level: string;
        };
        product_brand: {
            value: string;
        };
        product_channel: {
            channel: string;
        };
        product_channel_exclusivity: {
            channel_exclusivity: string;
        };
        product_condition: {
            condition: string;
        };
        product_custom_attribute: {
            value: string;
            index: string;
        };
        product_item_id: {
            value: string;
        };
        product_type: {
            value: string;
            level: string;
        };
        unknown_listing_dimension: {};
    };
    parent_ad_group_criterion: string;
};
export declare const ListingScopeInfo: {
    dimensions: {
        hotel_id: {
            value: string;
        };
        hotel_class: {
            value: string;
        };
        hotel_country_region: {
            country_region_criterion: string;
        };
        hotel_state: {
            state_criterion: string;
        };
        hotel_city: {
            city_criterion: string;
        };
        product_bidding_category: {
            id: string;
            country_code: string;
            level: string;
        };
        product_brand: {
            value: string;
        };
        product_channel: {
            channel: string;
        };
        product_channel_exclusivity: {
            channel_exclusivity: string;
        };
        product_condition: {
            condition: string;
        };
        product_custom_attribute: {
            value: string;
            index: string;
        };
        product_item_id: {
            value: string;
        };
        product_type: {
            value: string;
            level: string;
        };
        unknown_listing_dimension: {};
    };
};
export declare const LocationFeedItem: {
    business_name: string;
    address_line1: string;
    address_line2: string;
    city: string;
    province: string;
    postal_code: string;
    country_code: string;
    phone_number: string;
};
export declare const LocationGroupInfo: {
    feed: string;
    geo_target_constants: string;
    radius: string;
    radius_units: string;
};
export declare const LocationInfo: {
    geo_target_constant: string;
};
export declare const LogicalUserListOperandInfo: {
    user_list: string;
};
export declare const UserListLogicalRuleInfo: {
    operator: string;
    rule_operands: {
        user_list: string;
    };
};
export declare const LogicalUserListInfo: {
    rules: {
        operator: string;
        rule_operands: {
            user_list: string;
        };
    };
};
export declare const ManualCpc: {
    enhanced_cpc_enabled: string;
};
export declare const ManualCpm: {};
export declare const ManualCpv: {};
export declare const MaximizeConversionValue: {
    target_roas: string;
};
export declare const MaximizeConversions: {};
export declare const MediaBundleAsset: {
    data: string;
};
export declare const Metrics: {
    absolute_top_impression_percentage: string;
    active_view_cpm: string;
    active_view_ctr: string;
    active_view_impressions: string;
    active_view_measurability: string;
    active_view_measurable_cost_micros: string;
    active_view_measurable_impressions: string;
    active_view_viewability: string;
    all_conversions_from_interactions_rate: string;
    all_conversions_value: string;
    all_conversions: string;
    all_conversions_value_per_cost: string;
    all_conversions_from_click_to_call: string;
    all_conversions_from_directions: string;
    all_conversions_from_interactions_value_per_interaction: string;
    all_conversions_from_menu: string;
    all_conversions_from_order: string;
    all_conversions_from_other_engagement: string;
    all_conversions_from_store_visit: string;
    all_conversions_from_store_website: string;
    average_cost: string;
    average_cpc: string;
    average_cpe: string;
    average_cpm: string;
    average_cpv: string;
    average_page_views: string;
    average_time_on_site: string;
    benchmark_average_max_cpc: string;
    benchmark_ctr: string;
    bounce_rate: string;
    clicks: string;
    combined_clicks: string;
    combined_clicks_per_query: string;
    combined_queries: string;
    content_budget_lost_impression_share: string;
    content_impression_share: string;
    conversion_last_received_request_date_time: string;
    conversion_last_conversion_date: string;
    content_rank_lost_impression_share: string;
    conversions_from_interactions_rate: string;
    conversions_value: string;
    conversions_value_per_cost: string;
    conversions_from_interactions_value_per_interaction: string;
    conversions: string;
    cost_micros: string;
    cost_per_all_conversions: string;
    cost_per_conversion: string;
    cost_per_current_model_attributed_conversion: string;
    cross_device_conversions: string;
    ctr: string;
    current_model_attributed_conversions: string;
    current_model_attributed_conversions_from_interactions_rate: string;
    current_model_attributed_conversions_from_interactions_value_per_interaction: string;
    current_model_attributed_conversions_value: string;
    current_model_attributed_conversions_value_per_cost: string;
    engagement_rate: string;
    engagements: string;
    hotel_average_lead_value_micros: string;
    hotel_price_difference_percentage: string;
    historical_creative_quality_score: string;
    historical_landing_page_quality_score: string;
    historical_quality_score: string;
    historical_search_predicted_ctr: string;
    gmail_forwards: string;
    gmail_saves: string;
    gmail_secondary_clicks: string;
    impressions_from_store_reach: string;
    impressions: string;
    interaction_rate: string;
    interactions: string;
    interaction_event_types: string;
    invalid_click_rate: string;
    invalid_clicks: string;
    message_chats: string;
    message_impressions: string;
    message_chat_rate: string;
    mobile_friendly_clicks_percentage: string;
    organic_clicks: string;
    organic_clicks_per_query: string;
    organic_impressions: string;
    organic_impressions_per_query: string;
    organic_queries: string;
    percent_new_visitors: string;
    phone_calls: string;
    phone_impressions: string;
    phone_through_rate: string;
    relative_ctr: string;
    search_absolute_top_impression_share: string;
    search_budget_lost_absolute_top_impression_share: string;
    search_budget_lost_impression_share: string;
    search_budget_lost_top_impression_share: string;
    search_click_share: string;
    search_exact_match_impression_share: string;
    search_impression_share: string;
    search_rank_lost_absolute_top_impression_share: string;
    search_rank_lost_impression_share: string;
    search_rank_lost_top_impression_share: string;
    search_top_impression_share: string;
    speed_score: string;
    top_impression_percentage: string;
    valid_accelerated_mobile_pages_clicks_percentage: string;
    value_per_all_conversions: string;
    value_per_conversion: string;
    value_per_current_model_attributed_conversion: string;
    video_quartile_100_rate: string;
    video_quartile_25_rate: string;
    video_quartile_50_rate: string;
    video_quartile_75_rate: string;
    video_view_rate: string;
    video_views: string;
    view_through_conversions: string;
};
export declare const MobileAppCategoryInfo: {
    mobile_app_category_constant: string;
};
export declare const MobileApplicationInfo: {
    app_id: string;
    name: string;
};
export declare const MobileDeviceInfo: {
    mobile_device_constant: string;
};
export declare const OperatingSystemVersionInfo: {
    operating_system_version_constant: string;
};
export declare const ParentalStatusInfo: {
    type: string;
};
export declare const PercentCpc: {
    cpc_bid_ceiling_micros: string;
    enhanced_cpc_enabled: string;
};
export declare const PlacementInfo: {
    url: string;
};
export declare const WebsiteList: {
    websites: string;
};
export declare const TextList: {
    texts: string;
};
export declare const DestinationTextList: {
    destination_texts: string;
};
export declare const DestinationMismatch: {
    url_types: string;
};
export declare const DestinationNotWorking: {
    expanded_url: string;
    device: string;
    last_checked_date_time: string;
    dns_error_type: string;
    http_error_code: string;
};
export declare const PolicyTopicEvidence: {
    website_list: {
        websites: string;
    };
    text_list: {
        texts: string;
    };
    language_code: string;
    destination_text_list: {
        destination_texts: string;
    };
    destination_mismatch: {
        url_types: string;
    };
    destination_not_working: {
        expanded_url: string;
        device: string;
        last_checked_date_time: string;
        dns_error_type: string;
        http_error_code: string;
    };
};
export declare const CountryConstraint: {
    country_criterion: string;
};
export declare const CountryConstraintList: {
    total_targeted_countries: string;
    countries: {
        country_criterion: string;
    };
};
export declare const ResellerConstraint: {};
export declare const PolicyTopicConstraint: {
    country_constraint_list: {
        total_targeted_countries: string;
        countries: {
            country_criterion: string;
        };
    };
    reseller_constraint: {};
    certificate_missing_in_country_list: {
        total_targeted_countries: string;
        countries: {
            country_criterion: string;
        };
    };
    certificate_domain_mismatch_in_country_list: {
        total_targeted_countries: string;
        countries: {
            country_criterion: string;
        };
    };
};
export declare const PolicyTopicEntry: {
    topic: string;
    type: string;
    evidences: {
        website_list: {
            websites: string;
        };
        text_list: {
            texts: string;
        };
        language_code: string;
        destination_text_list: {
            destination_texts: string;
        };
        destination_mismatch: {
            url_types: string;
        };
        destination_not_working: {
            expanded_url: string;
            device: string;
            last_checked_date_time: string;
            dns_error_type: string;
            http_error_code: string;
        };
    };
    constraints: {
        country_constraint_list: {
            total_targeted_countries: string;
            countries: {
                country_criterion: string;
            };
        };
        reseller_constraint: {};
        certificate_missing_in_country_list: {
            total_targeted_countries: string;
            countries: {
                country_criterion: string;
            };
        };
        certificate_domain_mismatch_in_country_list: {
            total_targeted_countries: string;
            countries: {
                country_criterion: string;
            };
        };
    };
};
export declare const PolicyViolationKey: {
    policy_name: string;
    violating_text: string;
};
export declare const PolicyValidationParameter: {
    ignorable_policy_topics: string;
    exempt_policy_violation_keys: {
        policy_name: string;
        violating_text: string;
    };
};
export declare const PreferredContentInfo: {
    type: string;
};
export declare const Money: {
    currency_code: string;
    amount_micros: string;
};
export declare const PriceOffer: {
    header: string;
    description: string;
    price: {
        currency_code: string;
        amount_micros: string;
    };
    unit: string;
    final_urls: string;
    final_mobile_urls: string;
};
export declare const PriceFeedItem: {
    type: string;
    price_qualifier: string;
    tracking_url_template: string;
    language_code: string;
    price_offerings: {
        header: string;
        description: string;
        price: {
            currency_code: string;
            amount_micros: string;
        };
        unit: string;
        final_urls: string;
        final_mobile_urls: string;
    };
    final_url_suffix: string;
};
export declare const PromotionFeedItem: {
    promotion_target: string;
    discount_modifier: string;
    promotion_start_date: string;
    promotion_end_date: string;
    occasion: string;
    final_urls: string;
    final_mobile_urls: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    final_url_suffix: string;
    language_code: string;
    percent_off: string;
    money_amount_off: {
        currency_code: string;
        amount_micros: string;
    };
    promotion_code: string;
    orders_over_amount: {
        currency_code: string;
        amount_micros: string;
    };
};
export declare const GeoPointInfo: {
    longitude_in_micro_degrees: string;
    latitude_in_micro_degrees: string;
};
export declare const AddressInfo: {
    postal_code: string;
    province_code: string;
    country_code: string;
    province_name: string;
    street_address: string;
    street_address2: string;
    city_name: string;
};
export declare const ProximityInfo: {
    geo_point: {
        longitude_in_micro_degrees: string;
        latitude_in_micro_degrees: string;
    };
    radius: string;
    radius_units: string;
    address: {
        postal_code: string;
        province_code: string;
        country_code: string;
        province_name: string;
        street_address: string;
        street_address2: string;
        city_name: string;
    };
};
export declare const RealTimeBiddingSetting: {
    opt_in: string;
};
export declare const ResponsiveDisplayAdInfo: {
    marketing_images: {
        asset: string;
    };
    square_marketing_images: {
        asset: string;
    };
    logo_images: {
        asset: string;
    };
    square_logo_images: {
        asset: string;
    };
    headlines: {
        text: string;
        pinned_field: string;
    };
    long_headline: {
        text: string;
        pinned_field: string;
    };
    descriptions: {
        text: string;
        pinned_field: string;
    };
    youtube_videos: {
        asset: string;
    };
    business_name: string;
    main_color: string;
    accent_color: string;
    allow_flexible_color: string;
    call_to_action_text: string;
    price_prefix: string;
    promo_text: string;
    format_setting: string;
};
export declare const ResponsiveSearchAdInfo: {
    headlines: {
        text: string;
        pinned_field: string;
    };
    descriptions: {
        text: string;
        pinned_field: string;
    };
    path1: string;
    path2: string;
};
export declare const UserListNumberRuleItemInfo: {
    operator: string;
    value: string;
};
export declare const UserListStringRuleItemInfo: {
    operator: string;
    value: string;
};
export declare const UserListDateRuleItemInfo: {
    operator: string;
    value: string;
    offset_in_days: string;
};
export declare const UserListRuleItemInfo: {
    name: string;
    number_rule_item: {
        operator: string;
        value: string;
    };
    string_rule_item: {
        operator: string;
        value: string;
    };
    date_rule_item: {
        operator: string;
        value: string;
        offset_in_days: string;
    };
};
export declare const UserListRuleItemGroupInfo: {
    rule_items: {
        name: string;
        number_rule_item: {
            operator: string;
            value: string;
        };
        string_rule_item: {
            operator: string;
            value: string;
        };
        date_rule_item: {
            operator: string;
            value: string;
            offset_in_days: string;
        };
    };
};
export declare const UserListRuleInfo: {
    rule_type: string;
    rule_item_groups: {
        rule_items: {
            name: string;
            number_rule_item: {
                operator: string;
                value: string;
            };
            string_rule_item: {
                operator: string;
                value: string;
            };
            date_rule_item: {
                operator: string;
                value: string;
                offset_in_days: string;
            };
        };
    };
};
export declare const CombinedRuleUserListInfo: {
    left_operand: {
        rule_type: string;
        rule_item_groups: {
            rule_items: {
                name: string;
                number_rule_item: {
                    operator: string;
                    value: string;
                };
                string_rule_item: {
                    operator: string;
                    value: string;
                };
                date_rule_item: {
                    operator: string;
                    value: string;
                    offset_in_days: string;
                };
            };
        };
    };
    right_operand: {
        rule_type: string;
        rule_item_groups: {
            rule_items: {
                name: string;
                number_rule_item: {
                    operator: string;
                    value: string;
                };
                string_rule_item: {
                    operator: string;
                    value: string;
                };
                date_rule_item: {
                    operator: string;
                    value: string;
                    offset_in_days: string;
                };
            };
        };
    };
    rule_operator: string;
};
export declare const DateSpecificRuleUserListInfo: {
    rule: {
        rule_type: string;
        rule_item_groups: {
            rule_items: {
                name: string;
                number_rule_item: {
                    operator: string;
                    value: string;
                };
                string_rule_item: {
                    operator: string;
                    value: string;
                };
                date_rule_item: {
                    operator: string;
                    value: string;
                    offset_in_days: string;
                };
            };
        };
    };
    start_date: string;
    end_date: string;
};
export declare const ExpressionRuleUserListInfo: {
    rule: {
        rule_type: string;
        rule_item_groups: {
            rule_items: {
                name: string;
                number_rule_item: {
                    operator: string;
                    value: string;
                };
                string_rule_item: {
                    operator: string;
                    value: string;
                };
                date_rule_item: {
                    operator: string;
                    value: string;
                    offset_in_days: string;
                };
            };
        };
    };
};
export declare const RuleBasedUserListInfo: {
    prepopulation_status: string;
    combined_rule_user_list: {
        left_operand: {
            rule_type: string;
            rule_item_groups: {
                rule_items: {
                    name: string;
                    number_rule_item: {
                        operator: string;
                        value: string;
                    };
                    string_rule_item: {
                        operator: string;
                        value: string;
                    };
                    date_rule_item: {
                        operator: string;
                        value: string;
                        offset_in_days: string;
                    };
                };
            };
        };
        right_operand: {
            rule_type: string;
            rule_item_groups: {
                rule_items: {
                    name: string;
                    number_rule_item: {
                        operator: string;
                        value: string;
                    };
                    string_rule_item: {
                        operator: string;
                        value: string;
                    };
                    date_rule_item: {
                        operator: string;
                        value: string;
                        offset_in_days: string;
                    };
                };
            };
        };
        rule_operator: string;
    };
    date_specific_rule_user_list: {
        rule: {
            rule_type: string;
            rule_item_groups: {
                rule_items: {
                    name: string;
                    number_rule_item: {
                        operator: string;
                        value: string;
                    };
                    string_rule_item: {
                        operator: string;
                        value: string;
                    };
                    date_rule_item: {
                        operator: string;
                        value: string;
                        offset_in_days: string;
                    };
                };
            };
        };
        start_date: string;
        end_date: string;
    };
    expression_rule_user_list: {
        rule: {
            rule_type: string;
            rule_item_groups: {
                rule_items: {
                    name: string;
                    number_rule_item: {
                        operator: string;
                        value: string;
                    };
                    string_rule_item: {
                        operator: string;
                        value: string;
                    };
                    date_rule_item: {
                        operator: string;
                        value: string;
                        offset_in_days: string;
                    };
                };
            };
        };
    };
};
export declare const KeywordInfo: {
    text: string;
    match_type: string;
};
export declare const Keyword: {
    ad_group_criterion: string;
    info: {
        text: string;
        match_type: string;
    };
};
export declare const Segments: {
    ad_network_type: string;
    click_type: string;
    conversion_action: string;
    conversion_action_category: string;
    conversion_action_name: string;
    conversion_adjustment: string;
    conversion_attribution_event_type: string;
    conversion_lag_bucket: string;
    conversion_or_adjustment_lag_bucket: string;
    date: string;
    day_of_week: string;
    device: string;
    external_conversion_source: string;
    geo_target_airport: string;
    geo_target_canton: string;
    geo_target_city: string;
    geo_target_country: string;
    geo_target_county: string;
    geo_target_district: string;
    geo_target_metro: string;
    geo_target_most_specific_location: string;
    geo_target_postal_code: string;
    geo_target_province: string;
    geo_target_region: string;
    geo_target_state: string;
    hotel_booking_window_days: string;
    hotel_center_id: string;
    hotel_check_in_date: string;
    hotel_check_in_day_of_week: string;
    hotel_city: string;
    hotel_class: string;
    hotel_country: string;
    hotel_date_selection_type: string;
    hotel_length_of_stay: string;
    hotel_rate_rule_id: string;
    hotel_rate_type: string;
    hotel_price_bucket: string;
    hotel_state: string;
    hour: string;
    interaction_on_this_extension: string;
    keyword: {
        ad_group_criterion: string;
        info: {
            text: string;
            match_type: string;
        };
    };
    month: string;
    month_of_year: string;
    partner_hotel_id: string;
    placeholder_type: string;
    product_aggregator_id: string;
    product_bidding_category_level1: string;
    product_bidding_category_level2: string;
    product_bidding_category_level3: string;
    product_bidding_category_level4: string;
    product_bidding_category_level5: string;
    product_brand: string;
    product_channel: string;
    product_channel_exclusivity: string;
    product_condition: string;
    product_country: string;
    product_custom_attribute0: string;
    product_custom_attribute1: string;
    product_custom_attribute2: string;
    product_custom_attribute3: string;
    product_custom_attribute4: string;
    product_item_id: string;
    product_language: string;
    product_merchant_id: string;
    product_store_id: string;
    product_title: string;
    product_type_l1: string;
    product_type_l2: string;
    product_type_l3: string;
    product_type_l4: string;
    product_type_l5: string;
    quarter: string;
    search_engine_results_page_type: string;
    search_term_match_type: string;
    slot: string;
    webpage: string;
    week: string;
    year: string;
};
export declare const ShoppingComparisonListingAdInfo: {
    headline: string;
};
export declare const ShoppingProductAdInfo: {};
export declare const ShoppingSmartAdInfo: {};
export declare const SimilarUserListInfo: {
    seed_user_list: string;
};
export declare const SitelinkFeedItem: {
    link_text: string;
    line1: string;
    line2: string;
    final_urls: string;
    final_mobile_urls: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    final_url_suffix: string;
};
export declare const StructuredSnippetFeedItem: {
    header: string;
    values: string;
};
export declare const TagSnippet: {
    type: string;
    page_format: string;
    global_site_tag: string;
    event_snippet: string;
};
export declare const TargetCpa: {
    target_cpa_micros: string;
    cpc_bid_ceiling_micros: string;
    cpc_bid_floor_micros: string;
};
export declare const TargetCpaSimulationPoint: {
    target_cpa_micros: string;
    biddable_conversions: string;
    biddable_conversions_value: string;
    clicks: string;
    cost_micros: string;
    impressions: string;
    top_slot_impressions: string;
};
export declare const TargetCpaSimulationPointList: {
    points: {
        target_cpa_micros: string;
        biddable_conversions: string;
        biddable_conversions_value: string;
        clicks: string;
        cost_micros: string;
        impressions: string;
        top_slot_impressions: string;
    };
};
export declare const TargetCpm: {};
export declare const TargetImpressionShare: {
    location: string;
    location_fraction_micros: string;
    cpc_bid_ceiling_micros: string;
};
export declare const TargetRoas: {
    target_roas: string;
    cpc_bid_ceiling_micros: string;
    cpc_bid_floor_micros: string;
};
export declare const TargetSpend: {
    target_spend_micros: string;
    cpc_bid_ceiling_micros: string;
};
export declare const TargetRestriction: {
    targeting_dimension: string;
    bid_only: string;
};
export declare const Operator: {};
export declare const Operator: {};
export declare const TargetRestrictionOperation: {
    operator: {};
    value: {
        targeting_dimension: string;
        bid_only: string;
    };
};
export declare const TargetingSetting: {
    target_restrictions: {
        targeting_dimension: string;
        bid_only: string;
    };
    target_restriction_operations: {
        operator: {};
        value: {
            targeting_dimension: string;
            bid_only: string;
        };
    };
};
export declare const TextAdInfo: {
    headline: string;
    description1: string;
    description2: string;
};
export declare const TextAsset: {
    text: string;
};
export declare const TextLabel: {
    background_color: string;
    description: string;
};
export declare const TextMessageFeedItem: {
    business_name: string;
    country_code: string;
    phone_number: string;
    text: string;
    extension_text: string;
};
export declare const TopicInfo: {
    topic_constant: string;
    path: string;
};
export declare const UrlCollection: {
    url_collection_id: string;
    final_urls: string;
    final_mobile_urls: string;
    tracking_url_template: string;
};
export declare const UserInterestInfo: {
    user_interest_category: string;
};
export declare const UserListInfo: {
    user_list: string;
};
export declare const Value: {
    boolean_value: string;
    int_64_value: string;
    float_value: string;
    double_value: string;
    string_value: string;
};
export declare const VideoTrueViewInStreamAdInfo: {
    action_button_label: string;
    action_headline: string;
    companion_banner: string;
};
export declare const VideoBumperInStreamAdInfo: {
    companion_banner: string;
};
export declare const VideoOutstreamAdInfo: {
    headline: string;
    description: string;
};
export declare const VideoNonSkippableInStreamAdInfo: {
    companion_banner: string;
};
export declare const VideoTrueViewDiscoveryAdInfo: {
    headline: string;
    description1: string;
    description2: string;
};
export declare const VideoAdInfo: {
    media_file: string;
    in_stream: {
        action_button_label: string;
        action_headline: string;
        companion_banner: string;
    };
    bumper: {
        companion_banner: string;
    };
    out_stream: {
        headline: string;
        description: string;
    };
    non_skippable: {
        companion_banner: string;
    };
    discovery: {
        headline: string;
        description1: string;
        description2: string;
    };
};
export declare const WebpageConditionInfo: {
    operand: string;
    operator: string;
    argument: string;
};
export declare const WebpageInfo: {
    criterion_name: string;
    conditions: {
        operand: string;
        operator: string;
        argument: string;
    };
};
export declare const YouTubeChannelInfo: {
    channel_id: string;
};
export declare const YouTubeVideoInfo: {
    video_id: string;
};
export declare const YoutubeVideoAsset: {
    youtube_video_id: string;
};
export declare const PendingAccountBudgetProposal: {
    account_budget_proposal: string;
    proposal_type: string;
    name: string;
    start_date_time: string;
    purchase_order_number: string;
    notes: string;
    creation_date_time: string;
    end_date_time: string;
    end_time_type: string;
    spending_limit_micros: string;
    spending_limit_type: string;
};
export declare const PendingAccountBudgetProposal: {
    account_budget_proposal: string;
    proposal_type: string;
    name: string;
    start_date_time: string;
    purchase_order_number: string;
    notes: string;
    creation_date_time: string;
    end_date_time: string;
    end_time_type: string;
    spending_limit_micros: string;
    spending_limit_type: string;
};
export declare const AccountBudget: {
    resource_name: string;
    id: string;
    billing_setup: string;
    status: string;
    name: string;
    proposed_start_date_time: string;
    approved_start_date_time: string;
    total_adjustments_micros: string;
    amount_served_micros: string;
    purchase_order_number: string;
    notes: string;
    pending_proposal: {
        account_budget_proposal: string;
        proposal_type: string;
        name: string;
        start_date_time: string;
        purchase_order_number: string;
        notes: string;
        creation_date_time: string;
        end_date_time: string;
        end_time_type: string;
        spending_limit_micros: string;
        spending_limit_type: string;
    };
    proposed_end_date_time: string;
    proposed_end_time_type: string;
    approved_end_date_time: string;
    approved_end_time_type: string;
    proposed_spending_limit_micros: string;
    proposed_spending_limit_type: string;
    approved_spending_limit_micros: string;
    approved_spending_limit_type: string;
    adjusted_spending_limit_micros: string;
    adjusted_spending_limit_type: string;
};
export declare const AccountBudgetProposal: {
    resource_name: string;
    id: string;
    billing_setup: string;
    account_budget: string;
    proposal_type: string;
    status: string;
    proposed_name: string;
    approved_start_date_time: string;
    proposed_purchase_order_number: string;
    proposed_notes: string;
    creation_date_time: string;
    approval_date_time: string;
    proposed_start_date_time: string;
    proposed_start_time_type: string;
    proposed_end_date_time: string;
    proposed_end_time_type: string;
    approved_end_date_time: string;
    approved_end_time_type: string;
    proposed_spending_limit_micros: string;
    proposed_spending_limit_type: string;
    approved_spending_limit_micros: string;
    approved_spending_limit_type: string;
};
export declare const AdGroup: {
    resource_name: string;
    id: string;
    name: string;
    status: string;
    type: string;
    ad_rotation_mode: string;
    base_ad_group: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    campaign: string;
    cpc_bid_micros: string;
    cpm_bid_micros: string;
    target_cpa_micros: string;
    cpv_bid_micros: string;
    target_cpm_micros: string;
    target_roas: string;
    percent_cpc_bid_micros: string;
    explorer_auto_optimizer_setting: {
        opt_in: string;
    };
    display_custom_bid_dimension: string;
    final_url_suffix: string;
    targeting_setting: {
        target_restrictions: {
            targeting_dimension: string;
            bid_only: string;
        };
        target_restriction_operations: {
            operator: {};
            value: {
                targeting_dimension: string;
                bid_only: string;
            };
        };
    };
    effective_target_cpa_micros: string;
    effective_target_cpa_source: string;
    effective_target_roas: string;
    effective_target_roas_source: string;
    labels: string;
};
export declare const Ad: {
    resource_name: string;
    id: string;
    final_urls: string;
    final_app_urls: {
        os_type: string;
        url: string;
    };
    final_mobile_urls: string;
    tracking_url_template: string;
    final_url_suffix: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    display_url: string;
    type: string;
    added_by_google_ads: string;
    device_preference: string;
    url_collections: {
        url_collection_id: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
    };
    name: string;
    system_managed_resource_source: string;
    text_ad: {
        headline: string;
        description1: string;
        description2: string;
    };
    expanded_text_ad: {
        headline_part1: string;
        headline_part2: string;
        headline_part3: string;
        description: string;
        description2: string;
        path1: string;
        path2: string;
    };
    call_only_ad: {
        country_code: string;
        phone_number: string;
        business_name: string;
        headline1: string;
        headline2: string;
        description1: string;
        description2: string;
        call_tracked: string;
        disable_call_conversion: string;
        phone_number_verification_url: string;
        conversion_action: string;
        conversion_reporting_state: string;
    };
    expanded_dynamic_search_ad: {
        description: string;
        description2: string;
    };
    hotel_ad: {};
    shopping_smart_ad: {};
    shopping_product_ad: {};
    gmail_ad: {
        teaser: {
            headline: string;
            description: string;
            business_name: string;
            logo_image: string;
        };
        header_image: string;
        marketing_image: string;
        marketing_image_headline: string;
        marketing_image_description: string;
        marketing_image_display_call_to_action: {
            text: string;
            text_color: string;
            url_collection_id: string;
        };
        product_images: {
            product_image: string;
            description: string;
            display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
        };
        product_videos: {
            product_video: string;
        };
    };
    image_ad: {
        pixel_width: string;
        pixel_height: string;
        image_url: string;
        preview_pixel_width: string;
        preview_pixel_height: string;
        preview_image_url: string;
        mime_type: string;
        name: string;
        media_file: string;
        data: string;
        ad_id_to_copy_image_from: string;
    };
    video_ad: {
        media_file: string;
        in_stream: {
            action_button_label: string;
            action_headline: string;
            companion_banner: string;
        };
        bumper: {
            companion_banner: string;
        };
        out_stream: {
            headline: string;
            description: string;
        };
        non_skippable: {
            companion_banner: string;
        };
        discovery: {
            headline: string;
            description1: string;
            description2: string;
        };
    };
    responsive_search_ad: {
        headlines: {
            text: string;
            pinned_field: string;
        };
        descriptions: {
            text: string;
            pinned_field: string;
        };
        path1: string;
        path2: string;
    };
    legacy_responsive_display_ad: {
        short_headline: string;
        long_headline: string;
        description: string;
        business_name: string;
        allow_flexible_color: string;
        accent_color: string;
        main_color: string;
        call_to_action_text: string;
        logo_image: string;
        square_logo_image: string;
        marketing_image: string;
        square_marketing_image: string;
        format_setting: string;
        price_prefix: string;
        promo_text: string;
    };
    app_ad: {
        mandatory_ad_text: {
            text: string;
            pinned_field: string;
        };
        headlines: {
            text: string;
            pinned_field: string;
        };
        descriptions: {
            text: string;
            pinned_field: string;
        };
        images: {
            asset: string;
        };
        youtube_videos: {
            asset: string;
        };
        html_5_media_bundles: {
            asset: string;
        };
    };
    legacy_app_install_ad: {
        app_id: string;
        app_store: string;
        headline: string;
        description1: string;
        description2: string;
    };
    responsive_display_ad: {
        marketing_images: {
            asset: string;
        };
        square_marketing_images: {
            asset: string;
        };
        logo_images: {
            asset: string;
        };
        square_logo_images: {
            asset: string;
        };
        headlines: {
            text: string;
            pinned_field: string;
        };
        long_headline: {
            text: string;
            pinned_field: string;
        };
        descriptions: {
            text: string;
            pinned_field: string;
        };
        youtube_videos: {
            asset: string;
        };
        business_name: string;
        main_color: string;
        accent_color: string;
        allow_flexible_color: string;
        call_to_action_text: string;
        price_prefix: string;
        promo_text: string;
        format_setting: string;
    };
    display_upload_ad: {
        display_upload_product_type: string;
        media_bundle: {
            asset: string;
        };
    };
    app_engagement_ad: {
        headlines: {
            text: string;
            pinned_field: string;
        };
        descriptions: {
            text: string;
            pinned_field: string;
        };
        images: {
            asset: string;
        };
        videos: {
            asset: string;
        };
    };
    shopping_comparison_listing_ad: {
        headline: string;
    };
};
export declare const AdGroupAdPolicySummary: {
    policy_topic_entries: {
        topic: string;
        type: string;
        evidences: {
            website_list: {
                websites: string;
            };
            text_list: {
                texts: string;
            };
            language_code: string;
            destination_text_list: {
                destination_texts: string;
            };
            destination_mismatch: {
                url_types: string;
            };
            destination_not_working: {
                expanded_url: string;
                device: string;
                last_checked_date_time: string;
                dns_error_type: string;
                http_error_code: string;
            };
        };
        constraints: {
            country_constraint_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            reseller_constraint: {};
            certificate_missing_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            certificate_domain_mismatch_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
        };
    };
    review_status: string;
    approval_status: string;
};
export declare const AdGroupAd: {
    resource_name: string;
    status: string;
    ad_group: string;
    ad: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
    policy_summary: {
        policy_topic_entries: {
            topic: string;
            type: string;
            evidences: {
                website_list: {
                    websites: string;
                };
                text_list: {
                    texts: string;
                };
                language_code: string;
                destination_text_list: {
                    destination_texts: string;
                };
                destination_mismatch: {
                    url_types: string;
                };
                destination_not_working: {
                    expanded_url: string;
                    device: string;
                    last_checked_date_time: string;
                    dns_error_type: string;
                    http_error_code: string;
                };
            };
            constraints: {
                country_constraint_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                reseller_constraint: {};
                certificate_missing_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                certificate_domain_mismatch_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
            };
        };
        review_status: string;
        approval_status: string;
    };
    ad_strength: string;
};
export declare const AdGroupAdAssetPolicySummary: {
    policy_topic_entries: {
        topic: string;
        type: string;
        evidences: {
            website_list: {
                websites: string;
            };
            text_list: {
                texts: string;
            };
            language_code: string;
            destination_text_list: {
                destination_texts: string;
            };
            destination_mismatch: {
                url_types: string;
            };
            destination_not_working: {
                expanded_url: string;
                device: string;
                last_checked_date_time: string;
                dns_error_type: string;
                http_error_code: string;
            };
        };
        constraints: {
            country_constraint_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            reseller_constraint: {};
            certificate_missing_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            certificate_domain_mismatch_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
        };
    };
    review_status: string;
    approval_status: string;
};
export declare const AdGroupAdAssetView: {
    resource_name: string;
    ad_group_ad: string;
    asset: string;
    field_type: string;
    policy_summary: {
        policy_topic_entries: {
            topic: string;
            type: string;
            evidences: {
                website_list: {
                    websites: string;
                };
                text_list: {
                    texts: string;
                };
                language_code: string;
                destination_text_list: {
                    destination_texts: string;
                };
                destination_mismatch: {
                    url_types: string;
                };
                destination_not_working: {
                    expanded_url: string;
                    device: string;
                    last_checked_date_time: string;
                    dns_error_type: string;
                    http_error_code: string;
                };
            };
            constraints: {
                country_constraint_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                reseller_constraint: {};
                certificate_missing_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                certificate_domain_mismatch_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
            };
        };
        review_status: string;
        approval_status: string;
    };
    performance_label: string;
};
export declare const AdGroupAdLabel: {
    resource_name: string;
    ad_group_ad: string;
    label: string;
};
export declare const AdGroupAudienceView: {
    resource_name: string;
};
export declare const AdGroupBidModifier: {
    resource_name: string;
    ad_group: string;
    criterion_id: string;
    bid_modifier: string;
    base_ad_group: string;
    bid_modifier_source: string;
    hotel_date_selection_type: {
        type: string;
    };
    hotel_advance_booking_window: {
        min_days: string;
        max_days: string;
    };
    hotel_length_of_stay: {
        min_nights: string;
        max_nights: string;
    };
    hotel_check_in_day: {
        day_of_week: string;
    };
    device: {
        type: string;
    };
    preferred_content: {
        type: string;
    };
};
export declare const QualityInfo: {
    quality_score: string;
    creative_quality_score: string;
    post_click_quality_score: string;
    search_predicted_ctr: string;
};
export declare const PositionEstimates: {
    first_page_cpc_micros: string;
    first_position_cpc_micros: string;
    top_of_page_cpc_micros: string;
    estimated_add_clicks_at_first_position_cpc: string;
    estimated_add_cost_at_first_position_cpc: string;
};
export declare const QualityInfo: {
    quality_score: string;
    creative_quality_score: string;
    post_click_quality_score: string;
    search_predicted_ctr: string;
};
export declare const PositionEstimates: {
    first_page_cpc_micros: string;
    first_position_cpc_micros: string;
    top_of_page_cpc_micros: string;
    estimated_add_clicks_at_first_position_cpc: string;
    estimated_add_cost_at_first_position_cpc: string;
};
export declare const AdGroupCriterion: {
    resource_name: string;
    criterion_id: string;
    status: string;
    quality_info: {
        quality_score: string;
        creative_quality_score: string;
        post_click_quality_score: string;
        search_predicted_ctr: string;
    };
    ad_group: string;
    type: string;
    negative: string;
    system_serving_status: string;
    approval_status: string;
    bid_modifier: string;
    cpc_bid_micros: string;
    cpm_bid_micros: string;
    cpv_bid_micros: string;
    percent_cpc_bid_micros: string;
    effective_cpc_bid_micros: string;
    effective_cpm_bid_micros: string;
    effective_cpv_bid_micros: string;
    effective_percent_cpc_bid_micros: string;
    effective_cpc_bid_source: string;
    effective_cpm_bid_source: string;
    effective_cpv_bid_source: string;
    effective_percent_cpc_bid_source: string;
    position_estimates: {
        first_page_cpc_micros: string;
        first_position_cpc_micros: string;
        top_of_page_cpc_micros: string;
        estimated_add_clicks_at_first_position_cpc: string;
        estimated_add_cost_at_first_position_cpc: string;
    };
    final_urls: string;
    final_mobile_urls: string;
    final_url_suffix: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    keyword: {
        text: string;
        match_type: string;
    };
    placement: {
        url: string;
    };
    mobile_app_category: {
        mobile_app_category_constant: string;
    };
    mobile_application: {
        app_id: string;
        name: string;
    };
    listing_group: {
        type: string;
        case_value: {
            hotel_id: {
                value: string;
            };
            hotel_class: {
                value: string;
            };
            hotel_country_region: {
                country_region_criterion: string;
            };
            hotel_state: {
                state_criterion: string;
            };
            hotel_city: {
                city_criterion: string;
            };
            product_bidding_category: {
                id: string;
                country_code: string;
                level: string;
            };
            product_brand: {
                value: string;
            };
            product_channel: {
                channel: string;
            };
            product_channel_exclusivity: {
                channel_exclusivity: string;
            };
            product_condition: {
                condition: string;
            };
            product_custom_attribute: {
                value: string;
                index: string;
            };
            product_item_id: {
                value: string;
            };
            product_type: {
                value: string;
                level: string;
            };
            unknown_listing_dimension: {};
        };
        parent_ad_group_criterion: string;
    };
    age_range: {
        type: string;
    };
    gender: {
        type: string;
    };
    income_range: {
        type: string;
    };
    parental_status: {
        type: string;
    };
    user_list: {
        user_list: string;
    };
    youtube_video: {
        video_id: string;
    };
    youtube_channel: {
        channel_id: string;
    };
    topic: {
        topic_constant: string;
        path: string;
    };
    user_interest: {
        user_interest_category: string;
    };
    webpage: {
        criterion_name: string;
        conditions: {
            operand: string;
            operator: string;
            argument: string;
        };
    };
    app_payment_model: {
        type: string;
    };
    custom_affinity: {
        custom_affinity: string;
    };
    custom_intent: {
        custom_intent: string;
    };
};
export declare const AdGroupCriterionLabel: {
    resource_name: string;
    ad_group_criterion: string;
    label: string;
};
export declare const AdGroupCriterionSimulation: {
    resource_name: string;
    ad_group_id: string;
    criterion_id: string;
    type: string;
    modification_method: string;
    start_date: string;
    end_date: string;
    cpc_bid_point_list: {
        points: {
            cpc_bid_micros: string;
            biddable_conversions: string;
            biddable_conversions_value: string;
            clicks: string;
            cost_micros: string;
            impressions: string;
            top_slot_impressions: string;
        };
    };
};
export declare const AdGroupExtensionSetting: {
    resource_name: string;
    extension_type: string;
    ad_group: string;
    extension_feed_items: string;
    device: string;
};
export declare const AdGroupFeed: {
    resource_name: string;
    feed: string;
    ad_group: string;
    placeholder_types: string;
    matching_function: {
        function_string: string;
        operator: string;
        left_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
        right_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
    };
    status: string;
};
export declare const AdGroupLabel: {
    resource_name: string;
    ad_group: string;
    label: string;
};
export declare const AdGroupSimulation: {
    resource_name: string;
    ad_group_id: string;
    type: string;
    modification_method: string;
    start_date: string;
    end_date: string;
    cpc_bid_point_list: {
        points: {
            cpc_bid_micros: string;
            biddable_conversions: string;
            biddable_conversions_value: string;
            clicks: string;
            cost_micros: string;
            impressions: string;
            top_slot_impressions: string;
        };
    };
    cpv_bid_point_list: {
        points: {
            cpv_bid_micros: string;
            cost_micros: string;
            impressions: string;
            views: string;
        };
    };
    target_cpa_point_list: {
        points: {
            target_cpa_micros: string;
            biddable_conversions: string;
            biddable_conversions_value: string;
            clicks: string;
            cost_micros: string;
            impressions: string;
            top_slot_impressions: string;
        };
    };
};
export declare const AdParameter: {
    resource_name: string;
    ad_group_criterion: string;
    parameter_index: string;
    insertion_text: string;
};
export declare const AdScheduleView: {
    resource_name: string;
};
export declare const AgeRangeView: {
    resource_name: string;
};
export declare const Asset: {
    resource_name: string;
    id: string;
    name: string;
    type: string;
    youtube_video_asset: {
        youtube_video_id: string;
    };
    media_bundle_asset: {
        data: string;
    };
    image_asset: {
        data: string;
        file_size: string;
        mime_type: string;
        full_size: {
            height_pixels: string;
            width_pixels: string;
            url: string;
        };
    };
    text_asset: {
        text: string;
    };
};
export declare const BiddingStrategy: {
    resource_name: string;
    id: string;
    name: string;
    status: string;
    type: string;
    campaign_count: string;
    non_removed_campaign_count: string;
    enhanced_cpc: {};
    target_cpa: {
        target_cpa_micros: string;
        cpc_bid_ceiling_micros: string;
        cpc_bid_floor_micros: string;
    };
    target_impression_share: {
        location: string;
        location_fraction_micros: string;
        cpc_bid_ceiling_micros: string;
    };
    target_roas: {
        target_roas: string;
        cpc_bid_ceiling_micros: string;
        cpc_bid_floor_micros: string;
    };
    target_spend: {
        target_spend_micros: string;
        cpc_bid_ceiling_micros: string;
    };
};
export declare const PaymentsAccountInfo: {
    payments_account_id: string;
    payments_account_name: string;
    payments_profile_id: string;
    payments_profile_name: string;
    secondary_payments_profile_id: string;
};
export declare const PaymentsAccountInfo: {
    payments_account_id: string;
    payments_account_name: string;
    payments_profile_id: string;
    payments_profile_name: string;
    secondary_payments_profile_id: string;
};
export declare const BillingSetup: {
    resource_name: string;
    id: string;
    status: string;
    payments_account: string;
    payments_account_info: {
        payments_account_id: string;
        payments_account_name: string;
        payments_profile_id: string;
        payments_profile_name: string;
        secondary_payments_profile_id: string;
    };
    start_date_time: string;
    start_time_type: string;
    end_date_time: string;
    end_time_type: string;
};
export declare const NetworkSettings: {
    target_google_search: string;
    target_search_network: string;
    target_content_network: string;
    target_partner_search_network: string;
};
export declare const HotelSettingInfo: {
    hotel_center_id: string;
};
export declare const DynamicSearchAdsSetting: {
    domain_name: string;
    language_code: string;
    use_supplied_urls_only: string;
    feeds: string;
};
export declare const ShoppingSetting: {
    merchant_id: string;
    sales_country: string;
    campaign_priority: string;
    enable_local: string;
};
export declare const GeoTargetTypeSetting: {
    positive_geo_target_type: string;
    negative_geo_target_type: string;
};
export declare const AppCampaignSetting: {
    bidding_strategy_goal_type: string;
    app_id: string;
    app_store: string;
};
export declare const VanityPharma: {
    vanity_pharma_display_url_mode: string;
    vanity_pharma_text: string;
};
export declare const SelectiveOptimization: {
    conversion_actions: string;
};
export declare const TrackingSetting: {
    tracking_url: string;
};
export declare const NetworkSettings: {
    target_google_search: string;
    target_search_network: string;
    target_content_network: string;
    target_partner_search_network: string;
};
export declare const HotelSettingInfo: {
    hotel_center_id: string;
};
export declare const AppCampaignSetting: {
    bidding_strategy_goal_type: string;
    app_id: string;
    app_store: string;
};
export declare const DynamicSearchAdsSetting: {
    domain_name: string;
    language_code: string;
    use_supplied_urls_only: string;
    feeds: string;
};
export declare const ShoppingSetting: {
    merchant_id: string;
    sales_country: string;
    campaign_priority: string;
    enable_local: string;
};
export declare const VanityPharma: {
    vanity_pharma_display_url_mode: string;
    vanity_pharma_text: string;
};
export declare const SelectiveOptimization: {
    conversion_actions: string;
};
export declare const GeoTargetTypeSetting: {
    positive_geo_target_type: string;
    negative_geo_target_type: string;
};
export declare const TrackingSetting: {
    tracking_url: string;
};
export declare const Campaign: {
    resource_name: string;
    id: string;
    name: string;
    status: string;
    serving_status: string;
    ad_serving_optimization_status: string;
    advertising_channel_type: string;
    advertising_channel_sub_type: string;
    tracking_url_template: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    real_time_bidding_setting: {
        opt_in: string;
    };
    network_settings: {
        target_google_search: string;
        target_search_network: string;
        target_content_network: string;
        target_partner_search_network: string;
    };
    hotel_setting: {
        hotel_center_id: string;
    };
    dynamic_search_ads_setting: {
        domain_name: string;
        language_code: string;
        use_supplied_urls_only: string;
        feeds: string;
    };
    shopping_setting: {
        merchant_id: string;
        sales_country: string;
        campaign_priority: string;
        enable_local: string;
    };
    targeting_setting: {
        target_restrictions: {
            targeting_dimension: string;
            bid_only: string;
        };
        target_restriction_operations: {
            operator: {};
            value: {
                targeting_dimension: string;
                bid_only: string;
            };
        };
    };
    geo_target_type_setting: {
        positive_geo_target_type: string;
        negative_geo_target_type: string;
    };
    app_campaign_setting: {
        bidding_strategy_goal_type: string;
        app_id: string;
        app_store: string;
    };
    labels: string;
    experiment_type: string;
    base_campaign: string;
    campaign_budget: string;
    bidding_strategy_type: string;
    start_date: string;
    end_date: string;
    final_url_suffix: string;
    frequency_caps: {
        key: {
            level: string;
            event_type: string;
            time_unit: string;
            time_length: string;
        };
        cap: string;
    };
    video_brand_safety_suitability: string;
    vanity_pharma: {
        vanity_pharma_display_url_mode: string;
        vanity_pharma_text: string;
    };
    selective_optimization: {
        conversion_actions: string;
    };
    tracking_setting: {
        tracking_url: string;
    };
    payment_mode: string;
    bidding_strategy: string;
    commission: {
        commission_rate_micros: string;
    };
    manual_cpc: {
        enhanced_cpc_enabled: string;
    };
    manual_cpm: {};
    manual_cpv: {};
    maximize_conversions: {};
    maximize_conversion_value: {
        target_roas: string;
    };
    target_cpa: {
        target_cpa_micros: string;
        cpc_bid_ceiling_micros: string;
        cpc_bid_floor_micros: string;
    };
    target_impression_share: {
        location: string;
        location_fraction_micros: string;
        cpc_bid_ceiling_micros: string;
    };
    target_roas: {
        target_roas: string;
        cpc_bid_ceiling_micros: string;
        cpc_bid_floor_micros: string;
    };
    target_spend: {
        target_spend_micros: string;
        cpc_bid_ceiling_micros: string;
    };
    percent_cpc: {
        cpc_bid_ceiling_micros: string;
        enhanced_cpc_enabled: string;
    };
    target_cpm: {};
};
export declare const CampaignAudienceView: {
    resource_name: string;
};
export declare const CampaignBidModifier: {
    resource_name: string;
    campaign: string;
    criterion_id: string;
    bid_modifier: string;
    interaction_type: {
        type: string;
    };
};
export declare const CampaignBudget: {
    resource_name: string;
    id: string;
    name: string;
    amount_micros: string;
    total_amount_micros: string;
    status: string;
    delivery_method: string;
    explicitly_shared: string;
    reference_count: string;
    has_recommended_budget: string;
    recommended_budget_amount_micros: string;
    period: string;
    recommended_budget_estimated_change_weekly_clicks: string;
    recommended_budget_estimated_change_weekly_cost_micros: string;
    recommended_budget_estimated_change_weekly_interactions: string;
    recommended_budget_estimated_change_weekly_views: string;
    type: string;
};
export declare const CampaignCriterion: {
    resource_name: string;
    campaign: string;
    criterion_id: string;
    bid_modifier: string;
    negative: string;
    type: string;
    status: string;
    keyword: {
        text: string;
        match_type: string;
    };
    placement: {
        url: string;
    };
    mobile_app_category: {
        mobile_app_category_constant: string;
    };
    mobile_application: {
        app_id: string;
        name: string;
    };
    location: {
        geo_target_constant: string;
    };
    device: {
        type: string;
    };
    ad_schedule: {
        start_minute: string;
        end_minute: string;
        start_hour: string;
        end_hour: string;
        day_of_week: string;
    };
    age_range: {
        type: string;
    };
    gender: {
        type: string;
    };
    income_range: {
        type: string;
    };
    parental_status: {
        type: string;
    };
    user_list: {
        user_list: string;
    };
    youtube_video: {
        video_id: string;
    };
    youtube_channel: {
        channel_id: string;
    };
    proximity: {
        geo_point: {
            longitude_in_micro_degrees: string;
            latitude_in_micro_degrees: string;
        };
        radius: string;
        radius_units: string;
        address: {
            postal_code: string;
            province_code: string;
            country_code: string;
            province_name: string;
            street_address: string;
            street_address2: string;
            city_name: string;
        };
    };
    topic: {
        topic_constant: string;
        path: string;
    };
    listing_scope: {
        dimensions: {
            hotel_id: {
                value: string;
            };
            hotel_class: {
                value: string;
            };
            hotel_country_region: {
                country_region_criterion: string;
            };
            hotel_state: {
                state_criterion: string;
            };
            hotel_city: {
                city_criterion: string;
            };
            product_bidding_category: {
                id: string;
                country_code: string;
                level: string;
            };
            product_brand: {
                value: string;
            };
            product_channel: {
                channel: string;
            };
            product_channel_exclusivity: {
                channel_exclusivity: string;
            };
            product_condition: {
                condition: string;
            };
            product_custom_attribute: {
                value: string;
                index: string;
            };
            product_item_id: {
                value: string;
            };
            product_type: {
                value: string;
                level: string;
            };
            unknown_listing_dimension: {};
        };
    };
    language: {
        language_constant: string;
    };
    ip_block: {
        ip_address: string;
    };
    content_label: {
        type: string;
    };
    carrier: {
        carrier_constant: string;
    };
    user_interest: {
        user_interest_category: string;
    };
    webpage: {
        criterion_name: string;
        conditions: {
            operand: string;
            operator: string;
            argument: string;
        };
    };
    operating_system_version: {
        operating_system_version_constant: string;
    };
    mobile_device: {
        mobile_device_constant: string;
    };
    location_group: {
        feed: string;
        geo_target_constants: string;
        radius: string;
        radius_units: string;
    };
    custom_affinity: {
        custom_affinity: string;
    };
};
export declare const CampaignCriterionSimulation: {
    resource_name: string;
    campaign_id: string;
    criterion_id: string;
    type: string;
    modification_method: string;
    start_date: string;
    end_date: string;
    bid_modifier_point_list: {
        points: {
            bid_modifier: string;
            biddable_conversions: string;
            biddable_conversions_value: string;
            clicks: string;
            cost_micros: string;
            impressions: string;
            top_slot_impressions: string;
            parent_biddable_conversions: string;
            parent_biddable_conversions_value: string;
            parent_clicks: string;
            parent_cost_micros: string;
            parent_impressions: string;
            parent_top_slot_impressions: string;
            parent_required_budget_micros: string;
        };
    };
};
export declare const CampaignDraft: {
    resource_name: string;
    draft_id: string;
    base_campaign: string;
    name: string;
    draft_campaign: string;
    status: string;
    has_experiment_running: string;
    long_running_operation: string;
};
export declare const CampaignExperiment: {
    resource_name: string;
    id: string;
    campaign_draft: string;
    name: string;
    description: string;
    traffic_split_percent: string;
    traffic_split_type: string;
    experiment_campaign: string;
    status: string;
    long_running_operation: string;
    start_date: string;
    end_date: string;
};
export declare const CampaignExtensionSetting: {
    resource_name: string;
    extension_type: string;
    campaign: string;
    extension_feed_items: string;
    device: string;
};
export declare const CampaignFeed: {
    resource_name: string;
    feed: string;
    campaign: string;
    placeholder_types: string;
    matching_function: {
        function_string: string;
        operator: string;
        left_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
        right_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
    };
    status: string;
};
export declare const CampaignLabel: {
    resource_name: string;
    campaign: string;
    label: string;
};
export declare const CampaignSharedSet: {
    resource_name: string;
    campaign: string;
    shared_set: string;
    status: string;
};
export declare const CarrierConstant: {
    resource_name: string;
    id: string;
    name: string;
    country_code: string;
};
export declare const ChangeStatus: {
    resource_name: string;
    last_change_date_time: string;
    resource_type: string;
    campaign: string;
    ad_group: string;
    resource_status: string;
    ad_group_ad: string;
    ad_group_criterion: string;
    campaign_criterion: string;
    feed: string;
    feed_item: string;
    ad_group_feed: string;
    campaign_feed: string;
    ad_group_bid_modifier: string;
};
export declare const ClickView: {
    resource_name: string;
    gclid: string;
    area_of_interest: {
        city: string;
        country: string;
        metro: string;
        most_specific: string;
        region: string;
    };
    location_of_presence: {
        city: string;
        country: string;
        metro: string;
        most_specific: string;
        region: string;
    };
    page_number: string;
    ad_group_ad: string;
};
export declare const ValueSettings: {
    default_value: string;
    default_currency_code: string;
    always_use_default_value: string;
};
export declare const AttributionModelSettings: {
    attribution_model: string;
    data_driven_model_status: string;
};
export declare const AttributionModelSettings: {
    attribution_model: string;
    data_driven_model_status: string;
};
export declare const ValueSettings: {
    default_value: string;
    default_currency_code: string;
    always_use_default_value: string;
};
export declare const ConversionAction: {
    resource_name: string;
    id: string;
    name: string;
    status: string;
    type: string;
    category: string;
    owner_customer: string;
    include_in_conversions_metric: string;
    click_through_lookback_window_days: string;
    view_through_lookback_window_days: string;
    value_settings: {
        default_value: string;
        default_currency_code: string;
        always_use_default_value: string;
    };
    counting_type: string;
    attribution_model_settings: {
        attribution_model: string;
        data_driven_model_status: string;
    };
    tag_snippets: {
        type: string;
        page_format: string;
        global_site_tag: string;
        event_snippet: string;
    };
    phone_call_duration_seconds: string;
    app_id: string;
};
export declare const CurrencyConstant: {
    resource_name: string;
    code: string;
    name: string;
    symbol: string;
    billable_unit_micros: string;
};
export declare const CustomInterestMember: {
    member_type: string;
    parameter: string;
};
export declare const CustomInterest: {
    resource_name: string;
    id: string;
    status: string;
    name: string;
    type: string;
    description: string;
    members: {
        member_type: string;
        parameter: string;
    };
};
export declare const CallReportingSetting: {
    call_reporting_enabled: string;
    call_conversion_reporting_enabled: string;
    call_conversion_action: string;
};
export declare const ConversionTrackingSetting: {
    conversion_tracking_id: string;
    cross_account_conversion_tracking_id: string;
};
export declare const RemarketingSetting: {
    google_global_site_tag: string;
};
export declare const Customer: {
    resource_name: string;
    id: string;
    descriptive_name: string;
    currency_code: string;
    time_zone: string;
    tracking_url_template: string;
    final_url_suffix: string;
    auto_tagging_enabled: string;
    has_partners_badge: string;
    manager: string;
    test_account: string;
    call_reporting_setting: {
        call_reporting_enabled: string;
        call_conversion_reporting_enabled: string;
        call_conversion_action: string;
    };
    conversion_tracking_setting: {
        conversion_tracking_id: string;
        cross_account_conversion_tracking_id: string;
    };
    remarketing_setting: {
        google_global_site_tag: string;
    };
    pay_per_conversion_eligibility_failure_reasons: string;
};
export declare const CustomerClient: {
    resource_name: string;
    client_customer: string;
    hidden: string;
    level: string;
    time_zone: string;
    test_account: string;
    manager: string;
    descriptive_name: string;
    currency_code: string;
    id: string;
};
export declare const CustomerClientLink: {
    resource_name: string;
    client_customer: string;
    manager_link_id: string;
    status: string;
    hidden: string;
};
export declare const CustomerExtensionSetting: {
    resource_name: string;
    extension_type: string;
    extension_feed_items: string;
    device: string;
};
export declare const CustomerFeed: {
    resource_name: string;
    feed: string;
    placeholder_types: string;
    matching_function: {
        function_string: string;
        operator: string;
        left_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
        right_operands: {
            constant_operand: {
                string_value: string;
                long_value: string;
                boolean_value: string;
                double_value: string;
            };
            feed_attribute_operand: {
                feed_id: string;
                feed_attribute_id: string;
            };
            function_operand: null;
            request_context_operand: {
                context_type: string;
            };
        };
    };
    status: string;
};
export declare const CustomerLabel: {
    resource_name: string;
    customer: string;
    label: string;
};
export declare const CustomerManagerLink: {
    resource_name: string;
    manager_customer: string;
    manager_link_id: string;
    status: string;
};
export declare const CustomerNegativeCriterion: {
    resource_name: string;
    id: string;
    type: string;
    content_label: {
        type: string;
    };
    mobile_application: {
        app_id: string;
        name: string;
    };
    mobile_app_category: {
        mobile_app_category_constant: string;
    };
    placement: {
        url: string;
    };
    youtube_video: {
        video_id: string;
    };
    youtube_channel: {
        channel_id: string;
    };
};
export declare const DetailPlacementView: {
    resource_name: string;
    placement: string;
    display_name: string;
    group_placement_target_url: string;
    target_url: string;
    placement_type: string;
};
export declare const DisplayKeywordView: {
    resource_name: string;
};
export declare const DistanceView: {
    resource_name: string;
    distance_bucket: string;
    metric_system: string;
};
export declare const DomainCategory: {
    resource_name: string;
    campaign: string;
    category: string;
    language_code: string;
    domain: string;
    coverage_fraction: string;
    category_rank: string;
    has_children: string;
    recommended_cpc_bid_micros: string;
};
export declare const DynamicSearchAdsSearchTermView: {
    resource_name: string;
    search_term: string;
    headline: string;
    landing_page: string;
    page_url: string;
    has_negative_keyword: string;
    has_matching_keyword: string;
    has_negative_url: string;
};
export declare const ExpandedLandingPageView: {
    resource_name: string;
    expanded_final_url: string;
};
export declare const ExtensionFeedItem: {
    resource_name: string;
    id: string;
    extension_type: string;
    start_date_time: string;
    end_date_time: string;
    ad_schedules: {
        start_minute: string;
        end_minute: string;
        start_hour: string;
        end_hour: string;
        day_of_week: string;
    };
    device: string;
    targeted_geo_target_constant: string;
    targeted_keyword: {
        text: string;
        match_type: string;
    };
    status: string;
    sitelink_feed_item: {
        link_text: string;
        line1: string;
        line2: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
    structured_snippet_feed_item: {
        header: string;
        values: string;
    };
    app_feed_item: {
        link_text: string;
        app_id: string;
        app_store: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
    call_feed_item: {
        phone_number: string;
        country_code: string;
        call_tracking_enabled: string;
        call_conversion_action: string;
        call_conversion_tracking_disabled: string;
        call_conversion_reporting_state: string;
    };
    callout_feed_item: {
        callout_text: string;
    };
    text_message_feed_item: {
        business_name: string;
        country_code: string;
        phone_number: string;
        text: string;
        extension_text: string;
    };
    price_feed_item: {
        type: string;
        price_qualifier: string;
        tracking_url_template: string;
        language_code: string;
        price_offerings: {
            header: string;
            description: string;
            price: {
                currency_code: string;
                amount_micros: string;
            };
            unit: string;
            final_urls: string;
            final_mobile_urls: string;
        };
        final_url_suffix: string;
    };
    promotion_feed_item: {
        promotion_target: string;
        discount_modifier: string;
        promotion_start_date: string;
        promotion_end_date: string;
        occasion: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
        language_code: string;
        percent_off: string;
        money_amount_off: {
            currency_code: string;
            amount_micros: string;
        };
        promotion_code: string;
        orders_over_amount: {
            currency_code: string;
            amount_micros: string;
        };
    };
    location_feed_item: {
        business_name: string;
        address_line1: string;
        address_line2: string;
        city: string;
        province: string;
        postal_code: string;
        country_code: string;
        phone_number: string;
    };
    affiliate_location_feed_item: {
        business_name: string;
        address_line1: string;
        address_line2: string;
        city: string;
        province: string;
        postal_code: string;
        country_code: string;
        phone_number: string;
        chain_id: string;
        chain_name: string;
    };
    hotel_callout_feed_item: {
        text: string;
        language_code: string;
    };
    targeted_campaign: string;
    targeted_ad_group: string;
};
export declare const FeedAttribute: {
    id: string;
    name: string;
    type: string;
    is_part_of_key: string;
};
export declare const Operator: {};
export declare const Operator: {};
export declare const FeedAttributeOperation: {
    operator: {};
    value: {
        id: string;
        name: string;
        type: string;
        is_part_of_key: string;
    };
};
export declare const OAuthInfo: {
    http_method: string;
    http_request_url: string;
    http_authorization_header: string;
};
export declare const OAuthInfo: {
    http_method: string;
    http_request_url: string;
    http_authorization_header: string;
};
export declare const PlacesLocationFeedData: {
    oauth_info: {
        http_method: string;
        http_request_url: string;
        http_authorization_header: string;
    };
    email_address: string;
    business_account_id: string;
    business_name_filter: string;
    category_filters: string;
    label_filters: string;
};
export declare const AffiliateLocationFeedData: {
    chain_ids: string;
    relationship_type: string;
};
export declare const OAuthInfo: {
    http_method: string;
    http_request_url: string;
    http_authorization_header: string;
};
export declare const PlacesLocationFeedData: {
    oauth_info: {
        http_method: string;
        http_request_url: string;
        http_authorization_header: string;
    };
    email_address: string;
    business_account_id: string;
    business_name_filter: string;
    category_filters: string;
    label_filters: string;
};
export declare const AffiliateLocationFeedData: {
    chain_ids: string;
    relationship_type: string;
};
export declare const Feed: {
    resource_name: string;
    id: string;
    name: string;
    attributes: {
        id: string;
        name: string;
        type: string;
        is_part_of_key: string;
    };
    attribute_operations: {
        operator: {};
        value: {
            id: string;
            name: string;
            type: string;
            is_part_of_key: string;
        };
    };
    origin: string;
    status: string;
    places_location_feed_data: {
        oauth_info: {
            http_method: string;
            http_request_url: string;
            http_authorization_header: string;
        };
        email_address: string;
        business_account_id: string;
        business_name_filter: string;
        category_filters: string;
        label_filters: string;
    };
    affiliate_location_feed_data: {
        chain_ids: string;
        relationship_type: string;
    };
};
export declare const FeedItemAttributeValue: {
    feed_attribute_id: string;
    integer_value: string;
    boolean_value: string;
    string_value: string;
    double_value: string;
    price_value: {
        currency_code: string;
        amount_micros: string;
    };
    integer_values: string;
    boolean_values: string;
    string_values: string;
    double_values: string;
};
export declare const FeedItemValidationError: {};
export declare const FeedItemPlaceholderPolicyInfo: {
    placeholder_type_enum: string;
    feed_mapping_resource_name: string;
    review_status: string;
    approval_status: string;
    policy_topic_entries: {
        topic: string;
        type: string;
        evidences: {
            website_list: {
                websites: string;
            };
            text_list: {
                texts: string;
            };
            language_code: string;
            destination_text_list: {
                destination_texts: string;
            };
            destination_mismatch: {
                url_types: string;
            };
            destination_not_working: {
                expanded_url: string;
                device: string;
                last_checked_date_time: string;
                dns_error_type: string;
                http_error_code: string;
            };
        };
        constraints: {
            country_constraint_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            reseller_constraint: {};
            certificate_missing_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
            certificate_domain_mismatch_in_country_list: {
                total_targeted_countries: string;
                countries: {
                    country_criterion: string;
                };
            };
        };
    };
    validation_status: string;
    validation_errors: {};
    quality_approval_status: string;
    quality_disapproval_reasons: string;
};
export declare const FeedItem: {
    resource_name: string;
    feed: string;
    id: string;
    start_date_time: string;
    end_date_time: string;
    attribute_values: {
        feed_attribute_id: string;
        integer_value: string;
        boolean_value: string;
        string_value: string;
        double_value: string;
        price_value: {
            currency_code: string;
            amount_micros: string;
        };
        integer_values: string;
        boolean_values: string;
        string_values: string;
        double_values: string;
    };
    geo_targeting_restriction: string;
    url_custom_parameters: {
        key: string;
        value: string;
    };
    status: string;
    policy_infos: {
        placeholder_type_enum: string;
        feed_mapping_resource_name: string;
        review_status: string;
        approval_status: string;
        policy_topic_entries: {
            topic: string;
            type: string;
            evidences: {
                website_list: {
                    websites: string;
                };
                text_list: {
                    texts: string;
                };
                language_code: string;
                destination_text_list: {
                    destination_texts: string;
                };
                destination_mismatch: {
                    url_types: string;
                };
                destination_not_working: {
                    expanded_url: string;
                    device: string;
                    last_checked_date_time: string;
                    dns_error_type: string;
                    http_error_code: string;
                };
            };
            constraints: {
                country_constraint_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                reseller_constraint: {};
                certificate_missing_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
                certificate_domain_mismatch_in_country_list: {
                    total_targeted_countries: string;
                    countries: {
                        country_criterion: string;
                    };
                };
            };
        };
        validation_status: string;
        validation_errors: {};
        quality_approval_status: string;
        quality_disapproval_reasons: string;
    };
};
export declare const FeedItemTarget: {
    resource_name: string;
    feed_item: string;
    feed_item_target_type: string;
    feed_item_target_id: string;
    status: string;
    campaign: string;
    ad_group: string;
    keyword: {
        text: string;
        match_type: string;
    };
    geo_target_constant: string;
    device: string;
    ad_schedule: {
        start_minute: string;
        end_minute: string;
        start_hour: string;
        end_hour: string;
        day_of_week: string;
    };
};
export declare const AttributeFieldMapping: {
    feed_attribute_id: string;
    field_id: string;
    sitelink_field: string;
    call_field: string;
    app_field: string;
    location_field: string;
    affiliate_location_field: string;
    callout_field: string;
    structured_snippet_field: string;
    message_field: string;
    price_field: string;
    promotion_field: string;
    ad_customizer_field: string;
    dsa_page_feed_field: string;
    location_extension_targeting_field: string;
    education_field: string;
    flight_field: string;
    custom_field: string;
    hotel_field: string;
    real_estate_field: string;
    travel_field: string;
    local_field: string;
    job_field: string;
};
export declare const FeedMapping: {
    resource_name: string;
    feed: string;
    attribute_field_mappings: {
        feed_attribute_id: string;
        field_id: string;
        sitelink_field: string;
        call_field: string;
        app_field: string;
        location_field: string;
        affiliate_location_field: string;
        callout_field: string;
        structured_snippet_field: string;
        message_field: string;
        price_field: string;
        promotion_field: string;
        ad_customizer_field: string;
        dsa_page_feed_field: string;
        location_extension_targeting_field: string;
        education_field: string;
        flight_field: string;
        custom_field: string;
        hotel_field: string;
        real_estate_field: string;
        travel_field: string;
        local_field: string;
        job_field: string;
    };
    status: string;
    placeholder_type: string;
    criterion_type: string;
};
export declare const FeedPlaceholderView: {
    resource_name: string;
    placeholder_type: string;
};
export declare const GenderView: {
    resource_name: string;
};
export declare const GeoTargetConstant: {
    resource_name: string;
    id: string;
    name: string;
    country_code: string;
    target_type: string;
    status: string;
    canonical_name: string;
};
export declare const GeographicView: {
    resource_name: string;
    location_type: string;
    country_criterion_id: string;
};
export declare const GoogleAdsField: {
    resource_name: string;
    name: string;
    category: string;
    selectable: string;
    filterable: string;
    sortable: string;
    selectable_with: string;
    attribute_resources: string;
    metrics: string;
    segments: string;
    enum_values: string;
    data_type: string;
    type_url: string;
    is_repeated: string;
};
export declare const GroupPlacementView: {
    resource_name: string;
    placement: string;
    display_name: string;
    target_url: string;
    placement_type: string;
};
export declare const HotelGroupView: {
    resource_name: string;
};
export declare const HotelPerformanceView: {
    resource_name: string;
};
export declare const AccountBudgetSummary: {
    customer: string;
    customer_descriptive_name: string;
    account_budget: string;
    account_budget_name: string;
    purchase_order_number: string;
    subtotal_amount_micros: string;
    tax_amount_micros: string;
    total_amount_micros: string;
    billable_activity_date_range: {
        start_date: string;
        end_date: string;
    };
};
export declare const AccountBudgetSummary: {
    customer: string;
    customer_descriptive_name: string;
    account_budget: string;
    account_budget_name: string;
    purchase_order_number: string;
    subtotal_amount_micros: string;
    tax_amount_micros: string;
    total_amount_micros: string;
    billable_activity_date_range: {
        start_date: string;
        end_date: string;
    };
};
export declare const Invoice: {
    resource_name: string;
    id: string;
    type: string;
    billing_setup: string;
    payments_account_id: string;
    payments_profile_id: string;
    issue_date: string;
    due_date: string;
    service_date_range: {
        start_date: string;
        end_date: string;
    };
    currency_code: string;
    invoice_level_adjustments_micros: string;
    subtotal_amount_micros: string;
    tax_amount_micros: string;
    total_amount_micros: string;
    corrected_invoice: string;
    replaced_invoices: string;
    pdf_url: string;
    account_budget_summaries: {
        customer: string;
        customer_descriptive_name: string;
        account_budget: string;
        account_budget_name: string;
        purchase_order_number: string;
        subtotal_amount_micros: string;
        tax_amount_micros: string;
        total_amount_micros: string;
        billable_activity_date_range: {
            start_date: string;
            end_date: string;
        };
    };
};
export declare const KeywordPlanForecastPeriod: {
    date_interval: string;
    date_range: {
        start_date: string;
        end_date: string;
    };
};
export declare const KeywordPlan: {
    resource_name: string;
    id: string;
    name: string;
    forecast_period: {
        date_interval: string;
        date_range: {
            start_date: string;
            end_date: string;
        };
    };
};
export declare const KeywordPlanAdGroup: {
    resource_name: string;
    keyword_plan_campaign: string;
    id: string;
    name: string;
    cpc_bid_micros: string;
};
export declare const KeywordPlanGeoTarget: {
    geo_target_constant: string;
};
export declare const KeywordPlanCampaign: {
    resource_name: string;
    keyword_plan: string;
    id: string;
    name: string;
    language_constants: string;
    keyword_plan_network: string;
    cpc_bid_micros: string;
    geo_targets: {
        geo_target_constant: string;
    };
};
export declare const KeywordPlanKeyword: {
    resource_name: string;
    keyword_plan_ad_group: string;
    id: string;
    text: string;
    match_type: string;
    cpc_bid_micros: string;
};
export declare const KeywordPlanNegativeKeyword: {
    resource_name: string;
    keyword_plan_campaign: string;
    id: string;
    text: string;
    match_type: string;
};
export declare const KeywordView: {
    resource_name: string;
};
export declare const Label: {};
export declare const LandingPageView: {
    resource_name: string;
    unexpanded_final_url: string;
};
export declare const LanguageConstant: {
    resource_name: string;
    id: string;
    code: string;
    name: string;
    targetable: string;
};
export declare const LocationView: {
    resource_name: string;
};
export declare const ManagedPlacementView: {
    resource_name: string;
};
export declare const MediaImage: {
    data: string;
};
export declare const MediaBundle: {
    data: string;
};
export declare const MediaAudio: {
    ad_duration_millis: string;
};
export declare const MediaVideo: {
    ad_duration_millis: string;
    youtube_video_id: string;
    advertising_id_code: string;
    isci_code: string;
};
export declare const MediaFile: {
    resource_name: string;
    id: string;
    type: string;
    mime_type: string;
    source_url: string;
    name: string;
    file_size: string;
    image: {
        data: string;
    };
    media_bundle: {
        data: string;
    };
    audio: {
        ad_duration_millis: string;
    };
    video: {
        ad_duration_millis: string;
        youtube_video_id: string;
        advertising_id_code: string;
        isci_code: string;
    };
};
export declare const MerchantCenterLink: {
    resource_name: string;
    id: string;
    merchant_center_account_name: string;
    status: string;
};
export declare const MobileAppCategoryConstant: {
    resource_name: string;
    id: string;
    name: string;
};
export declare const MobileDeviceConstant: {
    resource_name: string;
    id: string;
    name: string;
    manufacturer_name: string;
    operating_system_name: string;
    type: string;
};
export declare const MutateJobMetadata: {
    creation_date_time: string;
    completion_date_time: string;
    estimated_completion_ratio: string;
    operation_count: string;
    executed_operation_count: string;
};
export declare const MutateJobMetadata: {
    creation_date_time: string;
    completion_date_time: string;
    estimated_completion_ratio: string;
    operation_count: string;
    executed_operation_count: string;
};
export declare const MutateJob: {
    resource_name: string;
    id: string;
    next_add_sequence_token: string;
    metadata: {
        creation_date_time: string;
        completion_date_time: string;
        estimated_completion_ratio: string;
        operation_count: string;
        executed_operation_count: string;
    };
    status: string;
    long_running_operation: string;
};
export declare const OperatingSystemVersionConstant: {
    resource_name: string;
    id: string;
    name: string;
    os_major_version: string;
    os_minor_version: string;
    operator_type: string;
};
export declare const PaidOrganicSearchTermView: {
    resource_name: string;
    search_term: string;
};
export declare const ParentalStatusView: {
    resource_name: string;
};
export declare const PaymentsAccount: {
    resource_name: string;
    payments_account_id: string;
    name: string;
    currency_code: string;
    payments_profile_id: string;
    secondary_payments_profile_id: string;
};
export declare const ProductBiddingCategoryConstant: {
    resource_name: string;
    id: string;
    country_code: string;
    product_bidding_category_constant_parent: string;
    level: string;
    status: string;
    language_code: string;
    localized_name: string;
};
export declare const ProductGroupView: {
    resource_name: string;
};
export declare const RecommendationMetrics: {
    impressions: string;
    clicks: string;
    cost_micros: string;
    conversions: string;
    video_views: string;
};
export declare const RecommendationImpact: {
    base_metrics: {
        impressions: string;
        clicks: string;
        cost_micros: string;
        conversions: string;
        video_views: string;
    };
    potential_metrics: {
        impressions: string;
        clicks: string;
        cost_micros: string;
        conversions: string;
        video_views: string;
    };
};
export declare const CampaignBudgetRecommendationOption: {
    budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const CampaignBudgetRecommendationOption: {
    budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const CampaignBudgetRecommendation: {
    current_budget_amount_micros: string;
    recommended_budget_amount_micros: string;
    budget_options: {
        budget_amount_micros: string;
        impact: {
            base_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
            potential_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
        };
    };
};
export declare const KeywordRecommendation: {
    keyword: {
        text: string;
        match_type: string;
    };
    recommended_cpc_bid_micros: string;
};
export declare const TextAdRecommendation: {
    ad: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
    creation_date: string;
    auto_apply_date: string;
};
export declare const TargetCpaOptInRecommendationOption: {
    goal: string;
    target_cpa_micros: string;
    required_campaign_budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const TargetCpaOptInRecommendationOption: {
    goal: string;
    target_cpa_micros: string;
    required_campaign_budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const TargetCpaOptInRecommendation: {
    options: {
        goal: string;
        target_cpa_micros: string;
        required_campaign_budget_amount_micros: string;
        impact: {
            base_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
            potential_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
        };
    };
    recommended_target_cpa_micros: string;
};
export declare const MaximizeConversionsOptInRecommendation: {
    recommended_budget_amount_micros: string;
};
export declare const EnhancedCpcOptInRecommendation: {};
export declare const SearchPartnersOptInRecommendation: {};
export declare const MaximizeClicksOptInRecommendation: {
    recommended_budget_amount_micros: string;
};
export declare const OptimizeAdRotationRecommendation: {};
export declare const CalloutExtensionRecommendation: {
    recommended_extensions: {
        callout_text: string;
    };
};
export declare const SitelinkExtensionRecommendation: {
    recommended_extensions: {
        link_text: string;
        line1: string;
        line2: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
};
export declare const CallExtensionRecommendation: {
    recommended_extensions: {
        phone_number: string;
        country_code: string;
        call_tracking_enabled: string;
        call_conversion_action: string;
        call_conversion_tracking_disabled: string;
        call_conversion_reporting_state: string;
    };
};
export declare const KeywordMatchTypeRecommendation: {
    keyword: {
        text: string;
        match_type: string;
    };
    recommended_match_type: string;
};
export declare const MoveUnusedBudgetRecommendation: {
    excess_campaign_budget: string;
    budget_recommendation: {
        current_budget_amount_micros: string;
        recommended_budget_amount_micros: string;
        budget_options: {
            budget_amount_micros: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
        };
    };
};
export declare const RecommendationImpact: {
    base_metrics: {
        impressions: string;
        clicks: string;
        cost_micros: string;
        conversions: string;
        video_views: string;
    };
    potential_metrics: {
        impressions: string;
        clicks: string;
        cost_micros: string;
        conversions: string;
        video_views: string;
    };
};
export declare const RecommendationMetrics: {
    impressions: string;
    clicks: string;
    cost_micros: string;
    conversions: string;
    video_views: string;
};
export declare const CampaignBudgetRecommendationOption: {
    budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const CampaignBudgetRecommendation: {
    current_budget_amount_micros: string;
    recommended_budget_amount_micros: string;
    budget_options: {
        budget_amount_micros: string;
        impact: {
            base_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
            potential_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
        };
    };
};
export declare const KeywordRecommendation: {
    keyword: {
        text: string;
        match_type: string;
    };
    recommended_cpc_bid_micros: string;
};
export declare const MaximizeClicksOptInRecommendation: {
    recommended_budget_amount_micros: string;
};
export declare const TextAdRecommendation: {
    ad: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
    creation_date: string;
    auto_apply_date: string;
};
export declare const MoveUnusedBudgetRecommendation: {
    excess_campaign_budget: string;
    budget_recommendation: {
        current_budget_amount_micros: string;
        recommended_budget_amount_micros: string;
        budget_options: {
            budget_amount_micros: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
        };
    };
};
export declare const TargetCpaOptInRecommendationOption: {
    goal: string;
    target_cpa_micros: string;
    required_campaign_budget_amount_micros: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
};
export declare const TargetCpaOptInRecommendation: {
    options: {
        goal: string;
        target_cpa_micros: string;
        required_campaign_budget_amount_micros: string;
        impact: {
            base_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
            potential_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
        };
    };
    recommended_target_cpa_micros: string;
};
export declare const CalloutExtensionRecommendation: {
    recommended_extensions: {
        callout_text: string;
    };
};
export declare const MaximizeConversionsOptInRecommendation: {
    recommended_budget_amount_micros: string;
};
export declare const EnhancedCpcOptInRecommendation: {};
export declare const KeywordMatchTypeRecommendation: {
    keyword: {
        text: string;
        match_type: string;
    };
    recommended_match_type: string;
};
export declare const SearchPartnersOptInRecommendation: {};
export declare const OptimizeAdRotationRecommendation: {};
export declare const SitelinkExtensionRecommendation: {
    recommended_extensions: {
        link_text: string;
        line1: string;
        line2: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
};
export declare const CallExtensionRecommendation: {
    recommended_extensions: {
        phone_number: string;
        country_code: string;
        call_tracking_enabled: string;
        call_conversion_action: string;
        call_conversion_tracking_disabled: string;
        call_conversion_reporting_state: string;
    };
};
export declare const Recommendation: {
    resource_name: string;
    type: string;
    impact: {
        base_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
        potential_metrics: {
            impressions: string;
            clicks: string;
            cost_micros: string;
            conversions: string;
            video_views: string;
        };
    };
    campaign_budget: string;
    campaign: string;
    ad_group: string;
    dismissed: string;
    campaign_budget_recommendation: {
        current_budget_amount_micros: string;
        recommended_budget_amount_micros: string;
        budget_options: {
            budget_amount_micros: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
        };
    };
    keyword_recommendation: {
        keyword: {
            text: string;
            match_type: string;
        };
        recommended_cpc_bid_micros: string;
    };
    text_ad_recommendation: {
        ad: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
        creation_date: string;
        auto_apply_date: string;
    };
    target_cpa_opt_in_recommendation: {
        options: {
            goal: string;
            target_cpa_micros: string;
            required_campaign_budget_amount_micros: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
        };
        recommended_target_cpa_micros: string;
    };
    maximize_conversions_opt_in_recommendation: {
        recommended_budget_amount_micros: string;
    };
    enhanced_cpc_opt_in_recommendation: {};
    search_partners_opt_in_recommendation: {};
    maximize_clicks_opt_in_recommendation: {
        recommended_budget_amount_micros: string;
    };
    optimize_ad_rotation_recommendation: {};
    callout_extension_recommendation: {
        recommended_extensions: {
            callout_text: string;
        };
    };
    sitelink_extension_recommendation: {
        recommended_extensions: {
            link_text: string;
            line1: string;
            line2: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
    };
    call_extension_recommendation: {
        recommended_extensions: {
            phone_number: string;
            country_code: string;
            call_tracking_enabled: string;
            call_conversion_action: string;
            call_conversion_tracking_disabled: string;
            call_conversion_reporting_state: string;
        };
    };
    keyword_match_type_recommendation: {
        keyword: {
            text: string;
            match_type: string;
        };
        recommended_match_type: string;
    };
    move_unused_budget_recommendation: {
        excess_campaign_budget: string;
        budget_recommendation: {
            current_budget_amount_micros: string;
            recommended_budget_amount_micros: string;
            budget_options: {
                budget_amount_micros: string;
                impact: {
                    base_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                    potential_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                };
            };
        };
    };
};
export declare const RemarketingAction: {
    resource_name: string;
    id: string;
    name: string;
    tag_snippets: {
        type: string;
        page_format: string;
        global_site_tag: string;
        event_snippet: string;
    };
};
export declare const SearchTermView: {
    resource_name: string;
    search_term: string;
    ad_group: string;
    status: string;
};
export declare const SharedCriterion: {
    resource_name: string;
    shared_set: string;
    criterion_id: string;
    type: string;
    keyword: {
        text: string;
        match_type: string;
    };
    youtube_video: {
        video_id: string;
    };
    youtube_channel: {
        channel_id: string;
    };
    placement: {
        url: string;
    };
    mobile_app_category: {
        mobile_app_category_constant: string;
    };
    mobile_application: {
        app_id: string;
        name: string;
    };
};
export declare const SharedSet: {
    resource_name: string;
    id: string;
    type: string;
    name: string;
    status: string;
    member_count: string;
    reference_count: string;
};
export declare const ShoppingPerformanceView: {
    resource_name: string;
};
export declare const TopicConstant: {
    resource_name: string;
    id: string;
    topic_constant_parent: string;
    path: string;
};
export declare const TopicView: {
    resource_name: string;
};
export declare const UserInterest: {
    resource_name: string;
    taxonomy_type: string;
    user_interest_id: string;
    name: string;
    user_interest_parent: string;
    launched_to_all: string;
    availabilities: {
        channel: {
            availability_mode: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            include_default_channel_sub_type: string;
        };
        locale: {
            availability_mode: string;
            country_code: string;
            language_code: string;
        };
    };
};
export declare const UserList: {
    resource_name: string;
    id: string;
    read_only: string;
    name: string;
    description: string;
    membership_status: string;
    integration_code: string;
    membership_life_span: string;
    size_for_display: string;
    size_range_for_display: string;
    size_for_search: string;
    size_range_for_search: string;
    type: string;
    closing_reason: string;
    access_reason: string;
    account_user_list_status: string;
    eligible_for_search: string;
    eligible_for_display: string;
    crm_based_user_list: {
        app_id: string;
        upload_key_type: string;
        data_source_type: string;
    };
    similar_user_list: {
        seed_user_list: string;
    };
    rule_based_user_list: {
        prepopulation_status: string;
        combined_rule_user_list: {
            left_operand: {
                rule_type: string;
                rule_item_groups: {
                    rule_items: {
                        name: string;
                        number_rule_item: {
                            operator: string;
                            value: string;
                        };
                        string_rule_item: {
                            operator: string;
                            value: string;
                        };
                        date_rule_item: {
                            operator: string;
                            value: string;
                            offset_in_days: string;
                        };
                    };
                };
            };
            right_operand: {
                rule_type: string;
                rule_item_groups: {
                    rule_items: {
                        name: string;
                        number_rule_item: {
                            operator: string;
                            value: string;
                        };
                        string_rule_item: {
                            operator: string;
                            value: string;
                        };
                        date_rule_item: {
                            operator: string;
                            value: string;
                            offset_in_days: string;
                        };
                    };
                };
            };
            rule_operator: string;
        };
        date_specific_rule_user_list: {
            rule: {
                rule_type: string;
                rule_item_groups: {
                    rule_items: {
                        name: string;
                        number_rule_item: {
                            operator: string;
                            value: string;
                        };
                        string_rule_item: {
                            operator: string;
                            value: string;
                        };
                        date_rule_item: {
                            operator: string;
                            value: string;
                            offset_in_days: string;
                        };
                    };
                };
            };
            start_date: string;
            end_date: string;
        };
        expression_rule_user_list: {
            rule: {
                rule_type: string;
                rule_item_groups: {
                    rule_items: {
                        name: string;
                        number_rule_item: {
                            operator: string;
                            value: string;
                        };
                        string_rule_item: {
                            operator: string;
                            value: string;
                        };
                        date_rule_item: {
                            operator: string;
                            value: string;
                            offset_in_days: string;
                        };
                    };
                };
            };
        };
    };
    logical_user_list: {
        rules: {
            operator: string;
            rule_operands: {
                user_list: string;
            };
        };
    };
    basic_user_list: {
        actions: {
            conversion_action: string;
            remarketing_action: string;
        };
    };
};
export declare const UserLocationView: {
    resource_name: string;
    country_criterion_id: string;
    targeting_location: string;
};
export declare const Video: {
    resource_name: string;
    id: string;
    channel_id: string;
    duration_millis: string;
    title: string;
};
export declare const AccountBudgetProposalService: {};
export declare const AccountBudgetService: {};
export declare const AdGroupAdAssetViewService: {};
export declare const AdGroupAdLabelService: {};
export declare const AdGroupAdService: {};
export declare const AdGroupAudienceViewService: {};
export declare const AdGroupBidModifierService: {};
export declare const AdGroupCriterionLabelService: {};
export declare const AdGroupCriterionService: {};
export declare const AdGroupCriterionSimulationService: {};
export declare const AdGroupExtensionSettingService: {};
export declare const AdGroupFeedService: {};
export declare const AdGroupLabelService: {};
export declare const AdGroupService: {};
export declare const AdGroupSimulationService: {};
export declare const AdParameterService: {};
export declare const AdScheduleViewService: {};
export declare const AdService: {};
export declare const AdGroupAdLabelOperation: {
    create: {
        resource_name: string;
        ad_group_ad: string;
        label: string;
    };
    remove: string;
};
export declare const AdGroupAdOperation: {
    update_mask: {
        paths: string;
    };
    policy_validation_parameter: {
        ignorable_policy_topics: string;
        exempt_policy_violation_keys: {
            policy_name: string;
            violating_text: string;
        };
    };
    create: {
        resource_name: string;
        status: string;
        ad_group: string;
        ad: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
        policy_summary: {
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            review_status: string;
            approval_status: string;
        };
        ad_strength: string;
    };
    update: {
        resource_name: string;
        status: string;
        ad_group: string;
        ad: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
        policy_summary: {
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            review_status: string;
            approval_status: string;
        };
        ad_strength: string;
    };
    remove: string;
};
export declare const AdGroupBidModifierOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        ad_group: string;
        criterion_id: string;
        bid_modifier: string;
        base_ad_group: string;
        bid_modifier_source: string;
        hotel_date_selection_type: {
            type: string;
        };
        hotel_advance_booking_window: {
            min_days: string;
            max_days: string;
        };
        hotel_length_of_stay: {
            min_nights: string;
            max_nights: string;
        };
        hotel_check_in_day: {
            day_of_week: string;
        };
        device: {
            type: string;
        };
        preferred_content: {
            type: string;
        };
    };
    update: {
        resource_name: string;
        ad_group: string;
        criterion_id: string;
        bid_modifier: string;
        base_ad_group: string;
        bid_modifier_source: string;
        hotel_date_selection_type: {
            type: string;
        };
        hotel_advance_booking_window: {
            min_days: string;
            max_days: string;
        };
        hotel_length_of_stay: {
            min_nights: string;
            max_nights: string;
        };
        hotel_check_in_day: {
            day_of_week: string;
        };
        device: {
            type: string;
        };
        preferred_content: {
            type: string;
        };
    };
    remove: string;
};
export declare const AdGroupCriterionLabelOperation: {
    create: {
        resource_name: string;
        ad_group_criterion: string;
        label: string;
    };
    remove: string;
};
export declare const AdGroupCriterionOperation: {
    update_mask: {
        paths: string;
    };
    exempt_policy_violation_keys: {
        policy_name: string;
        violating_text: string;
    };
    create: {
        resource_name: string;
        criterion_id: string;
        status: string;
        quality_info: {
            quality_score: string;
            creative_quality_score: string;
            post_click_quality_score: string;
            search_predicted_ctr: string;
        };
        ad_group: string;
        type: string;
        negative: string;
        system_serving_status: string;
        approval_status: string;
        bid_modifier: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        cpv_bid_micros: string;
        percent_cpc_bid_micros: string;
        effective_cpc_bid_micros: string;
        effective_cpm_bid_micros: string;
        effective_cpv_bid_micros: string;
        effective_percent_cpc_bid_micros: string;
        effective_cpc_bid_source: string;
        effective_cpm_bid_source: string;
        effective_cpv_bid_source: string;
        effective_percent_cpc_bid_source: string;
        position_estimates: {
            first_page_cpc_micros: string;
            first_position_cpc_micros: string;
            top_of_page_cpc_micros: string;
            estimated_add_clicks_at_first_position_cpc: string;
            estimated_add_cost_at_first_position_cpc: string;
        };
        final_urls: string;
        final_mobile_urls: string;
        final_url_suffix: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        listing_group: {
            type: string;
            case_value: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
            parent_ad_group_criterion: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        app_payment_model: {
            type: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
        custom_intent: {
            custom_intent: string;
        };
    };
    update: {
        resource_name: string;
        criterion_id: string;
        status: string;
        quality_info: {
            quality_score: string;
            creative_quality_score: string;
            post_click_quality_score: string;
            search_predicted_ctr: string;
        };
        ad_group: string;
        type: string;
        negative: string;
        system_serving_status: string;
        approval_status: string;
        bid_modifier: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        cpv_bid_micros: string;
        percent_cpc_bid_micros: string;
        effective_cpc_bid_micros: string;
        effective_cpm_bid_micros: string;
        effective_cpv_bid_micros: string;
        effective_percent_cpc_bid_micros: string;
        effective_cpc_bid_source: string;
        effective_cpm_bid_source: string;
        effective_cpv_bid_source: string;
        effective_percent_cpc_bid_source: string;
        position_estimates: {
            first_page_cpc_micros: string;
            first_position_cpc_micros: string;
            top_of_page_cpc_micros: string;
            estimated_add_clicks_at_first_position_cpc: string;
            estimated_add_cost_at_first_position_cpc: string;
        };
        final_urls: string;
        final_mobile_urls: string;
        final_url_suffix: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        listing_group: {
            type: string;
            case_value: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
            parent_ad_group_criterion: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        app_payment_model: {
            type: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
        custom_intent: {
            custom_intent: string;
        };
    };
    remove: string;
};
export declare const AdGroupExtensionSettingOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        extension_type: string;
        ad_group: string;
        extension_feed_items: string;
        device: string;
    };
    update: {
        resource_name: string;
        extension_type: string;
        ad_group: string;
        extension_feed_items: string;
        device: string;
    };
    remove: string;
};
export declare const AdGroupFeedOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        feed: string;
        ad_group: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    update: {
        resource_name: string;
        feed: string;
        ad_group: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    remove: string;
};
export declare const AdGroupLabelOperation: {
    create: {
        resource_name: string;
        ad_group: string;
        label: string;
    };
    remove: string;
};
export declare const AdGroupOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        ad_rotation_mode: string;
        base_ad_group: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        campaign: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        target_cpa_micros: string;
        cpv_bid_micros: string;
        target_cpm_micros: string;
        target_roas: string;
        percent_cpc_bid_micros: string;
        explorer_auto_optimizer_setting: {
            opt_in: string;
        };
        display_custom_bid_dimension: string;
        final_url_suffix: string;
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        effective_target_cpa_micros: string;
        effective_target_cpa_source: string;
        effective_target_roas: string;
        effective_target_roas_source: string;
        labels: string;
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        ad_rotation_mode: string;
        base_ad_group: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        campaign: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        target_cpa_micros: string;
        cpv_bid_micros: string;
        target_cpm_micros: string;
        target_roas: string;
        percent_cpc_bid_micros: string;
        explorer_auto_optimizer_setting: {
            opt_in: string;
        };
        display_custom_bid_dimension: string;
        final_url_suffix: string;
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        effective_target_cpa_micros: string;
        effective_target_cpa_source: string;
        effective_target_roas: string;
        effective_target_roas_source: string;
        labels: string;
    };
    remove: string;
};
export declare const AdParameterOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        ad_group_criterion: string;
        parameter_index: string;
        insertion_text: string;
    };
    update: {
        resource_name: string;
        ad_group_criterion: string;
        parameter_index: string;
        insertion_text: string;
    };
    remove: string;
};
export declare const AssetOperation: {
    create: {
        resource_name: string;
        id: string;
        name: string;
        type: string;
        youtube_video_asset: {
            youtube_video_id: string;
        };
        media_bundle_asset: {
            data: string;
        };
        image_asset: {
            data: string;
            file_size: string;
            mime_type: string;
            full_size: {
                height_pixels: string;
                width_pixels: string;
                url: string;
            };
        };
        text_asset: {
            text: string;
        };
    };
};
export declare const BiddingStrategyOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        campaign_count: string;
        non_removed_campaign_count: string;
        enhanced_cpc: {};
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        campaign_count: string;
        non_removed_campaign_count: string;
        enhanced_cpc: {};
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
    };
    remove: string;
};
export declare const CampaignBidModifierOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        interaction_type: {
            type: string;
        };
    };
    update: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        interaction_type: {
            type: string;
        };
    };
    remove: string;
};
export declare const CampaignBudgetOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        amount_micros: string;
        total_amount_micros: string;
        status: string;
        delivery_method: string;
        explicitly_shared: string;
        reference_count: string;
        has_recommended_budget: string;
        recommended_budget_amount_micros: string;
        period: string;
        recommended_budget_estimated_change_weekly_clicks: string;
        recommended_budget_estimated_change_weekly_cost_micros: string;
        recommended_budget_estimated_change_weekly_interactions: string;
        recommended_budget_estimated_change_weekly_views: string;
        type: string;
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        amount_micros: string;
        total_amount_micros: string;
        status: string;
        delivery_method: string;
        explicitly_shared: string;
        reference_count: string;
        has_recommended_budget: string;
        recommended_budget_amount_micros: string;
        period: string;
        recommended_budget_estimated_change_weekly_clicks: string;
        recommended_budget_estimated_change_weekly_cost_micros: string;
        recommended_budget_estimated_change_weekly_interactions: string;
        recommended_budget_estimated_change_weekly_views: string;
        type: string;
    };
    remove: string;
};
export declare const CampaignCriterionOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        negative: string;
        type: string;
        status: string;
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        location: {
            geo_target_constant: string;
        };
        device: {
            type: string;
        };
        ad_schedule: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        proximity: {
            geo_point: {
                longitude_in_micro_degrees: string;
                latitude_in_micro_degrees: string;
            };
            radius: string;
            radius_units: string;
            address: {
                postal_code: string;
                province_code: string;
                country_code: string;
                province_name: string;
                street_address: string;
                street_address2: string;
                city_name: string;
            };
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        listing_scope: {
            dimensions: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
        };
        language: {
            language_constant: string;
        };
        ip_block: {
            ip_address: string;
        };
        content_label: {
            type: string;
        };
        carrier: {
            carrier_constant: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        operating_system_version: {
            operating_system_version_constant: string;
        };
        mobile_device: {
            mobile_device_constant: string;
        };
        location_group: {
            feed: string;
            geo_target_constants: string;
            radius: string;
            radius_units: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
    };
    update: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        negative: string;
        type: string;
        status: string;
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        location: {
            geo_target_constant: string;
        };
        device: {
            type: string;
        };
        ad_schedule: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        proximity: {
            geo_point: {
                longitude_in_micro_degrees: string;
                latitude_in_micro_degrees: string;
            };
            radius: string;
            radius_units: string;
            address: {
                postal_code: string;
                province_code: string;
                country_code: string;
                province_name: string;
                street_address: string;
                street_address2: string;
                city_name: string;
            };
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        listing_scope: {
            dimensions: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
        };
        language: {
            language_constant: string;
        };
        ip_block: {
            ip_address: string;
        };
        content_label: {
            type: string;
        };
        carrier: {
            carrier_constant: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        operating_system_version: {
            operating_system_version_constant: string;
        };
        mobile_device: {
            mobile_device_constant: string;
        };
        location_group: {
            feed: string;
            geo_target_constants: string;
            radius: string;
            radius_units: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
    };
    remove: string;
};
export declare const CampaignDraftOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        draft_id: string;
        base_campaign: string;
        name: string;
        draft_campaign: string;
        status: string;
        has_experiment_running: string;
        long_running_operation: string;
    };
    update: {
        resource_name: string;
        draft_id: string;
        base_campaign: string;
        name: string;
        draft_campaign: string;
        status: string;
        has_experiment_running: string;
        long_running_operation: string;
    };
    remove: string;
};
export declare const CampaignExperimentOperation: {
    update_mask: {
        paths: string;
    };
    update: {
        resource_name: string;
        id: string;
        campaign_draft: string;
        name: string;
        description: string;
        traffic_split_percent: string;
        traffic_split_type: string;
        experiment_campaign: string;
        status: string;
        long_running_operation: string;
        start_date: string;
        end_date: string;
    };
    remove: string;
};
export declare const CampaignExtensionSettingOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        extension_type: string;
        campaign: string;
        extension_feed_items: string;
        device: string;
    };
    update: {
        resource_name: string;
        extension_type: string;
        campaign: string;
        extension_feed_items: string;
        device: string;
    };
    remove: string;
};
export declare const CampaignFeedOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        feed: string;
        campaign: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    update: {
        resource_name: string;
        feed: string;
        campaign: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    remove: string;
};
export declare const CampaignLabelOperation: {
    create: {
        resource_name: string;
        campaign: string;
        label: string;
    };
    remove: string;
};
export declare const CampaignOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        serving_status: string;
        ad_serving_optimization_status: string;
        advertising_channel_type: string;
        advertising_channel_sub_type: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        real_time_bidding_setting: {
            opt_in: string;
        };
        network_settings: {
            target_google_search: string;
            target_search_network: string;
            target_content_network: string;
            target_partner_search_network: string;
        };
        hotel_setting: {
            hotel_center_id: string;
        };
        dynamic_search_ads_setting: {
            domain_name: string;
            language_code: string;
            use_supplied_urls_only: string;
            feeds: string;
        };
        shopping_setting: {
            merchant_id: string;
            sales_country: string;
            campaign_priority: string;
            enable_local: string;
        };
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        geo_target_type_setting: {
            positive_geo_target_type: string;
            negative_geo_target_type: string;
        };
        app_campaign_setting: {
            bidding_strategy_goal_type: string;
            app_id: string;
            app_store: string;
        };
        labels: string;
        experiment_type: string;
        base_campaign: string;
        campaign_budget: string;
        bidding_strategy_type: string;
        start_date: string;
        end_date: string;
        final_url_suffix: string;
        frequency_caps: {
            key: {
                level: string;
                event_type: string;
                time_unit: string;
                time_length: string;
            };
            cap: string;
        };
        video_brand_safety_suitability: string;
        vanity_pharma: {
            vanity_pharma_display_url_mode: string;
            vanity_pharma_text: string;
        };
        selective_optimization: {
            conversion_actions: string;
        };
        tracking_setting: {
            tracking_url: string;
        };
        payment_mode: string;
        bidding_strategy: string;
        commission: {
            commission_rate_micros: string;
        };
        manual_cpc: {
            enhanced_cpc_enabled: string;
        };
        manual_cpm: {};
        manual_cpv: {};
        maximize_conversions: {};
        maximize_conversion_value: {
            target_roas: string;
        };
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        percent_cpc: {
            cpc_bid_ceiling_micros: string;
            enhanced_cpc_enabled: string;
        };
        target_cpm: {};
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        serving_status: string;
        ad_serving_optimization_status: string;
        advertising_channel_type: string;
        advertising_channel_sub_type: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        real_time_bidding_setting: {
            opt_in: string;
        };
        network_settings: {
            target_google_search: string;
            target_search_network: string;
            target_content_network: string;
            target_partner_search_network: string;
        };
        hotel_setting: {
            hotel_center_id: string;
        };
        dynamic_search_ads_setting: {
            domain_name: string;
            language_code: string;
            use_supplied_urls_only: string;
            feeds: string;
        };
        shopping_setting: {
            merchant_id: string;
            sales_country: string;
            campaign_priority: string;
            enable_local: string;
        };
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        geo_target_type_setting: {
            positive_geo_target_type: string;
            negative_geo_target_type: string;
        };
        app_campaign_setting: {
            bidding_strategy_goal_type: string;
            app_id: string;
            app_store: string;
        };
        labels: string;
        experiment_type: string;
        base_campaign: string;
        campaign_budget: string;
        bidding_strategy_type: string;
        start_date: string;
        end_date: string;
        final_url_suffix: string;
        frequency_caps: {
            key: {
                level: string;
                event_type: string;
                time_unit: string;
                time_length: string;
            };
            cap: string;
        };
        video_brand_safety_suitability: string;
        vanity_pharma: {
            vanity_pharma_display_url_mode: string;
            vanity_pharma_text: string;
        };
        selective_optimization: {
            conversion_actions: string;
        };
        tracking_setting: {
            tracking_url: string;
        };
        payment_mode: string;
        bidding_strategy: string;
        commission: {
            commission_rate_micros: string;
        };
        manual_cpc: {
            enhanced_cpc_enabled: string;
        };
        manual_cpm: {};
        manual_cpv: {};
        maximize_conversions: {};
        maximize_conversion_value: {
            target_roas: string;
        };
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        percent_cpc: {
            cpc_bid_ceiling_micros: string;
            enhanced_cpc_enabled: string;
        };
        target_cpm: {};
    };
    remove: string;
};
export declare const CampaignSharedSetOperation: {
    create: {
        resource_name: string;
        campaign: string;
        shared_set: string;
        status: string;
    };
    remove: string;
};
export declare const ConversionActionOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        category: string;
        owner_customer: string;
        include_in_conversions_metric: string;
        click_through_lookback_window_days: string;
        view_through_lookback_window_days: string;
        value_settings: {
            default_value: string;
            default_currency_code: string;
            always_use_default_value: string;
        };
        counting_type: string;
        attribution_model_settings: {
            attribution_model: string;
            data_driven_model_status: string;
        };
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
        phone_call_duration_seconds: string;
        app_id: string;
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        category: string;
        owner_customer: string;
        include_in_conversions_metric: string;
        click_through_lookback_window_days: string;
        view_through_lookback_window_days: string;
        value_settings: {
            default_value: string;
            default_currency_code: string;
            always_use_default_value: string;
        };
        counting_type: string;
        attribution_model_settings: {
            attribution_model: string;
            data_driven_model_status: string;
        };
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
        phone_call_duration_seconds: string;
        app_id: string;
    };
    remove: string;
};
export declare const CustomerExtensionSettingOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        extension_type: string;
        extension_feed_items: string;
        device: string;
    };
    update: {
        resource_name: string;
        extension_type: string;
        extension_feed_items: string;
        device: string;
    };
    remove: string;
};
export declare const CustomerFeedOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        feed: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    update: {
        resource_name: string;
        feed: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    remove: string;
};
export declare const CustomerLabelOperation: {
    create: {
        resource_name: string;
        customer: string;
        label: string;
    };
    remove: string;
};
export declare const CustomerNegativeCriterionOperation: {
    create: {
        resource_name: string;
        id: string;
        type: string;
        content_label: {
            type: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        placement: {
            url: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
    };
    remove: string;
};
export declare const CustomerOperation: {
    update: {
        resource_name: string;
        id: string;
        descriptive_name: string;
        currency_code: string;
        time_zone: string;
        tracking_url_template: string;
        final_url_suffix: string;
        auto_tagging_enabled: string;
        has_partners_badge: string;
        manager: string;
        test_account: string;
        call_reporting_setting: {
            call_reporting_enabled: string;
            call_conversion_reporting_enabled: string;
            call_conversion_action: string;
        };
        conversion_tracking_setting: {
            conversion_tracking_id: string;
            cross_account_conversion_tracking_id: string;
        };
        remarketing_setting: {
            google_global_site_tag: string;
        };
        pay_per_conversion_eligibility_failure_reasons: string;
    };
    update_mask: {
        paths: string;
    };
};
export declare const ExtensionFeedItemOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        extension_type: string;
        start_date_time: string;
        end_date_time: string;
        ad_schedules: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        device: string;
        targeted_geo_target_constant: string;
        targeted_keyword: {
            text: string;
            match_type: string;
        };
        status: string;
        sitelink_feed_item: {
            link_text: string;
            line1: string;
            line2: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        structured_snippet_feed_item: {
            header: string;
            values: string;
        };
        app_feed_item: {
            link_text: string;
            app_id: string;
            app_store: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        call_feed_item: {
            phone_number: string;
            country_code: string;
            call_tracking_enabled: string;
            call_conversion_action: string;
            call_conversion_tracking_disabled: string;
            call_conversion_reporting_state: string;
        };
        callout_feed_item: {
            callout_text: string;
        };
        text_message_feed_item: {
            business_name: string;
            country_code: string;
            phone_number: string;
            text: string;
            extension_text: string;
        };
        price_feed_item: {
            type: string;
            price_qualifier: string;
            tracking_url_template: string;
            language_code: string;
            price_offerings: {
                header: string;
                description: string;
                price: {
                    currency_code: string;
                    amount_micros: string;
                };
                unit: string;
                final_urls: string;
                final_mobile_urls: string;
            };
            final_url_suffix: string;
        };
        promotion_feed_item: {
            promotion_target: string;
            discount_modifier: string;
            promotion_start_date: string;
            promotion_end_date: string;
            occasion: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
            language_code: string;
            percent_off: string;
            money_amount_off: {
                currency_code: string;
                amount_micros: string;
            };
            promotion_code: string;
            orders_over_amount: {
                currency_code: string;
                amount_micros: string;
            };
        };
        location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
        };
        affiliate_location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
            chain_id: string;
            chain_name: string;
        };
        hotel_callout_feed_item: {
            text: string;
            language_code: string;
        };
        targeted_campaign: string;
        targeted_ad_group: string;
    };
    update: {
        resource_name: string;
        id: string;
        extension_type: string;
        start_date_time: string;
        end_date_time: string;
        ad_schedules: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        device: string;
        targeted_geo_target_constant: string;
        targeted_keyword: {
            text: string;
            match_type: string;
        };
        status: string;
        sitelink_feed_item: {
            link_text: string;
            line1: string;
            line2: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        structured_snippet_feed_item: {
            header: string;
            values: string;
        };
        app_feed_item: {
            link_text: string;
            app_id: string;
            app_store: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        call_feed_item: {
            phone_number: string;
            country_code: string;
            call_tracking_enabled: string;
            call_conversion_action: string;
            call_conversion_tracking_disabled: string;
            call_conversion_reporting_state: string;
        };
        callout_feed_item: {
            callout_text: string;
        };
        text_message_feed_item: {
            business_name: string;
            country_code: string;
            phone_number: string;
            text: string;
            extension_text: string;
        };
        price_feed_item: {
            type: string;
            price_qualifier: string;
            tracking_url_template: string;
            language_code: string;
            price_offerings: {
                header: string;
                description: string;
                price: {
                    currency_code: string;
                    amount_micros: string;
                };
                unit: string;
                final_urls: string;
                final_mobile_urls: string;
            };
            final_url_suffix: string;
        };
        promotion_feed_item: {
            promotion_target: string;
            discount_modifier: string;
            promotion_start_date: string;
            promotion_end_date: string;
            occasion: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
            language_code: string;
            percent_off: string;
            money_amount_off: {
                currency_code: string;
                amount_micros: string;
            };
            promotion_code: string;
            orders_over_amount: {
                currency_code: string;
                amount_micros: string;
            };
        };
        location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
        };
        affiliate_location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
            chain_id: string;
            chain_name: string;
        };
        hotel_callout_feed_item: {
            text: string;
            language_code: string;
        };
        targeted_campaign: string;
        targeted_ad_group: string;
    };
    remove: string;
};
export declare const FeedItemOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        feed: string;
        id: string;
        start_date_time: string;
        end_date_time: string;
        attribute_values: {
            feed_attribute_id: string;
            integer_value: string;
            boolean_value: string;
            string_value: string;
            double_value: string;
            price_value: {
                currency_code: string;
                amount_micros: string;
            };
            integer_values: string;
            boolean_values: string;
            string_values: string;
            double_values: string;
        };
        geo_targeting_restriction: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        status: string;
        policy_infos: {
            placeholder_type_enum: string;
            feed_mapping_resource_name: string;
            review_status: string;
            approval_status: string;
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            validation_status: string;
            validation_errors: {};
            quality_approval_status: string;
            quality_disapproval_reasons: string;
        };
    };
    update: {
        resource_name: string;
        feed: string;
        id: string;
        start_date_time: string;
        end_date_time: string;
        attribute_values: {
            feed_attribute_id: string;
            integer_value: string;
            boolean_value: string;
            string_value: string;
            double_value: string;
            price_value: {
                currency_code: string;
                amount_micros: string;
            };
            integer_values: string;
            boolean_values: string;
            string_values: string;
            double_values: string;
        };
        geo_targeting_restriction: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        status: string;
        policy_infos: {
            placeholder_type_enum: string;
            feed_mapping_resource_name: string;
            review_status: string;
            approval_status: string;
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            validation_status: string;
            validation_errors: {};
            quality_approval_status: string;
            quality_disapproval_reasons: string;
        };
    };
    remove: string;
};
export declare const FeedItemTargetOperation: {
    create: {
        resource_name: string;
        feed_item: string;
        feed_item_target_type: string;
        feed_item_target_id: string;
        status: string;
        campaign: string;
        ad_group: string;
        keyword: {
            text: string;
            match_type: string;
        };
        geo_target_constant: string;
        device: string;
        ad_schedule: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
    };
    remove: string;
};
export declare const FeedMappingOperation: {
    create: {
        resource_name: string;
        feed: string;
        attribute_field_mappings: {
            feed_attribute_id: string;
            field_id: string;
            sitelink_field: string;
            call_field: string;
            app_field: string;
            location_field: string;
            affiliate_location_field: string;
            callout_field: string;
            structured_snippet_field: string;
            message_field: string;
            price_field: string;
            promotion_field: string;
            ad_customizer_field: string;
            dsa_page_feed_field: string;
            location_extension_targeting_field: string;
            education_field: string;
            flight_field: string;
            custom_field: string;
            hotel_field: string;
            real_estate_field: string;
            travel_field: string;
            local_field: string;
            job_field: string;
        };
        status: string;
        placeholder_type: string;
        criterion_type: string;
    };
    remove: string;
};
export declare const FeedOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        attributes: {
            id: string;
            name: string;
            type: string;
            is_part_of_key: string;
        };
        attribute_operations: {
            operator: {};
            value: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
        };
        origin: string;
        status: string;
        places_location_feed_data: {
            oauth_info: {
                http_method: string;
                http_request_url: string;
                http_authorization_header: string;
            };
            email_address: string;
            business_account_id: string;
            business_name_filter: string;
            category_filters: string;
            label_filters: string;
        };
        affiliate_location_feed_data: {
            chain_ids: string;
            relationship_type: string;
        };
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        attributes: {
            id: string;
            name: string;
            type: string;
            is_part_of_key: string;
        };
        attribute_operations: {
            operator: {};
            value: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
        };
        origin: string;
        status: string;
        places_location_feed_data: {
            oauth_info: {
                http_method: string;
                http_request_url: string;
                http_authorization_header: string;
            };
            email_address: string;
            business_account_id: string;
            business_name_filter: string;
            category_filters: string;
            label_filters: string;
        };
        affiliate_location_feed_data: {
            chain_ids: string;
            relationship_type: string;
        };
    };
    remove: string;
};
export declare const LabelOperation: {
    update_mask: {
        paths: string;
    };
    create: {};
    update: {};
    remove: string;
};
export declare const MediaFileOperation: {
    create: {
        resource_name: string;
        id: string;
        type: string;
        mime_type: string;
        source_url: string;
        name: string;
        file_size: string;
        image: {
            data: string;
        };
        media_bundle: {
            data: string;
        };
        audio: {
            ad_duration_millis: string;
        };
        video: {
            ad_duration_millis: string;
            youtube_video_id: string;
            advertising_id_code: string;
            isci_code: string;
        };
    };
};
export declare const RemarketingActionOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
    };
};
export declare const SharedCriterionOperation: {
    create: {
        resource_name: string;
        shared_set: string;
        criterion_id: string;
        type: string;
        keyword: {
            text: string;
            match_type: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
    };
    remove: string;
};
export declare const SharedSetOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        type: string;
        name: string;
        status: string;
        member_count: string;
        reference_count: string;
    };
    update: {
        resource_name: string;
        id: string;
        type: string;
        name: string;
        status: string;
        member_count: string;
        reference_count: string;
    };
    remove: string;
};
export declare const UserListOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        read_only: string;
        name: string;
        description: string;
        membership_status: string;
        integration_code: string;
        membership_life_span: string;
        size_for_display: string;
        size_range_for_display: string;
        size_for_search: string;
        size_range_for_search: string;
        type: string;
        closing_reason: string;
        access_reason: string;
        account_user_list_status: string;
        eligible_for_search: string;
        eligible_for_display: string;
        crm_based_user_list: {
            app_id: string;
            upload_key_type: string;
            data_source_type: string;
        };
        similar_user_list: {
            seed_user_list: string;
        };
        rule_based_user_list: {
            prepopulation_status: string;
            combined_rule_user_list: {
                left_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                right_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                rule_operator: string;
            };
            date_specific_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                start_date: string;
                end_date: string;
            };
            expression_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
            };
        };
        logical_user_list: {
            rules: {
                operator: string;
                rule_operands: {
                    user_list: string;
                };
            };
        };
        basic_user_list: {
            actions: {
                conversion_action: string;
                remarketing_action: string;
            };
        };
    };
    update: {
        resource_name: string;
        id: string;
        read_only: string;
        name: string;
        description: string;
        membership_status: string;
        integration_code: string;
        membership_life_span: string;
        size_for_display: string;
        size_range_for_display: string;
        size_for_search: string;
        size_range_for_search: string;
        type: string;
        closing_reason: string;
        access_reason: string;
        account_user_list_status: string;
        eligible_for_search: string;
        eligible_for_display: string;
        crm_based_user_list: {
            app_id: string;
            upload_key_type: string;
            data_source_type: string;
        };
        similar_user_list: {
            seed_user_list: string;
        };
        rule_based_user_list: {
            prepopulation_status: string;
            combined_rule_user_list: {
                left_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                right_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                rule_operator: string;
            };
            date_specific_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                start_date: string;
                end_date: string;
            };
            expression_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
            };
        };
        logical_user_list: {
            rules: {
                operator: string;
                rule_operands: {
                    user_list: string;
                };
            };
        };
        basic_user_list: {
            actions: {
                conversion_action: string;
                remarketing_action: string;
            };
        };
    };
    remove: string;
};
export declare const MutateOperation: {
    ad_group_ad_label_operation: {
        create: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        remove: string;
    };
    ad_group_ad_operation: {
        update_mask: {
            paths: string;
        };
        policy_validation_parameter: {
            ignorable_policy_topics: string;
            exempt_policy_violation_keys: {
                policy_name: string;
                violating_text: string;
            };
        };
        create: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        update: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        remove: string;
    };
    ad_group_bid_modifier_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        update: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        remove: string;
    };
    ad_group_criterion_label_operation: {
        create: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        remove: string;
    };
    ad_group_criterion_operation: {
        update_mask: {
            paths: string;
        };
        exempt_policy_violation_keys: {
            policy_name: string;
            violating_text: string;
        };
        create: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        update: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        remove: string;
    };
    ad_group_extension_setting_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    ad_group_feed_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    ad_group_label_operation: {
        create: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        remove: string;
    };
    ad_group_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        remove: string;
    };
    ad_parameter_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        update: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        remove: string;
    };
    asset_operation: {
        create: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
    };
    bidding_strategy_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        remove: string;
    };
    campaign_bid_modifier_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        update: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        remove: string;
    };
    campaign_budget_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        remove: string;
    };
    campaign_criterion_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        update: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        remove: string;
    };
    campaign_draft_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        update: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        remove: string;
    };
    campaign_experiment_operation: {
        update_mask: {
            paths: string;
        };
        update: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        remove: string;
    };
    campaign_extension_setting_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    campaign_feed_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    campaign_label_operation: {
        create: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        remove: string;
    };
    campaign_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        remove: string;
    };
    campaign_shared_set_operation: {
        create: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        remove: string;
    };
    conversion_action_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        remove: string;
    };
    customer_extension_setting_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    customer_feed_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    customer_label_operation: {
        create: {
            resource_name: string;
            customer: string;
            label: string;
        };
        remove: string;
    };
    customer_negative_criterion_operation: {
        create: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        remove: string;
    };
    customer_operation: {
        update: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        update_mask: {
            paths: string;
        };
    };
    extension_feed_item_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        update: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        remove: string;
    };
    feed_item_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        update: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        remove: string;
    };
    feed_item_target_operation: {
        create: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        remove: string;
    };
    feed_mapping_operation: {
        create: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        remove: string;
    };
    feed_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        remove: string;
    };
    label_operation: {
        update_mask: {
            paths: string;
        };
        create: {};
        update: {};
        remove: string;
    };
    media_file_operation: {
        create: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
    };
    remarketing_action_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
    };
    shared_criterion_operation: {
        create: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        remove: string;
    };
    shared_set_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        update: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        remove: string;
    };
    user_list_operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        update: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        remove: string;
    };
};
export declare const AddMutateJobOperationsRequest: {
    resource_name: string;
    sequence_token: string;
    mutate_operations: {
        ad_group_ad_label_operation: {
            create: {
                resource_name: string;
                ad_group_ad: string;
                label: string;
            };
            remove: string;
        };
        ad_group_ad_operation: {
            update_mask: {
                paths: string;
            };
            policy_validation_parameter: {
                ignorable_policy_topics: string;
                exempt_policy_violation_keys: {
                    policy_name: string;
                    violating_text: string;
                };
            };
            create: {
                resource_name: string;
                status: string;
                ad_group: string;
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                policy_summary: {
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    review_status: string;
                    approval_status: string;
                };
                ad_strength: string;
            };
            update: {
                resource_name: string;
                status: string;
                ad_group: string;
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                policy_summary: {
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    review_status: string;
                    approval_status: string;
                };
                ad_strength: string;
            };
            remove: string;
        };
        ad_group_bid_modifier_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                ad_group: string;
                criterion_id: string;
                bid_modifier: string;
                base_ad_group: string;
                bid_modifier_source: string;
                hotel_date_selection_type: {
                    type: string;
                };
                hotel_advance_booking_window: {
                    min_days: string;
                    max_days: string;
                };
                hotel_length_of_stay: {
                    min_nights: string;
                    max_nights: string;
                };
                hotel_check_in_day: {
                    day_of_week: string;
                };
                device: {
                    type: string;
                };
                preferred_content: {
                    type: string;
                };
            };
            update: {
                resource_name: string;
                ad_group: string;
                criterion_id: string;
                bid_modifier: string;
                base_ad_group: string;
                bid_modifier_source: string;
                hotel_date_selection_type: {
                    type: string;
                };
                hotel_advance_booking_window: {
                    min_days: string;
                    max_days: string;
                };
                hotel_length_of_stay: {
                    min_nights: string;
                    max_nights: string;
                };
                hotel_check_in_day: {
                    day_of_week: string;
                };
                device: {
                    type: string;
                };
                preferred_content: {
                    type: string;
                };
            };
            remove: string;
        };
        ad_group_criterion_label_operation: {
            create: {
                resource_name: string;
                ad_group_criterion: string;
                label: string;
            };
            remove: string;
        };
        ad_group_criterion_operation: {
            update_mask: {
                paths: string;
            };
            exempt_policy_violation_keys: {
                policy_name: string;
                violating_text: string;
            };
            create: {
                resource_name: string;
                criterion_id: string;
                status: string;
                quality_info: {
                    quality_score: string;
                    creative_quality_score: string;
                    post_click_quality_score: string;
                    search_predicted_ctr: string;
                };
                ad_group: string;
                type: string;
                negative: string;
                system_serving_status: string;
                approval_status: string;
                bid_modifier: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                cpv_bid_micros: string;
                percent_cpc_bid_micros: string;
                effective_cpc_bid_micros: string;
                effective_cpm_bid_micros: string;
                effective_cpv_bid_micros: string;
                effective_percent_cpc_bid_micros: string;
                effective_cpc_bid_source: string;
                effective_cpm_bid_source: string;
                effective_cpv_bid_source: string;
                effective_percent_cpc_bid_source: string;
                position_estimates: {
                    first_page_cpc_micros: string;
                    first_position_cpc_micros: string;
                    top_of_page_cpc_micros: string;
                    estimated_add_clicks_at_first_position_cpc: string;
                    estimated_add_cost_at_first_position_cpc: string;
                };
                final_urls: string;
                final_mobile_urls: string;
                final_url_suffix: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                listing_group: {
                    type: string;
                    case_value: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                    parent_ad_group_criterion: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                app_payment_model: {
                    type: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
                custom_intent: {
                    custom_intent: string;
                };
            };
            update: {
                resource_name: string;
                criterion_id: string;
                status: string;
                quality_info: {
                    quality_score: string;
                    creative_quality_score: string;
                    post_click_quality_score: string;
                    search_predicted_ctr: string;
                };
                ad_group: string;
                type: string;
                negative: string;
                system_serving_status: string;
                approval_status: string;
                bid_modifier: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                cpv_bid_micros: string;
                percent_cpc_bid_micros: string;
                effective_cpc_bid_micros: string;
                effective_cpm_bid_micros: string;
                effective_cpv_bid_micros: string;
                effective_percent_cpc_bid_micros: string;
                effective_cpc_bid_source: string;
                effective_cpm_bid_source: string;
                effective_cpv_bid_source: string;
                effective_percent_cpc_bid_source: string;
                position_estimates: {
                    first_page_cpc_micros: string;
                    first_position_cpc_micros: string;
                    top_of_page_cpc_micros: string;
                    estimated_add_clicks_at_first_position_cpc: string;
                    estimated_add_cost_at_first_position_cpc: string;
                };
                final_urls: string;
                final_mobile_urls: string;
                final_url_suffix: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                listing_group: {
                    type: string;
                    case_value: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                    parent_ad_group_criterion: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                app_payment_model: {
                    type: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
                custom_intent: {
                    custom_intent: string;
                };
            };
            remove: string;
        };
        ad_group_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                ad_group: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                ad_group: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        ad_group_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                ad_group: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                ad_group: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        ad_group_label_operation: {
            create: {
                resource_name: string;
                ad_group: string;
                label: string;
            };
            remove: string;
        };
        ad_group_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                ad_rotation_mode: string;
                base_ad_group: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                campaign: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                target_cpa_micros: string;
                cpv_bid_micros: string;
                target_cpm_micros: string;
                target_roas: string;
                percent_cpc_bid_micros: string;
                explorer_auto_optimizer_setting: {
                    opt_in: string;
                };
                display_custom_bid_dimension: string;
                final_url_suffix: string;
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                effective_target_cpa_micros: string;
                effective_target_cpa_source: string;
                effective_target_roas: string;
                effective_target_roas_source: string;
                labels: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                ad_rotation_mode: string;
                base_ad_group: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                campaign: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                target_cpa_micros: string;
                cpv_bid_micros: string;
                target_cpm_micros: string;
                target_roas: string;
                percent_cpc_bid_micros: string;
                explorer_auto_optimizer_setting: {
                    opt_in: string;
                };
                display_custom_bid_dimension: string;
                final_url_suffix: string;
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                effective_target_cpa_micros: string;
                effective_target_cpa_source: string;
                effective_target_roas: string;
                effective_target_roas_source: string;
                labels: string;
            };
            remove: string;
        };
        ad_parameter_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                ad_group_criterion: string;
                parameter_index: string;
                insertion_text: string;
            };
            update: {
                resource_name: string;
                ad_group_criterion: string;
                parameter_index: string;
                insertion_text: string;
            };
            remove: string;
        };
        asset_operation: {
            create: {
                resource_name: string;
                id: string;
                name: string;
                type: string;
                youtube_video_asset: {
                    youtube_video_id: string;
                };
                media_bundle_asset: {
                    data: string;
                };
                image_asset: {
                    data: string;
                    file_size: string;
                    mime_type: string;
                    full_size: {
                        height_pixels: string;
                        width_pixels: string;
                        url: string;
                    };
                };
                text_asset: {
                    text: string;
                };
            };
        };
        bidding_strategy_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                campaign_count: string;
                non_removed_campaign_count: string;
                enhanced_cpc: {};
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                campaign_count: string;
                non_removed_campaign_count: string;
                enhanced_cpc: {};
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
            };
            remove: string;
        };
        campaign_bid_modifier_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                interaction_type: {
                    type: string;
                };
            };
            update: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                interaction_type: {
                    type: string;
                };
            };
            remove: string;
        };
        campaign_budget_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                amount_micros: string;
                total_amount_micros: string;
                status: string;
                delivery_method: string;
                explicitly_shared: string;
                reference_count: string;
                has_recommended_budget: string;
                recommended_budget_amount_micros: string;
                period: string;
                recommended_budget_estimated_change_weekly_clicks: string;
                recommended_budget_estimated_change_weekly_cost_micros: string;
                recommended_budget_estimated_change_weekly_interactions: string;
                recommended_budget_estimated_change_weekly_views: string;
                type: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                amount_micros: string;
                total_amount_micros: string;
                status: string;
                delivery_method: string;
                explicitly_shared: string;
                reference_count: string;
                has_recommended_budget: string;
                recommended_budget_amount_micros: string;
                period: string;
                recommended_budget_estimated_change_weekly_clicks: string;
                recommended_budget_estimated_change_weekly_cost_micros: string;
                recommended_budget_estimated_change_weekly_interactions: string;
                recommended_budget_estimated_change_weekly_views: string;
                type: string;
            };
            remove: string;
        };
        campaign_criterion_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                negative: string;
                type: string;
                status: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                location: {
                    geo_target_constant: string;
                };
                device: {
                    type: string;
                };
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                proximity: {
                    geo_point: {
                        longitude_in_micro_degrees: string;
                        latitude_in_micro_degrees: string;
                    };
                    radius: string;
                    radius_units: string;
                    address: {
                        postal_code: string;
                        province_code: string;
                        country_code: string;
                        province_name: string;
                        street_address: string;
                        street_address2: string;
                        city_name: string;
                    };
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                listing_scope: {
                    dimensions: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                };
                language: {
                    language_constant: string;
                };
                ip_block: {
                    ip_address: string;
                };
                content_label: {
                    type: string;
                };
                carrier: {
                    carrier_constant: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                operating_system_version: {
                    operating_system_version_constant: string;
                };
                mobile_device: {
                    mobile_device_constant: string;
                };
                location_group: {
                    feed: string;
                    geo_target_constants: string;
                    radius: string;
                    radius_units: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
            };
            update: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                negative: string;
                type: string;
                status: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                location: {
                    geo_target_constant: string;
                };
                device: {
                    type: string;
                };
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                proximity: {
                    geo_point: {
                        longitude_in_micro_degrees: string;
                        latitude_in_micro_degrees: string;
                    };
                    radius: string;
                    radius_units: string;
                    address: {
                        postal_code: string;
                        province_code: string;
                        country_code: string;
                        province_name: string;
                        street_address: string;
                        street_address2: string;
                        city_name: string;
                    };
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                listing_scope: {
                    dimensions: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                };
                language: {
                    language_constant: string;
                };
                ip_block: {
                    ip_address: string;
                };
                content_label: {
                    type: string;
                };
                carrier: {
                    carrier_constant: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                operating_system_version: {
                    operating_system_version_constant: string;
                };
                mobile_device: {
                    mobile_device_constant: string;
                };
                location_group: {
                    feed: string;
                    geo_target_constants: string;
                    radius: string;
                    radius_units: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
            };
            remove: string;
        };
        campaign_draft_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                draft_id: string;
                base_campaign: string;
                name: string;
                draft_campaign: string;
                status: string;
                has_experiment_running: string;
                long_running_operation: string;
            };
            update: {
                resource_name: string;
                draft_id: string;
                base_campaign: string;
                name: string;
                draft_campaign: string;
                status: string;
                has_experiment_running: string;
                long_running_operation: string;
            };
            remove: string;
        };
        campaign_experiment_operation: {
            update_mask: {
                paths: string;
            };
            update: {
                resource_name: string;
                id: string;
                campaign_draft: string;
                name: string;
                description: string;
                traffic_split_percent: string;
                traffic_split_type: string;
                experiment_campaign: string;
                status: string;
                long_running_operation: string;
                start_date: string;
                end_date: string;
            };
            remove: string;
        };
        campaign_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                campaign: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                campaign: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        campaign_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                campaign: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                campaign: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        campaign_label_operation: {
            create: {
                resource_name: string;
                campaign: string;
                label: string;
            };
            remove: string;
        };
        campaign_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                serving_status: string;
                ad_serving_optimization_status: string;
                advertising_channel_type: string;
                advertising_channel_sub_type: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                real_time_bidding_setting: {
                    opt_in: string;
                };
                network_settings: {
                    target_google_search: string;
                    target_search_network: string;
                    target_content_network: string;
                    target_partner_search_network: string;
                };
                hotel_setting: {
                    hotel_center_id: string;
                };
                dynamic_search_ads_setting: {
                    domain_name: string;
                    language_code: string;
                    use_supplied_urls_only: string;
                    feeds: string;
                };
                shopping_setting: {
                    merchant_id: string;
                    sales_country: string;
                    campaign_priority: string;
                    enable_local: string;
                };
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                geo_target_type_setting: {
                    positive_geo_target_type: string;
                    negative_geo_target_type: string;
                };
                app_campaign_setting: {
                    bidding_strategy_goal_type: string;
                    app_id: string;
                    app_store: string;
                };
                labels: string;
                experiment_type: string;
                base_campaign: string;
                campaign_budget: string;
                bidding_strategy_type: string;
                start_date: string;
                end_date: string;
                final_url_suffix: string;
                frequency_caps: {
                    key: {
                        level: string;
                        event_type: string;
                        time_unit: string;
                        time_length: string;
                    };
                    cap: string;
                };
                video_brand_safety_suitability: string;
                vanity_pharma: {
                    vanity_pharma_display_url_mode: string;
                    vanity_pharma_text: string;
                };
                selective_optimization: {
                    conversion_actions: string;
                };
                tracking_setting: {
                    tracking_url: string;
                };
                payment_mode: string;
                bidding_strategy: string;
                commission: {
                    commission_rate_micros: string;
                };
                manual_cpc: {
                    enhanced_cpc_enabled: string;
                };
                manual_cpm: {};
                manual_cpv: {};
                maximize_conversions: {};
                maximize_conversion_value: {
                    target_roas: string;
                };
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                percent_cpc: {
                    cpc_bid_ceiling_micros: string;
                    enhanced_cpc_enabled: string;
                };
                target_cpm: {};
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                serving_status: string;
                ad_serving_optimization_status: string;
                advertising_channel_type: string;
                advertising_channel_sub_type: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                real_time_bidding_setting: {
                    opt_in: string;
                };
                network_settings: {
                    target_google_search: string;
                    target_search_network: string;
                    target_content_network: string;
                    target_partner_search_network: string;
                };
                hotel_setting: {
                    hotel_center_id: string;
                };
                dynamic_search_ads_setting: {
                    domain_name: string;
                    language_code: string;
                    use_supplied_urls_only: string;
                    feeds: string;
                };
                shopping_setting: {
                    merchant_id: string;
                    sales_country: string;
                    campaign_priority: string;
                    enable_local: string;
                };
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                geo_target_type_setting: {
                    positive_geo_target_type: string;
                    negative_geo_target_type: string;
                };
                app_campaign_setting: {
                    bidding_strategy_goal_type: string;
                    app_id: string;
                    app_store: string;
                };
                labels: string;
                experiment_type: string;
                base_campaign: string;
                campaign_budget: string;
                bidding_strategy_type: string;
                start_date: string;
                end_date: string;
                final_url_suffix: string;
                frequency_caps: {
                    key: {
                        level: string;
                        event_type: string;
                        time_unit: string;
                        time_length: string;
                    };
                    cap: string;
                };
                video_brand_safety_suitability: string;
                vanity_pharma: {
                    vanity_pharma_display_url_mode: string;
                    vanity_pharma_text: string;
                };
                selective_optimization: {
                    conversion_actions: string;
                };
                tracking_setting: {
                    tracking_url: string;
                };
                payment_mode: string;
                bidding_strategy: string;
                commission: {
                    commission_rate_micros: string;
                };
                manual_cpc: {
                    enhanced_cpc_enabled: string;
                };
                manual_cpm: {};
                manual_cpv: {};
                maximize_conversions: {};
                maximize_conversion_value: {
                    target_roas: string;
                };
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                percent_cpc: {
                    cpc_bid_ceiling_micros: string;
                    enhanced_cpc_enabled: string;
                };
                target_cpm: {};
            };
            remove: string;
        };
        campaign_shared_set_operation: {
            create: {
                resource_name: string;
                campaign: string;
                shared_set: string;
                status: string;
            };
            remove: string;
        };
        conversion_action_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                category: string;
                owner_customer: string;
                include_in_conversions_metric: string;
                click_through_lookback_window_days: string;
                view_through_lookback_window_days: string;
                value_settings: {
                    default_value: string;
                    default_currency_code: string;
                    always_use_default_value: string;
                };
                counting_type: string;
                attribution_model_settings: {
                    attribution_model: string;
                    data_driven_model_status: string;
                };
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
                phone_call_duration_seconds: string;
                app_id: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                category: string;
                owner_customer: string;
                include_in_conversions_metric: string;
                click_through_lookback_window_days: string;
                view_through_lookback_window_days: string;
                value_settings: {
                    default_value: string;
                    default_currency_code: string;
                    always_use_default_value: string;
                };
                counting_type: string;
                attribution_model_settings: {
                    attribution_model: string;
                    data_driven_model_status: string;
                };
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
                phone_call_duration_seconds: string;
                app_id: string;
            };
            remove: string;
        };
        customer_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        customer_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        customer_label_operation: {
            create: {
                resource_name: string;
                customer: string;
                label: string;
            };
            remove: string;
        };
        customer_negative_criterion_operation: {
            create: {
                resource_name: string;
                id: string;
                type: string;
                content_label: {
                    type: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                placement: {
                    url: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
            };
            remove: string;
        };
        customer_operation: {
            update: {
                resource_name: string;
                id: string;
                descriptive_name: string;
                currency_code: string;
                time_zone: string;
                tracking_url_template: string;
                final_url_suffix: string;
                auto_tagging_enabled: string;
                has_partners_badge: string;
                manager: string;
                test_account: string;
                call_reporting_setting: {
                    call_reporting_enabled: string;
                    call_conversion_reporting_enabled: string;
                    call_conversion_action: string;
                };
                conversion_tracking_setting: {
                    conversion_tracking_id: string;
                    cross_account_conversion_tracking_id: string;
                };
                remarketing_setting: {
                    google_global_site_tag: string;
                };
                pay_per_conversion_eligibility_failure_reasons: string;
            };
            update_mask: {
                paths: string;
            };
        };
        extension_feed_item_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                extension_type: string;
                start_date_time: string;
                end_date_time: string;
                ad_schedules: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                device: string;
                targeted_geo_target_constant: string;
                targeted_keyword: {
                    text: string;
                    match_type: string;
                };
                status: string;
                sitelink_feed_item: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                structured_snippet_feed_item: {
                    header: string;
                    values: string;
                };
                app_feed_item: {
                    link_text: string;
                    app_id: string;
                    app_store: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                call_feed_item: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
                callout_feed_item: {
                    callout_text: string;
                };
                text_message_feed_item: {
                    business_name: string;
                    country_code: string;
                    phone_number: string;
                    text: string;
                    extension_text: string;
                };
                price_feed_item: {
                    type: string;
                    price_qualifier: string;
                    tracking_url_template: string;
                    language_code: string;
                    price_offerings: {
                        header: string;
                        description: string;
                        price: {
                            currency_code: string;
                            amount_micros: string;
                        };
                        unit: string;
                        final_urls: string;
                        final_mobile_urls: string;
                    };
                    final_url_suffix: string;
                };
                promotion_feed_item: {
                    promotion_target: string;
                    discount_modifier: string;
                    promotion_start_date: string;
                    promotion_end_date: string;
                    occasion: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                    language_code: string;
                    percent_off: string;
                    money_amount_off: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    promotion_code: string;
                    orders_over_amount: {
                        currency_code: string;
                        amount_micros: string;
                    };
                };
                location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                };
                affiliate_location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                    chain_id: string;
                    chain_name: string;
                };
                hotel_callout_feed_item: {
                    text: string;
                    language_code: string;
                };
                targeted_campaign: string;
                targeted_ad_group: string;
            };
            update: {
                resource_name: string;
                id: string;
                extension_type: string;
                start_date_time: string;
                end_date_time: string;
                ad_schedules: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                device: string;
                targeted_geo_target_constant: string;
                targeted_keyword: {
                    text: string;
                    match_type: string;
                };
                status: string;
                sitelink_feed_item: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                structured_snippet_feed_item: {
                    header: string;
                    values: string;
                };
                app_feed_item: {
                    link_text: string;
                    app_id: string;
                    app_store: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                call_feed_item: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
                callout_feed_item: {
                    callout_text: string;
                };
                text_message_feed_item: {
                    business_name: string;
                    country_code: string;
                    phone_number: string;
                    text: string;
                    extension_text: string;
                };
                price_feed_item: {
                    type: string;
                    price_qualifier: string;
                    tracking_url_template: string;
                    language_code: string;
                    price_offerings: {
                        header: string;
                        description: string;
                        price: {
                            currency_code: string;
                            amount_micros: string;
                        };
                        unit: string;
                        final_urls: string;
                        final_mobile_urls: string;
                    };
                    final_url_suffix: string;
                };
                promotion_feed_item: {
                    promotion_target: string;
                    discount_modifier: string;
                    promotion_start_date: string;
                    promotion_end_date: string;
                    occasion: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                    language_code: string;
                    percent_off: string;
                    money_amount_off: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    promotion_code: string;
                    orders_over_amount: {
                        currency_code: string;
                        amount_micros: string;
                    };
                };
                location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                };
                affiliate_location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                    chain_id: string;
                    chain_name: string;
                };
                hotel_callout_feed_item: {
                    text: string;
                    language_code: string;
                };
                targeted_campaign: string;
                targeted_ad_group: string;
            };
            remove: string;
        };
        feed_item_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                id: string;
                start_date_time: string;
                end_date_time: string;
                attribute_values: {
                    feed_attribute_id: string;
                    integer_value: string;
                    boolean_value: string;
                    string_value: string;
                    double_value: string;
                    price_value: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    integer_values: string;
                    boolean_values: string;
                    string_values: string;
                    double_values: string;
                };
                geo_targeting_restriction: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                status: string;
                policy_infos: {
                    placeholder_type_enum: string;
                    feed_mapping_resource_name: string;
                    review_status: string;
                    approval_status: string;
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    validation_status: string;
                    validation_errors: {};
                    quality_approval_status: string;
                    quality_disapproval_reasons: string;
                };
            };
            update: {
                resource_name: string;
                feed: string;
                id: string;
                start_date_time: string;
                end_date_time: string;
                attribute_values: {
                    feed_attribute_id: string;
                    integer_value: string;
                    boolean_value: string;
                    string_value: string;
                    double_value: string;
                    price_value: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    integer_values: string;
                    boolean_values: string;
                    string_values: string;
                    double_values: string;
                };
                geo_targeting_restriction: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                status: string;
                policy_infos: {
                    placeholder_type_enum: string;
                    feed_mapping_resource_name: string;
                    review_status: string;
                    approval_status: string;
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    validation_status: string;
                    validation_errors: {};
                    quality_approval_status: string;
                    quality_disapproval_reasons: string;
                };
            };
            remove: string;
        };
        feed_item_target_operation: {
            create: {
                resource_name: string;
                feed_item: string;
                feed_item_target_type: string;
                feed_item_target_id: string;
                status: string;
                campaign: string;
                ad_group: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                geo_target_constant: string;
                device: string;
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
            };
            remove: string;
        };
        feed_mapping_operation: {
            create: {
                resource_name: string;
                feed: string;
                attribute_field_mappings: {
                    feed_attribute_id: string;
                    field_id: string;
                    sitelink_field: string;
                    call_field: string;
                    app_field: string;
                    location_field: string;
                    affiliate_location_field: string;
                    callout_field: string;
                    structured_snippet_field: string;
                    message_field: string;
                    price_field: string;
                    promotion_field: string;
                    ad_customizer_field: string;
                    dsa_page_feed_field: string;
                    location_extension_targeting_field: string;
                    education_field: string;
                    flight_field: string;
                    custom_field: string;
                    hotel_field: string;
                    real_estate_field: string;
                    travel_field: string;
                    local_field: string;
                    job_field: string;
                };
                status: string;
                placeholder_type: string;
                criterion_type: string;
            };
            remove: string;
        };
        feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                attributes: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
                attribute_operations: {
                    operator: {};
                    value: {
                        id: string;
                        name: string;
                        type: string;
                        is_part_of_key: string;
                    };
                };
                origin: string;
                status: string;
                places_location_feed_data: {
                    oauth_info: {
                        http_method: string;
                        http_request_url: string;
                        http_authorization_header: string;
                    };
                    email_address: string;
                    business_account_id: string;
                    business_name_filter: string;
                    category_filters: string;
                    label_filters: string;
                };
                affiliate_location_feed_data: {
                    chain_ids: string;
                    relationship_type: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                attributes: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
                attribute_operations: {
                    operator: {};
                    value: {
                        id: string;
                        name: string;
                        type: string;
                        is_part_of_key: string;
                    };
                };
                origin: string;
                status: string;
                places_location_feed_data: {
                    oauth_info: {
                        http_method: string;
                        http_request_url: string;
                        http_authorization_header: string;
                    };
                    email_address: string;
                    business_account_id: string;
                    business_name_filter: string;
                    category_filters: string;
                    label_filters: string;
                };
                affiliate_location_feed_data: {
                    chain_ids: string;
                    relationship_type: string;
                };
            };
            remove: string;
        };
        label_operation: {
            update_mask: {
                paths: string;
            };
            create: {};
            update: {};
            remove: string;
        };
        media_file_operation: {
            create: {
                resource_name: string;
                id: string;
                type: string;
                mime_type: string;
                source_url: string;
                name: string;
                file_size: string;
                image: {
                    data: string;
                };
                media_bundle: {
                    data: string;
                };
                audio: {
                    ad_duration_millis: string;
                };
                video: {
                    ad_duration_millis: string;
                    youtube_video_id: string;
                    advertising_id_code: string;
                    isci_code: string;
                };
            };
        };
        remarketing_action_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
            };
        };
        shared_criterion_operation: {
            create: {
                resource_name: string;
                shared_set: string;
                criterion_id: string;
                type: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
            };
            remove: string;
        };
        shared_set_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                type: string;
                name: string;
                status: string;
                member_count: string;
                reference_count: string;
            };
            update: {
                resource_name: string;
                id: string;
                type: string;
                name: string;
                status: string;
                member_count: string;
                reference_count: string;
            };
            remove: string;
        };
        user_list_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                read_only: string;
                name: string;
                description: string;
                membership_status: string;
                integration_code: string;
                membership_life_span: string;
                size_for_display: string;
                size_range_for_display: string;
                size_for_search: string;
                size_range_for_search: string;
                type: string;
                closing_reason: string;
                access_reason: string;
                account_user_list_status: string;
                eligible_for_search: string;
                eligible_for_display: string;
                crm_based_user_list: {
                    app_id: string;
                    upload_key_type: string;
                    data_source_type: string;
                };
                similar_user_list: {
                    seed_user_list: string;
                };
                rule_based_user_list: {
                    prepopulation_status: string;
                    combined_rule_user_list: {
                        left_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        right_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        rule_operator: string;
                    };
                    date_specific_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        start_date: string;
                        end_date: string;
                    };
                    expression_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                    };
                };
                logical_user_list: {
                    rules: {
                        operator: string;
                        rule_operands: {
                            user_list: string;
                        };
                    };
                };
                basic_user_list: {
                    actions: {
                        conversion_action: string;
                        remarketing_action: string;
                    };
                };
            };
            update: {
                resource_name: string;
                id: string;
                read_only: string;
                name: string;
                description: string;
                membership_status: string;
                integration_code: string;
                membership_life_span: string;
                size_for_display: string;
                size_range_for_display: string;
                size_for_search: string;
                size_range_for_search: string;
                type: string;
                closing_reason: string;
                access_reason: string;
                account_user_list_status: string;
                eligible_for_search: string;
                eligible_for_display: string;
                crm_based_user_list: {
                    app_id: string;
                    upload_key_type: string;
                    data_source_type: string;
                };
                similar_user_list: {
                    seed_user_list: string;
                };
                rule_based_user_list: {
                    prepopulation_status: string;
                    combined_rule_user_list: {
                        left_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        right_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        rule_operator: string;
                    };
                    date_specific_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        start_date: string;
                        end_date: string;
                    };
                    expression_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                    };
                };
                logical_user_list: {
                    rules: {
                        operator: string;
                        rule_operands: {
                            user_list: string;
                        };
                    };
                };
                basic_user_list: {
                    actions: {
                        conversion_action: string;
                        remarketing_action: string;
                    };
                };
            };
            remove: string;
        };
    };
};
export declare const AddMutateJobOperationsResponse: {
    total_operations: string;
    next_sequence_token: string;
};
export declare const AgeRangeViewService: {};
export declare const CampaignBudgetParameters: {
    new_budget_amount_micros: string;
};
export declare const TextAdParameters: {
    ad: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
};
export declare const KeywordParameters: {
    ad_group: string;
    match_type: string;
    cpc_bid_micros: string;
};
export declare const TargetCpaOptInParameters: {
    target_cpa_micros: string;
    new_campaign_budget_amount_micros: string;
};
export declare const CalloutExtensionParameters: {
    callout_extensions: {
        callout_text: string;
    };
};
export declare const CallExtensionParameters: {
    call_extensions: {
        phone_number: string;
        country_code: string;
        call_tracking_enabled: string;
        call_conversion_action: string;
        call_conversion_tracking_disabled: string;
        call_conversion_reporting_state: string;
    };
};
export declare const SitelinkExtensionParameters: {
    sitelink_extensions: {
        link_text: string;
        line1: string;
        line2: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
};
export declare const MoveUnusedBudgetParameters: {
    budget_micros_to_move: string;
};
export declare const CampaignBudgetParameters: {
    new_budget_amount_micros: string;
};
export declare const TextAdParameters: {
    ad: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
};
export declare const KeywordParameters: {
    ad_group: string;
    match_type: string;
    cpc_bid_micros: string;
};
export declare const TargetCpaOptInParameters: {
    target_cpa_micros: string;
    new_campaign_budget_amount_micros: string;
};
export declare const CalloutExtensionParameters: {
    callout_extensions: {
        callout_text: string;
    };
};
export declare const CallExtensionParameters: {
    call_extensions: {
        phone_number: string;
        country_code: string;
        call_tracking_enabled: string;
        call_conversion_action: string;
        call_conversion_tracking_disabled: string;
        call_conversion_reporting_state: string;
    };
};
export declare const SitelinkExtensionParameters: {
    sitelink_extensions: {
        link_text: string;
        line1: string;
        line2: string;
        final_urls: string;
        final_mobile_urls: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        final_url_suffix: string;
    };
};
export declare const MoveUnusedBudgetParameters: {
    budget_micros_to_move: string;
};
export declare const ApplyRecommendationOperation: {
    resource_name: string;
    campaign_budget: {
        new_budget_amount_micros: string;
    };
    text_ad: {
        ad: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
    };
    keyword: {
        ad_group: string;
        match_type: string;
        cpc_bid_micros: string;
    };
    target_cpa_opt_in: {
        target_cpa_micros: string;
        new_campaign_budget_amount_micros: string;
    };
    callout_extension: {
        callout_extensions: {
            callout_text: string;
        };
    };
    call_extension: {
        call_extensions: {
            phone_number: string;
            country_code: string;
            call_tracking_enabled: string;
            call_conversion_action: string;
            call_conversion_tracking_disabled: string;
            call_conversion_reporting_state: string;
        };
    };
    sitelink_extension: {
        sitelink_extensions: {
            link_text: string;
            line1: string;
            line2: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
    };
    move_unused_budget: {
        budget_micros_to_move: string;
    };
};
export declare const ApplyRecommendationRequest: {
    customer_id: string;
    operations: {
        resource_name: string;
        campaign_budget: {
            new_budget_amount_micros: string;
        };
        text_ad: {
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
        };
        keyword: {
            ad_group: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        target_cpa_opt_in: {
            target_cpa_micros: string;
            new_campaign_budget_amount_micros: string;
        };
        callout_extension: {
            callout_extensions: {
                callout_text: string;
            };
        };
        call_extension: {
            call_extensions: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
        };
        sitelink_extension: {
            sitelink_extensions: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
        };
        move_unused_budget: {
            budget_micros_to_move: string;
        };
    };
    partial_failure: string;
};
export declare const ApplyRecommendationResult: {
    resource_name: string;
};
export declare const ApplyRecommendationResponse: {
    results: {
        resource_name: string;
    };
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
};
export declare const AssetService: {};
export declare const BiddingStrategyService: {};
export declare const BillingSetupService: {};
export declare const CampaignAudienceViewService: {};
export declare const CampaignBidModifierService: {};
export declare const CampaignBudgetService: {};
export declare const CampaignCriterionService: {};
export declare const CampaignCriterionSimulationService: {};
export declare const CampaignDraftService: {};
export declare const CampaignExperimentService: {};
export declare const CampaignExtensionSettingService: {};
export declare const CampaignFeedService: {};
export declare const CampaignLabelService: {};
export declare const CampaignService: {};
export declare const CampaignSharedSetService: {};
export declare const CarrierConstantService: {};
export declare const ChangeStatusService: {};
export declare const ClickViewService: {};
export declare const ConversionActionService: {};
export declare const ConversionAdjustmentUploadService: {};
export declare const ConversionUploadService: {};
export declare const CreateCampaignExperimentMetadata: {
    campaign_experiment: string;
};
export declare const CreateCampaignExperimentRequest: {
    customer_id: string;
    campaign_experiment: {
        resource_name: string;
        id: string;
        campaign_draft: string;
        name: string;
        description: string;
        traffic_split_percent: string;
        traffic_split_type: string;
        experiment_campaign: string;
        status: string;
        long_running_operation: string;
        start_date: string;
        end_date: string;
    };
    validate_only: string;
};
export declare const CreateCustomerClientRequest: {
    customer_id: string;
    customer_client: {
        resource_name: string;
        id: string;
        descriptive_name: string;
        currency_code: string;
        time_zone: string;
        tracking_url_template: string;
        final_url_suffix: string;
        auto_tagging_enabled: string;
        has_partners_badge: string;
        manager: string;
        test_account: string;
        call_reporting_setting: {
            call_reporting_enabled: string;
            call_conversion_reporting_enabled: string;
            call_conversion_action: string;
        };
        conversion_tracking_setting: {
            conversion_tracking_id: string;
            cross_account_conversion_tracking_id: string;
        };
        remarketing_setting: {
            google_global_site_tag: string;
        };
        pay_per_conversion_eligibility_failure_reasons: string;
    };
    email_address: string;
    access_role: string;
};
export declare const CreateCustomerClientResponse: {
    resource_name: string;
};
export declare const CreateMutateJobRequest: {
    customer_id: string;
};
export declare const CreateMutateJobResponse: {
    resource_name: string;
};
export declare const CurrencyConstantService: {};
export declare const CustomInterestService: {};
export declare const CustomerClientLinkService: {};
export declare const CustomerClientService: {};
export declare const CustomerExtensionSettingService: {};
export declare const CustomerFeedService: {};
export declare const CustomerLabelService: {};
export declare const CustomerManagerLinkService: {};
export declare const CustomerNegativeCriterionService: {};
export declare const CustomerService: {};
export declare const DetailPlacementViewService: {};
export declare const DismissRecommendationOperation: {
    resource_name: string;
};
export declare const DismissRecommendationOperation: {
    resource_name: string;
};
export declare const DismissRecommendationRequest: {
    customer_id: string;
    operations: {
        resource_name: string;
    };
    partial_failure: string;
};
export declare const DismissRecommendationResult: {
    resource_name: string;
};
export declare const DismissRecommendationResult: {
    resource_name: string;
};
export declare const DismissRecommendationResponse: {
    results: {
        resource_name: string;
    };
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
};
export declare const DisplayKeywordViewService: {};
export declare const DistanceViewService: {};
export declare const DomainCategoryService: {};
export declare const DynamicSearchAdsSearchTermViewService: {};
export declare const EndCampaignExperimentRequest: {
    campaign_experiment: string;
};
export declare const ExpandedLandingPageViewService: {};
export declare const ExtensionFeedItemService: {};
export declare const FeedItemService: {};
export declare const FeedItemTargetService: {};
export declare const FeedMappingService: {};
export declare const FeedPlaceholderViewService: {};
export declare const FeedService: {};
export declare const GenderViewService: {};
export declare const GenerateForecastMetricsRequest: {
    keyword_plan: string;
};
export declare const ForecastMetrics: {
    impressions: string;
    ctr: string;
    average_cpc: string;
    clicks: string;
    cost_micros: string;
};
export declare const KeywordPlanCampaignForecast: {
    keyword_plan_campaign: string;
    campaign_forecast: {
        impressions: string;
        ctr: string;
        average_cpc: string;
        clicks: string;
        cost_micros: string;
    };
};
export declare const KeywordPlanAdGroupForecast: {
    keyword_plan_ad_group: string;
    ad_group_forecast: {
        impressions: string;
        ctr: string;
        average_cpc: string;
        clicks: string;
        cost_micros: string;
    };
};
export declare const KeywordPlanKeywordForecast: {
    keyword_plan_ad_group_keyword: string;
    keyword_forecast: {
        impressions: string;
        ctr: string;
        average_cpc: string;
        clicks: string;
        cost_micros: string;
    };
};
export declare const GenerateForecastMetricsResponse: {
    campaign_forecasts: {
        keyword_plan_campaign: string;
        campaign_forecast: {
            impressions: string;
            ctr: string;
            average_cpc: string;
            clicks: string;
            cost_micros: string;
        };
    };
    ad_group_forecasts: {
        keyword_plan_ad_group: string;
        ad_group_forecast: {
            impressions: string;
            ctr: string;
            average_cpc: string;
            clicks: string;
            cost_micros: string;
        };
    };
    keyword_forecasts: {
        keyword_plan_ad_group_keyword: string;
        keyword_forecast: {
            impressions: string;
            ctr: string;
            average_cpc: string;
            clicks: string;
            cost_micros: string;
        };
    };
};
export declare const GenerateHistoricalMetricsRequest: {
    keyword_plan: string;
};
export declare const KeywordPlanKeywordHistoricalMetrics: {
    search_query: string;
    keyword_metrics: {
        avg_monthly_searches: string;
        competition: string;
    };
};
export declare const GenerateHistoricalMetricsResponse: {
    metrics: {
        search_query: string;
        keyword_metrics: {
            avg_monthly_searches: string;
            competition: string;
        };
    };
};
export declare const GenerateKeywordIdeaResult: {
    text: string;
    keyword_idea_metrics: {
        avg_monthly_searches: string;
        competition: string;
    };
};
export declare const GenerateKeywordIdeaResponse: {
    results: {
        text: string;
        keyword_idea_metrics: {
            avg_monthly_searches: string;
            competition: string;
        };
    };
};
export declare const KeywordAndUrlSeed: {
    url: string;
    keywords: string;
};
export declare const KeywordSeed: {
    keywords: string;
};
export declare const UrlSeed: {
    url: string;
};
export declare const GenerateKeywordIdeasRequest: {
    customer_id: string;
    language: string;
    geo_target_constants: string;
    keyword_plan_network: string;
    keyword_and_url_seed: {
        url: string;
        keywords: string;
    };
    keyword_seed: {
        keywords: string;
    };
    url_seed: {
        url: string;
    };
};
export declare const Preferences: {
    is_skippable: string;
    starts_with_sound: string;
    ad_length: string;
    top_content_only: string;
    has_guaranteed_price: string;
};
export declare const GenerateProductMixIdeasRequest: {
    customer_id: string;
    plannable_location_id: string;
    currency_code: string;
    budget_micros: string;
    preferences: {
        is_skippable: string;
        starts_with_sound: string;
        ad_length: string;
        top_content_only: string;
        has_guaranteed_price: string;
    };
};
export declare const ProductAllocation: {
    plannable_product_code: string;
    budget_micros: string;
};
export declare const GenerateProductMixIdeasResponse: {
    product_allocation: {
        plannable_product_code: string;
        budget_micros: string;
    };
};
export declare const CampaignDuration: {
    duration_in_days: string;
};
export declare const Targeting: {
    plannable_location_id: string;
    age_range: string;
    genders: {
        type: string;
    };
    devices: {
        type: string;
    };
    network: string;
};
export declare const PlannedProduct: {
    plannable_product_code: string;
    budget_micros: string;
};
export declare const GenerateReachForecastRequest: {
    customer_id: string;
    currency_code: string;
    campaign_duration: {
        duration_in_days: string;
    };
    cookie_frequency_cap: string;
    min_effective_frequency: string;
    targeting: {
        plannable_location_id: string;
        age_range: string;
        genders: {
            type: string;
        };
        devices: {
            type: string;
        };
        network: string;
    };
    planned_products: {
        plannable_product_code: string;
        budget_micros: string;
    };
};
export declare const OnTargetAudienceMetrics: {
    youtube_audience_size: string;
    census_audience_size: string;
};
export declare const Forecast: {
    on_target_reach: string;
    total_reach: string;
    on_target_impressions: string;
    total_impressions: string;
};
export declare const ReachForecast: {
    cost_micros: string;
    forecast: {
        on_target_reach: string;
        total_reach: string;
        on_target_impressions: string;
        total_impressions: string;
    };
    forecasted_product_allocations: {
        plannable_product_code: string;
        budget_micros: string;
    };
};
export declare const ReachCurve: {
    reach_forecasts: {
        cost_micros: string;
        forecast: {
            on_target_reach: string;
            total_reach: string;
            on_target_impressions: string;
            total_impressions: string;
        };
        forecasted_product_allocations: {
            plannable_product_code: string;
            budget_micros: string;
        };
    };
};
export declare const GenerateReachForecastResponse: {
    on_target_audience_metrics: {
        youtube_audience_size: string;
        census_audience_size: string;
    };
    reach_curve: {
        reach_forecasts: {
            cost_micros: string;
            forecast: {
                on_target_reach: string;
                total_reach: string;
                on_target_impressions: string;
                total_impressions: string;
            };
            forecasted_product_allocations: {
                plannable_product_code: string;
                budget_micros: string;
            };
        };
    };
};
export declare const GeoTargetConstantService: {};
export declare const GeographicViewService: {};
export declare const GetAccountBudgetProposalRequest: {
    resource_name: string;
};
export declare const GetAccountBudgetRequest: {
    resource_name: string;
};
export declare const GetAdGroupAdAssetViewRequest: {
    resource_name: string;
};
export declare const GetAdGroupAdLabelRequest: {
    resource_name: string;
};
export declare const GetAdGroupAdRequest: {
    resource_name: string;
};
export declare const GetAdGroupAudienceViewRequest: {
    resource_name: string;
};
export declare const GetAdGroupBidModifierRequest: {
    resource_name: string;
};
export declare const GetAdGroupCriterionLabelRequest: {
    resource_name: string;
};
export declare const GetAdGroupCriterionRequest: {
    resource_name: string;
};
export declare const GetAdGroupCriterionSimulationRequest: {
    resource_name: string;
};
export declare const GetAdGroupExtensionSettingRequest: {
    resource_name: string;
};
export declare const GetAdGroupFeedRequest: {
    resource_name: string;
};
export declare const GetAdGroupLabelRequest: {
    resource_name: string;
};
export declare const GetAdGroupRequest: {
    resource_name: string;
};
export declare const GetAdGroupSimulationRequest: {
    resource_name: string;
};
export declare const GetAdParameterRequest: {
    resource_name: string;
};
export declare const GetAdRequest: {
    resource_name: string;
};
export declare const GetAdScheduleViewRequest: {
    resource_name: string;
};
export declare const GetAgeRangeViewRequest: {
    resource_name: string;
};
export declare const GetAssetRequest: {
    resource_name: string;
};
export declare const GetBiddingStrategyRequest: {
    resource_name: string;
};
export declare const GetBillingSetupRequest: {
    resource_name: string;
};
export declare const GetCampaignAudienceViewRequest: {
    resource_name: string;
};
export declare const GetCampaignBidModifierRequest: {
    resource_name: string;
};
export declare const GetCampaignBudgetRequest: {
    resource_name: string;
};
export declare const GetCampaignCriterionRequest: {
    resource_name: string;
};
export declare const GetCampaignCriterionSimulationRequest: {
    resource_name: string;
};
export declare const GetCampaignDraftRequest: {
    resource_name: string;
};
export declare const GetCampaignExperimentRequest: {
    resource_name: string;
};
export declare const GetCampaignExtensionSettingRequest: {
    resource_name: string;
};
export declare const GetCampaignFeedRequest: {
    resource_name: string;
};
export declare const GetCampaignLabelRequest: {
    resource_name: string;
};
export declare const GetCampaignRequest: {
    resource_name: string;
};
export declare const GetCampaignSharedSetRequest: {
    resource_name: string;
};
export declare const GetCarrierConstantRequest: {
    resource_name: string;
};
export declare const GetChangeStatusRequest: {
    resource_name: string;
};
export declare const GetClickViewRequest: {
    resource_name: string;
};
export declare const GetConversionActionRequest: {
    resource_name: string;
};
export declare const GetCurrencyConstantRequest: {
    resource_name: string;
};
export declare const GetCustomInterestRequest: {
    resource_name: string;
};
export declare const GetCustomerClientLinkRequest: {
    resource_name: string;
};
export declare const GetCustomerClientRequest: {
    resource_name: string;
};
export declare const GetCustomerExtensionSettingRequest: {
    resource_name: string;
};
export declare const GetCustomerFeedRequest: {
    resource_name: string;
};
export declare const GetCustomerLabelRequest: {
    resource_name: string;
};
export declare const GetCustomerManagerLinkRequest: {
    resource_name: string;
};
export declare const GetCustomerNegativeCriterionRequest: {
    resource_name: string;
};
export declare const GetCustomerRequest: {
    resource_name: string;
};
export declare const GetDetailPlacementViewRequest: {
    resource_name: string;
};
export declare const GetDisplayKeywordViewRequest: {
    resource_name: string;
};
export declare const GetDistanceViewRequest: {
    resource_name: string;
};
export declare const GetDomainCategoryRequest: {
    resource_name: string;
};
export declare const GetDynamicSearchAdsSearchTermViewRequest: {
    resource_name: string;
};
export declare const GetExpandedLandingPageViewRequest: {
    resource_name: string;
};
export declare const GetExtensionFeedItemRequest: {
    resource_name: string;
};
export declare const GetFeedItemRequest: {
    resource_name: string;
};
export declare const GetFeedItemTargetRequest: {
    resource_name: string;
};
export declare const GetFeedMappingRequest: {
    resource_name: string;
};
export declare const GetFeedPlaceholderViewRequest: {
    resource_name: string;
};
export declare const GetFeedRequest: {
    resource_name: string;
};
export declare const GetGenderViewRequest: {
    resource_name: string;
};
export declare const GetGeoTargetConstantRequest: {
    resource_name: string;
};
export declare const GetGeographicViewRequest: {
    resource_name: string;
};
export declare const GetGoogleAdsFieldRequest: {
    resource_name: string;
};
export declare const GetGroupPlacementViewRequest: {
    resource_name: string;
};
export declare const GetHotelGroupViewRequest: {
    resource_name: string;
};
export declare const GetHotelPerformanceViewRequest: {
    resource_name: string;
};
export declare const GetKeywordPlanAdGroupRequest: {
    resource_name: string;
};
export declare const GetKeywordPlanCampaignRequest: {
    resource_name: string;
};
export declare const GetKeywordPlanKeywordRequest: {
    resource_name: string;
};
export declare const GetKeywordPlanNegativeKeywordRequest: {
    resource_name: string;
};
export declare const GetKeywordPlanRequest: {
    resource_name: string;
};
export declare const GetKeywordViewRequest: {
    resource_name: string;
};
export declare const GetLabelRequest: {
    resource_name: string;
};
export declare const GetLandingPageViewRequest: {
    resource_name: string;
};
export declare const GetLanguageConstantRequest: {
    resource_name: string;
};
export declare const GetLocationViewRequest: {
    resource_name: string;
};
export declare const GetManagedPlacementViewRequest: {
    resource_name: string;
};
export declare const GetMediaFileRequest: {
    resource_name: string;
};
export declare const GetMerchantCenterLinkRequest: {
    resource_name: string;
};
export declare const GetMobileAppCategoryConstantRequest: {
    resource_name: string;
};
export declare const GetMobileDeviceConstantRequest: {
    resource_name: string;
};
export declare const GetMutateJobRequest: {
    resource_name: string;
};
export declare const GetOperatingSystemVersionConstantRequest: {
    resource_name: string;
};
export declare const GetPaidOrganicSearchTermViewRequest: {
    resource_name: string;
};
export declare const GetParentalStatusViewRequest: {
    resource_name: string;
};
export declare const GetProductBiddingCategoryConstantRequest: {
    resource_name: string;
};
export declare const GetProductGroupViewRequest: {
    resource_name: string;
};
export declare const GetRecommendationRequest: {
    resource_name: string;
};
export declare const GetRemarketingActionRequest: {
    resource_name: string;
};
export declare const GetSearchTermViewRequest: {
    resource_name: string;
};
export declare const GetSharedCriterionRequest: {
    resource_name: string;
};
export declare const GetSharedSetRequest: {
    resource_name: string;
};
export declare const GetShoppingPerformanceViewRequest: {
    resource_name: string;
};
export declare const GetTopicConstantRequest: {
    resource_name: string;
};
export declare const GetTopicViewRequest: {
    resource_name: string;
};
export declare const GetUserInterestRequest: {
    resource_name: string;
};
export declare const GetUserListRequest: {
    resource_name: string;
};
export declare const GetUserLocationViewRequest: {
    resource_name: string;
};
export declare const GetVideoRequest: {
    resource_name: string;
};
export declare const GoogleAdsFieldService: {};
export declare const GoogleAdsService: {};
export declare const GraduateCampaignExperimentRequest: {
    campaign_experiment: string;
    campaign_budget: string;
};
export declare const GraduateCampaignExperimentResponse: {
    graduated_campaign: string;
};
export declare const GroupPlacementViewService: {};
export declare const HotelGroupViewService: {};
export declare const HotelPerformanceViewService: {};
export declare const InvoiceService: {};
export declare const KeywordPlanAdGroupService: {};
export declare const KeywordPlanCampaignService: {};
export declare const KeywordPlanIdeaService: {};
export declare const KeywordPlanKeywordService: {};
export declare const KeywordPlanNegativeKeywordService: {};
export declare const KeywordPlanService: {};
export declare const KeywordViewService: {};
export declare const LabelService: {};
export declare const LandingPageViewService: {};
export declare const LanguageConstantService: {};
export declare const ListAccessibleCustomersRequest: {};
export declare const ListAccessibleCustomersResponse: {
    resource_names: string;
};
export declare const ListCampaignDraftAsyncErrorsRequest: {
    resource_name: string;
    page_token: string;
    page_size: string;
};
export declare const ListCampaignDraftAsyncErrorsResponse: {
    errors: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    next_page_token: string;
};
export declare const ListCampaignExperimentAsyncErrorsRequest: {
    resource_name: string;
    page_token: string;
    page_size: string;
};
export declare const ListCampaignExperimentAsyncErrorsResponse: {
    errors: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    next_page_token: string;
};
export declare const ListInvoicesRequest: {
    customer_id: string;
    billing_setup: string;
    issue_year: string;
    issue_month: string;
};
export declare const ListInvoicesResponse: {
    invoices: {
        resource_name: string;
        id: string;
        type: string;
        billing_setup: string;
        payments_account_id: string;
        payments_profile_id: string;
        issue_date: string;
        due_date: string;
        service_date_range: {
            start_date: string;
            end_date: string;
        };
        currency_code: string;
        invoice_level_adjustments_micros: string;
        subtotal_amount_micros: string;
        tax_amount_micros: string;
        total_amount_micros: string;
        corrected_invoice: string;
        replaced_invoices: string;
        pdf_url: string;
        account_budget_summaries: {
            customer: string;
            customer_descriptive_name: string;
            account_budget: string;
            account_budget_name: string;
            purchase_order_number: string;
            subtotal_amount_micros: string;
            tax_amount_micros: string;
            total_amount_micros: string;
            billable_activity_date_range: {
                start_date: string;
                end_date: string;
            };
        };
    };
};
export declare const ListMerchantCenterLinksRequest: {
    customer_id: string;
};
export declare const ListMerchantCenterLinksResponse: {
    merchant_center_links: {
        resource_name: string;
        id: string;
        merchant_center_account_name: string;
        status: string;
    };
};
export declare const ListMutateJobResultsRequest: {
    resource_name: string;
    page_token: string;
    page_size: string;
};
export declare const MutateAdGroupAdLabelResult: {
    resource_name: string;
};
export declare const MutateAdGroupAdResult: {
    resource_name: string;
};
export declare const MutateAdGroupBidModifierResult: {
    resource_name: string;
};
export declare const MutateAdGroupCriterionLabelResult: {
    resource_name: string;
};
export declare const MutateAdGroupCriterionResult: {
    resource_name: string;
};
export declare const MutateAdGroupExtensionSettingResult: {
    resource_name: string;
};
export declare const MutateAdGroupFeedResult: {
    resource_name: string;
};
export declare const MutateAdGroupLabelResult: {
    resource_name: string;
};
export declare const MutateAdGroupResult: {
    resource_name: string;
};
export declare const MutateAdParameterResult: {
    resource_name: string;
};
export declare const MutateAssetResult: {
    resource_name: string;
};
export declare const MutateBiddingStrategyResult: {
    resource_name: string;
};
export declare const MutateCampaignBidModifierResult: {
    resource_name: string;
};
export declare const MutateCampaignBudgetResult: {
    resource_name: string;
};
export declare const MutateCampaignCriterionResult: {
    resource_name: string;
};
export declare const MutateCampaignDraftResult: {
    resource_name: string;
};
export declare const MutateCampaignExperimentResult: {
    resource_name: string;
};
export declare const MutateCampaignExtensionSettingResult: {
    resource_name: string;
};
export declare const MutateCampaignFeedResult: {
    resource_name: string;
};
export declare const MutateCampaignLabelResult: {
    resource_name: string;
};
export declare const MutateCampaignResult: {
    resource_name: string;
};
export declare const MutateCampaignSharedSetResult: {
    resource_name: string;
};
export declare const MutateConversionActionResult: {
    resource_name: string;
};
export declare const MutateCustomerExtensionSettingResult: {
    resource_name: string;
};
export declare const MutateCustomerFeedResult: {
    resource_name: string;
};
export declare const MutateCustomerLabelResult: {
    resource_name: string;
};
export declare const MutateCustomerNegativeCriteriaResult: {
    resource_name: string;
};
export declare const MutateCustomerResult: {
    resource_name: string;
};
export declare const MutateExtensionFeedItemResult: {
    resource_name: string;
};
export declare const MutateFeedItemResult: {
    resource_name: string;
};
export declare const MutateFeedItemTargetResult: {
    resource_name: string;
};
export declare const MutateFeedMappingResult: {
    resource_name: string;
};
export declare const MutateFeedResult: {
    resource_name: string;
};
export declare const MutateLabelResult: {
    resource_name: string;
};
export declare const MutateMediaFileResult: {
    resource_name: string;
};
export declare const MutateRemarketingActionResult: {
    resource_name: string;
};
export declare const MutateSharedCriterionResult: {
    resource_name: string;
};
export declare const MutateSharedSetResult: {
    resource_name: string;
};
export declare const MutateUserListResult: {
    resource_name: string;
};
export declare const MutateOperationResponse: {
    ad_group_ad_label_result: {
        resource_name: string;
    };
    ad_group_ad_result: {
        resource_name: string;
    };
    ad_group_bid_modifier_result: {
        resource_name: string;
    };
    ad_group_criterion_label_result: {
        resource_name: string;
    };
    ad_group_criterion_result: {
        resource_name: string;
    };
    ad_group_extension_setting_result: {
        resource_name: string;
    };
    ad_group_feed_result: {
        resource_name: string;
    };
    ad_group_label_result: {
        resource_name: string;
    };
    ad_group_result: {
        resource_name: string;
    };
    ad_parameter_result: {
        resource_name: string;
    };
    asset_result: {
        resource_name: string;
    };
    bidding_strategy_result: {
        resource_name: string;
    };
    campaign_bid_modifier_result: {
        resource_name: string;
    };
    campaign_budget_result: {
        resource_name: string;
    };
    campaign_criterion_result: {
        resource_name: string;
    };
    campaign_draft_result: {
        resource_name: string;
    };
    campaign_experiment_result: {
        resource_name: string;
    };
    campaign_extension_setting_result: {
        resource_name: string;
    };
    campaign_feed_result: {
        resource_name: string;
    };
    campaign_label_result: {
        resource_name: string;
    };
    campaign_result: {
        resource_name: string;
    };
    campaign_shared_set_result: {
        resource_name: string;
    };
    conversion_action_result: {
        resource_name: string;
    };
    customer_extension_setting_result: {
        resource_name: string;
    };
    customer_feed_result: {
        resource_name: string;
    };
    customer_label_result: {
        resource_name: string;
    };
    customer_negative_criterion_result: {
        resource_name: string;
    };
    customer_result: {
        resource_name: string;
    };
    extension_feed_item_result: {
        resource_name: string;
    };
    feed_item_result: {
        resource_name: string;
    };
    feed_item_target_result: {
        resource_name: string;
    };
    feed_mapping_result: {
        resource_name: string;
    };
    feed_result: {
        resource_name: string;
    };
    label_result: {
        resource_name: string;
    };
    media_file_result: {
        resource_name: string;
    };
    remarketing_action_result: {
        resource_name: string;
    };
    shared_criterion_result: {
        resource_name: string;
    };
    shared_set_result: {
        resource_name: string;
    };
    user_list_result: {
        resource_name: string;
    };
};
export declare const MutateJobResult: {
    operation_index: string;
    mutate_operation_response: {
        ad_group_ad_label_result: {
            resource_name: string;
        };
        ad_group_ad_result: {
            resource_name: string;
        };
        ad_group_bid_modifier_result: {
            resource_name: string;
        };
        ad_group_criterion_label_result: {
            resource_name: string;
        };
        ad_group_criterion_result: {
            resource_name: string;
        };
        ad_group_extension_setting_result: {
            resource_name: string;
        };
        ad_group_feed_result: {
            resource_name: string;
        };
        ad_group_label_result: {
            resource_name: string;
        };
        ad_group_result: {
            resource_name: string;
        };
        ad_parameter_result: {
            resource_name: string;
        };
        asset_result: {
            resource_name: string;
        };
        bidding_strategy_result: {
            resource_name: string;
        };
        campaign_bid_modifier_result: {
            resource_name: string;
        };
        campaign_budget_result: {
            resource_name: string;
        };
        campaign_criterion_result: {
            resource_name: string;
        };
        campaign_draft_result: {
            resource_name: string;
        };
        campaign_experiment_result: {
            resource_name: string;
        };
        campaign_extension_setting_result: {
            resource_name: string;
        };
        campaign_feed_result: {
            resource_name: string;
        };
        campaign_label_result: {
            resource_name: string;
        };
        campaign_result: {
            resource_name: string;
        };
        campaign_shared_set_result: {
            resource_name: string;
        };
        conversion_action_result: {
            resource_name: string;
        };
        customer_extension_setting_result: {
            resource_name: string;
        };
        customer_feed_result: {
            resource_name: string;
        };
        customer_label_result: {
            resource_name: string;
        };
        customer_negative_criterion_result: {
            resource_name: string;
        };
        customer_result: {
            resource_name: string;
        };
        extension_feed_item_result: {
            resource_name: string;
        };
        feed_item_result: {
            resource_name: string;
        };
        feed_item_target_result: {
            resource_name: string;
        };
        feed_mapping_result: {
            resource_name: string;
        };
        feed_result: {
            resource_name: string;
        };
        label_result: {
            resource_name: string;
        };
        media_file_result: {
            resource_name: string;
        };
        remarketing_action_result: {
            resource_name: string;
        };
        shared_criterion_result: {
            resource_name: string;
        };
        shared_set_result: {
            resource_name: string;
        };
        user_list_result: {
            resource_name: string;
        };
    };
    status: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
};
export declare const ListMutateJobResultsResponse: {
    results: {
        operation_index: string;
        mutate_operation_response: {
            ad_group_ad_label_result: {
                resource_name: string;
            };
            ad_group_ad_result: {
                resource_name: string;
            };
            ad_group_bid_modifier_result: {
                resource_name: string;
            };
            ad_group_criterion_label_result: {
                resource_name: string;
            };
            ad_group_criterion_result: {
                resource_name: string;
            };
            ad_group_extension_setting_result: {
                resource_name: string;
            };
            ad_group_feed_result: {
                resource_name: string;
            };
            ad_group_label_result: {
                resource_name: string;
            };
            ad_group_result: {
                resource_name: string;
            };
            ad_parameter_result: {
                resource_name: string;
            };
            asset_result: {
                resource_name: string;
            };
            bidding_strategy_result: {
                resource_name: string;
            };
            campaign_bid_modifier_result: {
                resource_name: string;
            };
            campaign_budget_result: {
                resource_name: string;
            };
            campaign_criterion_result: {
                resource_name: string;
            };
            campaign_draft_result: {
                resource_name: string;
            };
            campaign_experiment_result: {
                resource_name: string;
            };
            campaign_extension_setting_result: {
                resource_name: string;
            };
            campaign_feed_result: {
                resource_name: string;
            };
            campaign_label_result: {
                resource_name: string;
            };
            campaign_result: {
                resource_name: string;
            };
            campaign_shared_set_result: {
                resource_name: string;
            };
            conversion_action_result: {
                resource_name: string;
            };
            customer_extension_setting_result: {
                resource_name: string;
            };
            customer_feed_result: {
                resource_name: string;
            };
            customer_label_result: {
                resource_name: string;
            };
            customer_negative_criterion_result: {
                resource_name: string;
            };
            customer_result: {
                resource_name: string;
            };
            extension_feed_item_result: {
                resource_name: string;
            };
            feed_item_result: {
                resource_name: string;
            };
            feed_item_target_result: {
                resource_name: string;
            };
            feed_mapping_result: {
                resource_name: string;
            };
            feed_result: {
                resource_name: string;
            };
            label_result: {
                resource_name: string;
            };
            media_file_result: {
                resource_name: string;
            };
            remarketing_action_result: {
                resource_name: string;
            };
            shared_criterion_result: {
                resource_name: string;
            };
            shared_set_result: {
                resource_name: string;
            };
            user_list_result: {
                resource_name: string;
            };
        };
        status: {
            code: string;
            message: string;
            details: {
                type_url: string;
                value: string;
            };
        };
    };
    next_page_token: string;
};
export declare const ListPaymentsAccountsRequest: {
    customer_id: string;
};
export declare const ListPaymentsAccountsResponse: {
    payments_accounts: {
        resource_name: string;
        payments_account_id: string;
        name: string;
        currency_code: string;
        payments_profile_id: string;
        secondary_payments_profile_id: string;
    };
};
export declare const ListPlannableLocationsRequest: {};
export declare const PlannableLocation: {
    id: string;
    name: string;
    parent_country_id: string;
};
export declare const ListPlannableLocationsResponse: {
    plannable_locations: {
        id: string;
        name: string;
        parent_country_id: string;
    };
};
export declare const ListPlannableProductsRequest: {
    plannable_location_id: string;
};
export declare const PlannableTargeting: {
    age_ranges: string;
    genders: {
        type: string;
    };
    devices: {
        type: string;
    };
    networks: string;
};
export declare const ProductMetadata: {
    plannable_product_code: string;
    plannable_targeting: {
        age_ranges: string;
        genders: {
            type: string;
        };
        devices: {
            type: string;
        };
        networks: string;
    };
};
export declare const ListPlannableProductsResponse: {
    product_metadata: {
        plannable_product_code: string;
        plannable_targeting: {
            age_ranges: string;
            genders: {
                type: string;
            };
            devices: {
                type: string;
            };
            networks: string;
        };
    };
};
export declare const LocationViewService: {};
export declare const ManagedPlacementViewService: {};
export declare const MediaFileService: {};
export declare const MerchantCenterLinkService: {};
export declare const MobileAppCategoryConstantService: {};
export declare const MobileDeviceConstantService: {};
export declare const MoveManagerLinkRequest: {
    customer_id: string;
    previous_customer_manager_link: string;
    new_manager: string;
};
export declare const MoveManagerLinkResponse: {
    resource_name: string;
};
export declare const AccountBudgetProposalOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        billing_setup: string;
        account_budget: string;
        proposal_type: string;
        status: string;
        proposed_name: string;
        approved_start_date_time: string;
        proposed_purchase_order_number: string;
        proposed_notes: string;
        creation_date_time: string;
        approval_date_time: string;
        proposed_start_date_time: string;
        proposed_start_time_type: string;
        proposed_end_date_time: string;
        proposed_end_time_type: string;
        approved_end_date_time: string;
        approved_end_time_type: string;
        proposed_spending_limit_micros: string;
        proposed_spending_limit_type: string;
        approved_spending_limit_micros: string;
        approved_spending_limit_type: string;
    };
    remove: string;
};
export declare const MutateAccountBudgetProposalRequest: {
    customer_id: string;
    operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            billing_setup: string;
            account_budget: string;
            proposal_type: string;
            status: string;
            proposed_name: string;
            approved_start_date_time: string;
            proposed_purchase_order_number: string;
            proposed_notes: string;
            creation_date_time: string;
            approval_date_time: string;
            proposed_start_date_time: string;
            proposed_start_time_type: string;
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
        };
        remove: string;
    };
    validate_only: string;
};
export declare const MutateAccountBudgetProposalResult: {
    resource_name: string;
};
export declare const MutateAccountBudgetProposalResponse: {
    result: {
        resource_name: string;
    };
};
export declare const MutateAdGroupAdLabelsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupAdLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupAdsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        policy_validation_parameter: {
            ignorable_policy_topics: string;
            exempt_policy_violation_keys: {
                policy_name: string;
                violating_text: string;
            };
        };
        create: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        update: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupAdsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupBidModifiersRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        update: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupBidModifiersResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupCriteriaRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        exempt_policy_violation_keys: {
            policy_name: string;
            violating_text: string;
        };
        create: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        update: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupCriteriaResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupCriterionLabelsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupCriterionLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupExtensionSettingsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupExtensionSettingsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupFeedsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupFeedsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupLabelsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdGroupsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdGroupsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateAdParametersRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        update: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateAdParametersResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const AdOperation: {
    update_mask: {
        paths: string;
    };
    update: {
        resource_name: string;
        id: string;
        final_urls: string;
        final_app_urls: {
            os_type: string;
            url: string;
        };
        final_mobile_urls: string;
        tracking_url_template: string;
        final_url_suffix: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        display_url: string;
        type: string;
        added_by_google_ads: string;
        device_preference: string;
        url_collections: {
            url_collection_id: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
        };
        name: string;
        system_managed_resource_source: string;
        text_ad: {
            headline: string;
            description1: string;
            description2: string;
        };
        expanded_text_ad: {
            headline_part1: string;
            headline_part2: string;
            headline_part3: string;
            description: string;
            description2: string;
            path1: string;
            path2: string;
        };
        call_only_ad: {
            country_code: string;
            phone_number: string;
            business_name: string;
            headline1: string;
            headline2: string;
            description1: string;
            description2: string;
            call_tracked: string;
            disable_call_conversion: string;
            phone_number_verification_url: string;
            conversion_action: string;
            conversion_reporting_state: string;
        };
        expanded_dynamic_search_ad: {
            description: string;
            description2: string;
        };
        hotel_ad: {};
        shopping_smart_ad: {};
        shopping_product_ad: {};
        gmail_ad: {
            teaser: {
                headline: string;
                description: string;
                business_name: string;
                logo_image: string;
            };
            header_image: string;
            marketing_image: string;
            marketing_image_headline: string;
            marketing_image_description: string;
            marketing_image_display_call_to_action: {
                text: string;
                text_color: string;
                url_collection_id: string;
            };
            product_images: {
                product_image: string;
                description: string;
                display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
            };
            product_videos: {
                product_video: string;
            };
        };
        image_ad: {
            pixel_width: string;
            pixel_height: string;
            image_url: string;
            preview_pixel_width: string;
            preview_pixel_height: string;
            preview_image_url: string;
            mime_type: string;
            name: string;
            media_file: string;
            data: string;
            ad_id_to_copy_image_from: string;
        };
        video_ad: {
            media_file: string;
            in_stream: {
                action_button_label: string;
                action_headline: string;
                companion_banner: string;
            };
            bumper: {
                companion_banner: string;
            };
            out_stream: {
                headline: string;
                description: string;
            };
            non_skippable: {
                companion_banner: string;
            };
            discovery: {
                headline: string;
                description1: string;
                description2: string;
            };
        };
        responsive_search_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            path1: string;
            path2: string;
        };
        legacy_responsive_display_ad: {
            short_headline: string;
            long_headline: string;
            description: string;
            business_name: string;
            allow_flexible_color: string;
            accent_color: string;
            main_color: string;
            call_to_action_text: string;
            logo_image: string;
            square_logo_image: string;
            marketing_image: string;
            square_marketing_image: string;
            format_setting: string;
            price_prefix: string;
            promo_text: string;
        };
        app_ad: {
            mandatory_ad_text: {
                text: string;
                pinned_field: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            youtube_videos: {
                asset: string;
            };
            html_5_media_bundles: {
                asset: string;
            };
        };
        legacy_app_install_ad: {
            app_id: string;
            app_store: string;
            headline: string;
            description1: string;
            description2: string;
        };
        responsive_display_ad: {
            marketing_images: {
                asset: string;
            };
            square_marketing_images: {
                asset: string;
            };
            logo_images: {
                asset: string;
            };
            square_logo_images: {
                asset: string;
            };
            headlines: {
                text: string;
                pinned_field: string;
            };
            long_headline: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            youtube_videos: {
                asset: string;
            };
            business_name: string;
            main_color: string;
            accent_color: string;
            allow_flexible_color: string;
            call_to_action_text: string;
            price_prefix: string;
            promo_text: string;
            format_setting: string;
        };
        display_upload_ad: {
            display_upload_product_type: string;
            media_bundle: {
                asset: string;
            };
        };
        app_engagement_ad: {
            headlines: {
                text: string;
                pinned_field: string;
            };
            descriptions: {
                text: string;
                pinned_field: string;
            };
            images: {
                asset: string;
            };
            videos: {
                asset: string;
            };
        };
        shopping_comparison_listing_ad: {
            headline: string;
        };
    };
};
export declare const MutateAdsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        update: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
    };
};
export declare const MutateAdResult: {
    resource_name: string;
};
export declare const MutateAdsResponse: {
    results: {
        resource_name: string;
    };
};
export declare const MutateAssetsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
    };
};
export declare const MutateAssetsResponse: {
    results: {
        resource_name: string;
    };
};
export declare const MutateBiddingStrategiesRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateBiddingStrategiesResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const BillingSetupOperation: {
    create: {
        resource_name: string;
        id: string;
        status: string;
        payments_account: string;
        payments_account_info: {
            payments_account_id: string;
            payments_account_name: string;
            payments_profile_id: string;
            payments_profile_name: string;
            secondary_payments_profile_id: string;
        };
        start_date_time: string;
        start_time_type: string;
        end_date_time: string;
        end_time_type: string;
    };
    remove: string;
};
export declare const MutateBillingSetupRequest: {
    customer_id: string;
    operation: {
        create: {
            resource_name: string;
            id: string;
            status: string;
            payments_account: string;
            payments_account_info: {
                payments_account_id: string;
                payments_account_name: string;
                payments_profile_id: string;
                payments_profile_name: string;
                secondary_payments_profile_id: string;
            };
            start_date_time: string;
            start_time_type: string;
            end_date_time: string;
            end_time_type: string;
        };
        remove: string;
    };
};
export declare const MutateBillingSetupResult: {
    resource_name: string;
};
export declare const MutateBillingSetupResponse: {
    result: {
        resource_name: string;
    };
};
export declare const MutateCampaignBidModifiersRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        update: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignBidModifiersResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignBudgetsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignBudgetsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignCriteriaRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        update: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignCriteriaResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignDraftsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        update: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignDraftsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignExperimentsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        update: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignExperimentsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignExtensionSettingsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignExtensionSettingsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignFeedsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignFeedsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignLabelsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignSharedSetsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignSharedSetsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCampaignsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCampaignsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateConversionActionsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateConversionActionsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const CustomInterestOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        status: string;
        name: string;
        type: string;
        description: string;
        members: {
            member_type: string;
            parameter: string;
        };
    };
    update: {
        resource_name: string;
        id: string;
        status: string;
        name: string;
        type: string;
        description: string;
        members: {
            member_type: string;
            parameter: string;
        };
    };
};
export declare const MutateCustomInterestsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
    };
    validate_only: string;
};
export declare const MutateCustomInterestResult: {
    resource_name: string;
};
export declare const MutateCustomInterestsResponse: {
    results: {
        resource_name: string;
    };
};
export declare const CustomerClientLinkOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        client_customer: string;
        manager_link_id: string;
        status: string;
        hidden: string;
    };
    update: {
        resource_name: string;
        client_customer: string;
        manager_link_id: string;
        status: string;
        hidden: string;
    };
};
export declare const MutateCustomerClientLinkRequest: {
    customer_id: string;
    operation: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
        update: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
    };
};
export declare const MutateCustomerClientLinkResult: {
    resource_name: string;
};
export declare const MutateCustomerClientLinkResponse: {
    result: {
        resource_name: string;
    };
};
export declare const MutateCustomerExtensionSettingsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        update: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCustomerExtensionSettingsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCustomerFeedsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        update: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCustomerFeedsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCustomerLabelsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            customer: string;
            label: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCustomerLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const CustomerManagerLinkOperation: {
    update_mask: {
        paths: string;
    };
    update: {
        resource_name: string;
        manager_customer: string;
        manager_link_id: string;
        status: string;
    };
};
export declare const MutateCustomerManagerLinkRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        update: {
            resource_name: string;
            manager_customer: string;
            manager_link_id: string;
            status: string;
        };
    };
};
export declare const MutateCustomerManagerLinkResult: {
    resource_name: string;
};
export declare const MutateCustomerManagerLinkResponse: {
    results: {
        resource_name: string;
    };
};
export declare const MutateCustomerNegativeCriteriaRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateCustomerNegativeCriteriaResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateCustomerRequest: {
    customer_id: string;
    operation: {
        update: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        update_mask: {
            paths: string;
        };
    };
    validate_only: string;
};
export declare const MutateCustomerResponse: {
    result: {
        resource_name: string;
    };
};
export declare const MutateExtensionFeedItemsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        update: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateExtensionFeedItemsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateFeedItemTargetsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        remove: string;
    };
};
export declare const MutateFeedItemTargetsResponse: {
    results: {
        resource_name: string;
    };
};
export declare const MutateFeedItemsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        update: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateFeedItemsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateFeedMappingsRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateFeedMappingsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateFeedsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateFeedsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateGoogleAdsRequest: {
    customer_id: string;
    mutate_operations: {
        ad_group_ad_label_operation: {
            create: {
                resource_name: string;
                ad_group_ad: string;
                label: string;
            };
            remove: string;
        };
        ad_group_ad_operation: {
            update_mask: {
                paths: string;
            };
            policy_validation_parameter: {
                ignorable_policy_topics: string;
                exempt_policy_violation_keys: {
                    policy_name: string;
                    violating_text: string;
                };
            };
            create: {
                resource_name: string;
                status: string;
                ad_group: string;
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                policy_summary: {
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    review_status: string;
                    approval_status: string;
                };
                ad_strength: string;
            };
            update: {
                resource_name: string;
                status: string;
                ad_group: string;
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                policy_summary: {
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    review_status: string;
                    approval_status: string;
                };
                ad_strength: string;
            };
            remove: string;
        };
        ad_group_bid_modifier_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                ad_group: string;
                criterion_id: string;
                bid_modifier: string;
                base_ad_group: string;
                bid_modifier_source: string;
                hotel_date_selection_type: {
                    type: string;
                };
                hotel_advance_booking_window: {
                    min_days: string;
                    max_days: string;
                };
                hotel_length_of_stay: {
                    min_nights: string;
                    max_nights: string;
                };
                hotel_check_in_day: {
                    day_of_week: string;
                };
                device: {
                    type: string;
                };
                preferred_content: {
                    type: string;
                };
            };
            update: {
                resource_name: string;
                ad_group: string;
                criterion_id: string;
                bid_modifier: string;
                base_ad_group: string;
                bid_modifier_source: string;
                hotel_date_selection_type: {
                    type: string;
                };
                hotel_advance_booking_window: {
                    min_days: string;
                    max_days: string;
                };
                hotel_length_of_stay: {
                    min_nights: string;
                    max_nights: string;
                };
                hotel_check_in_day: {
                    day_of_week: string;
                };
                device: {
                    type: string;
                };
                preferred_content: {
                    type: string;
                };
            };
            remove: string;
        };
        ad_group_criterion_label_operation: {
            create: {
                resource_name: string;
                ad_group_criterion: string;
                label: string;
            };
            remove: string;
        };
        ad_group_criterion_operation: {
            update_mask: {
                paths: string;
            };
            exempt_policy_violation_keys: {
                policy_name: string;
                violating_text: string;
            };
            create: {
                resource_name: string;
                criterion_id: string;
                status: string;
                quality_info: {
                    quality_score: string;
                    creative_quality_score: string;
                    post_click_quality_score: string;
                    search_predicted_ctr: string;
                };
                ad_group: string;
                type: string;
                negative: string;
                system_serving_status: string;
                approval_status: string;
                bid_modifier: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                cpv_bid_micros: string;
                percent_cpc_bid_micros: string;
                effective_cpc_bid_micros: string;
                effective_cpm_bid_micros: string;
                effective_cpv_bid_micros: string;
                effective_percent_cpc_bid_micros: string;
                effective_cpc_bid_source: string;
                effective_cpm_bid_source: string;
                effective_cpv_bid_source: string;
                effective_percent_cpc_bid_source: string;
                position_estimates: {
                    first_page_cpc_micros: string;
                    first_position_cpc_micros: string;
                    top_of_page_cpc_micros: string;
                    estimated_add_clicks_at_first_position_cpc: string;
                    estimated_add_cost_at_first_position_cpc: string;
                };
                final_urls: string;
                final_mobile_urls: string;
                final_url_suffix: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                listing_group: {
                    type: string;
                    case_value: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                    parent_ad_group_criterion: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                app_payment_model: {
                    type: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
                custom_intent: {
                    custom_intent: string;
                };
            };
            update: {
                resource_name: string;
                criterion_id: string;
                status: string;
                quality_info: {
                    quality_score: string;
                    creative_quality_score: string;
                    post_click_quality_score: string;
                    search_predicted_ctr: string;
                };
                ad_group: string;
                type: string;
                negative: string;
                system_serving_status: string;
                approval_status: string;
                bid_modifier: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                cpv_bid_micros: string;
                percent_cpc_bid_micros: string;
                effective_cpc_bid_micros: string;
                effective_cpm_bid_micros: string;
                effective_cpv_bid_micros: string;
                effective_percent_cpc_bid_micros: string;
                effective_cpc_bid_source: string;
                effective_cpm_bid_source: string;
                effective_cpv_bid_source: string;
                effective_percent_cpc_bid_source: string;
                position_estimates: {
                    first_page_cpc_micros: string;
                    first_position_cpc_micros: string;
                    top_of_page_cpc_micros: string;
                    estimated_add_clicks_at_first_position_cpc: string;
                    estimated_add_cost_at_first_position_cpc: string;
                };
                final_urls: string;
                final_mobile_urls: string;
                final_url_suffix: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                listing_group: {
                    type: string;
                    case_value: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                    parent_ad_group_criterion: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                app_payment_model: {
                    type: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
                custom_intent: {
                    custom_intent: string;
                };
            };
            remove: string;
        };
        ad_group_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                ad_group: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                ad_group: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        ad_group_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                ad_group: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                ad_group: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        ad_group_label_operation: {
            create: {
                resource_name: string;
                ad_group: string;
                label: string;
            };
            remove: string;
        };
        ad_group_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                ad_rotation_mode: string;
                base_ad_group: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                campaign: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                target_cpa_micros: string;
                cpv_bid_micros: string;
                target_cpm_micros: string;
                target_roas: string;
                percent_cpc_bid_micros: string;
                explorer_auto_optimizer_setting: {
                    opt_in: string;
                };
                display_custom_bid_dimension: string;
                final_url_suffix: string;
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                effective_target_cpa_micros: string;
                effective_target_cpa_source: string;
                effective_target_roas: string;
                effective_target_roas_source: string;
                labels: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                ad_rotation_mode: string;
                base_ad_group: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                campaign: string;
                cpc_bid_micros: string;
                cpm_bid_micros: string;
                target_cpa_micros: string;
                cpv_bid_micros: string;
                target_cpm_micros: string;
                target_roas: string;
                percent_cpc_bid_micros: string;
                explorer_auto_optimizer_setting: {
                    opt_in: string;
                };
                display_custom_bid_dimension: string;
                final_url_suffix: string;
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                effective_target_cpa_micros: string;
                effective_target_cpa_source: string;
                effective_target_roas: string;
                effective_target_roas_source: string;
                labels: string;
            };
            remove: string;
        };
        ad_parameter_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                ad_group_criterion: string;
                parameter_index: string;
                insertion_text: string;
            };
            update: {
                resource_name: string;
                ad_group_criterion: string;
                parameter_index: string;
                insertion_text: string;
            };
            remove: string;
        };
        asset_operation: {
            create: {
                resource_name: string;
                id: string;
                name: string;
                type: string;
                youtube_video_asset: {
                    youtube_video_id: string;
                };
                media_bundle_asset: {
                    data: string;
                };
                image_asset: {
                    data: string;
                    file_size: string;
                    mime_type: string;
                    full_size: {
                        height_pixels: string;
                        width_pixels: string;
                        url: string;
                    };
                };
                text_asset: {
                    text: string;
                };
            };
        };
        bidding_strategy_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                campaign_count: string;
                non_removed_campaign_count: string;
                enhanced_cpc: {};
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                campaign_count: string;
                non_removed_campaign_count: string;
                enhanced_cpc: {};
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
            };
            remove: string;
        };
        campaign_bid_modifier_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                interaction_type: {
                    type: string;
                };
            };
            update: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                interaction_type: {
                    type: string;
                };
            };
            remove: string;
        };
        campaign_budget_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                amount_micros: string;
                total_amount_micros: string;
                status: string;
                delivery_method: string;
                explicitly_shared: string;
                reference_count: string;
                has_recommended_budget: string;
                recommended_budget_amount_micros: string;
                period: string;
                recommended_budget_estimated_change_weekly_clicks: string;
                recommended_budget_estimated_change_weekly_cost_micros: string;
                recommended_budget_estimated_change_weekly_interactions: string;
                recommended_budget_estimated_change_weekly_views: string;
                type: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                amount_micros: string;
                total_amount_micros: string;
                status: string;
                delivery_method: string;
                explicitly_shared: string;
                reference_count: string;
                has_recommended_budget: string;
                recommended_budget_amount_micros: string;
                period: string;
                recommended_budget_estimated_change_weekly_clicks: string;
                recommended_budget_estimated_change_weekly_cost_micros: string;
                recommended_budget_estimated_change_weekly_interactions: string;
                recommended_budget_estimated_change_weekly_views: string;
                type: string;
            };
            remove: string;
        };
        campaign_criterion_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                negative: string;
                type: string;
                status: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                location: {
                    geo_target_constant: string;
                };
                device: {
                    type: string;
                };
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                proximity: {
                    geo_point: {
                        longitude_in_micro_degrees: string;
                        latitude_in_micro_degrees: string;
                    };
                    radius: string;
                    radius_units: string;
                    address: {
                        postal_code: string;
                        province_code: string;
                        country_code: string;
                        province_name: string;
                        street_address: string;
                        street_address2: string;
                        city_name: string;
                    };
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                listing_scope: {
                    dimensions: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                };
                language: {
                    language_constant: string;
                };
                ip_block: {
                    ip_address: string;
                };
                content_label: {
                    type: string;
                };
                carrier: {
                    carrier_constant: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                operating_system_version: {
                    operating_system_version_constant: string;
                };
                mobile_device: {
                    mobile_device_constant: string;
                };
                location_group: {
                    feed: string;
                    geo_target_constants: string;
                    radius: string;
                    radius_units: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
            };
            update: {
                resource_name: string;
                campaign: string;
                criterion_id: string;
                bid_modifier: string;
                negative: string;
                type: string;
                status: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                location: {
                    geo_target_constant: string;
                };
                device: {
                    type: string;
                };
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                age_range: {
                    type: string;
                };
                gender: {
                    type: string;
                };
                income_range: {
                    type: string;
                };
                parental_status: {
                    type: string;
                };
                user_list: {
                    user_list: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                proximity: {
                    geo_point: {
                        longitude_in_micro_degrees: string;
                        latitude_in_micro_degrees: string;
                    };
                    radius: string;
                    radius_units: string;
                    address: {
                        postal_code: string;
                        province_code: string;
                        country_code: string;
                        province_name: string;
                        street_address: string;
                        street_address2: string;
                        city_name: string;
                    };
                };
                topic: {
                    topic_constant: string;
                    path: string;
                };
                listing_scope: {
                    dimensions: {
                        hotel_id: {
                            value: string;
                        };
                        hotel_class: {
                            value: string;
                        };
                        hotel_country_region: {
                            country_region_criterion: string;
                        };
                        hotel_state: {
                            state_criterion: string;
                        };
                        hotel_city: {
                            city_criterion: string;
                        };
                        product_bidding_category: {
                            id: string;
                            country_code: string;
                            level: string;
                        };
                        product_brand: {
                            value: string;
                        };
                        product_channel: {
                            channel: string;
                        };
                        product_channel_exclusivity: {
                            channel_exclusivity: string;
                        };
                        product_condition: {
                            condition: string;
                        };
                        product_custom_attribute: {
                            value: string;
                            index: string;
                        };
                        product_item_id: {
                            value: string;
                        };
                        product_type: {
                            value: string;
                            level: string;
                        };
                        unknown_listing_dimension: {};
                    };
                };
                language: {
                    language_constant: string;
                };
                ip_block: {
                    ip_address: string;
                };
                content_label: {
                    type: string;
                };
                carrier: {
                    carrier_constant: string;
                };
                user_interest: {
                    user_interest_category: string;
                };
                webpage: {
                    criterion_name: string;
                    conditions: {
                        operand: string;
                        operator: string;
                        argument: string;
                    };
                };
                operating_system_version: {
                    operating_system_version_constant: string;
                };
                mobile_device: {
                    mobile_device_constant: string;
                };
                location_group: {
                    feed: string;
                    geo_target_constants: string;
                    radius: string;
                    radius_units: string;
                };
                custom_affinity: {
                    custom_affinity: string;
                };
            };
            remove: string;
        };
        campaign_draft_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                draft_id: string;
                base_campaign: string;
                name: string;
                draft_campaign: string;
                status: string;
                has_experiment_running: string;
                long_running_operation: string;
            };
            update: {
                resource_name: string;
                draft_id: string;
                base_campaign: string;
                name: string;
                draft_campaign: string;
                status: string;
                has_experiment_running: string;
                long_running_operation: string;
            };
            remove: string;
        };
        campaign_experiment_operation: {
            update_mask: {
                paths: string;
            };
            update: {
                resource_name: string;
                id: string;
                campaign_draft: string;
                name: string;
                description: string;
                traffic_split_percent: string;
                traffic_split_type: string;
                experiment_campaign: string;
                status: string;
                long_running_operation: string;
                start_date: string;
                end_date: string;
            };
            remove: string;
        };
        campaign_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                campaign: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                campaign: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        campaign_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                campaign: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                campaign: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        campaign_label_operation: {
            create: {
                resource_name: string;
                campaign: string;
                label: string;
            };
            remove: string;
        };
        campaign_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                serving_status: string;
                ad_serving_optimization_status: string;
                advertising_channel_type: string;
                advertising_channel_sub_type: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                real_time_bidding_setting: {
                    opt_in: string;
                };
                network_settings: {
                    target_google_search: string;
                    target_search_network: string;
                    target_content_network: string;
                    target_partner_search_network: string;
                };
                hotel_setting: {
                    hotel_center_id: string;
                };
                dynamic_search_ads_setting: {
                    domain_name: string;
                    language_code: string;
                    use_supplied_urls_only: string;
                    feeds: string;
                };
                shopping_setting: {
                    merchant_id: string;
                    sales_country: string;
                    campaign_priority: string;
                    enable_local: string;
                };
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                geo_target_type_setting: {
                    positive_geo_target_type: string;
                    negative_geo_target_type: string;
                };
                app_campaign_setting: {
                    bidding_strategy_goal_type: string;
                    app_id: string;
                    app_store: string;
                };
                labels: string;
                experiment_type: string;
                base_campaign: string;
                campaign_budget: string;
                bidding_strategy_type: string;
                start_date: string;
                end_date: string;
                final_url_suffix: string;
                frequency_caps: {
                    key: {
                        level: string;
                        event_type: string;
                        time_unit: string;
                        time_length: string;
                    };
                    cap: string;
                };
                video_brand_safety_suitability: string;
                vanity_pharma: {
                    vanity_pharma_display_url_mode: string;
                    vanity_pharma_text: string;
                };
                selective_optimization: {
                    conversion_actions: string;
                };
                tracking_setting: {
                    tracking_url: string;
                };
                payment_mode: string;
                bidding_strategy: string;
                commission: {
                    commission_rate_micros: string;
                };
                manual_cpc: {
                    enhanced_cpc_enabled: string;
                };
                manual_cpm: {};
                manual_cpv: {};
                maximize_conversions: {};
                maximize_conversion_value: {
                    target_roas: string;
                };
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                percent_cpc: {
                    cpc_bid_ceiling_micros: string;
                    enhanced_cpc_enabled: string;
                };
                target_cpm: {};
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                serving_status: string;
                ad_serving_optimization_status: string;
                advertising_channel_type: string;
                advertising_channel_sub_type: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                real_time_bidding_setting: {
                    opt_in: string;
                };
                network_settings: {
                    target_google_search: string;
                    target_search_network: string;
                    target_content_network: string;
                    target_partner_search_network: string;
                };
                hotel_setting: {
                    hotel_center_id: string;
                };
                dynamic_search_ads_setting: {
                    domain_name: string;
                    language_code: string;
                    use_supplied_urls_only: string;
                    feeds: string;
                };
                shopping_setting: {
                    merchant_id: string;
                    sales_country: string;
                    campaign_priority: string;
                    enable_local: string;
                };
                targeting_setting: {
                    target_restrictions: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                    target_restriction_operations: {
                        operator: {};
                        value: {
                            targeting_dimension: string;
                            bid_only: string;
                        };
                    };
                };
                geo_target_type_setting: {
                    positive_geo_target_type: string;
                    negative_geo_target_type: string;
                };
                app_campaign_setting: {
                    bidding_strategy_goal_type: string;
                    app_id: string;
                    app_store: string;
                };
                labels: string;
                experiment_type: string;
                base_campaign: string;
                campaign_budget: string;
                bidding_strategy_type: string;
                start_date: string;
                end_date: string;
                final_url_suffix: string;
                frequency_caps: {
                    key: {
                        level: string;
                        event_type: string;
                        time_unit: string;
                        time_length: string;
                    };
                    cap: string;
                };
                video_brand_safety_suitability: string;
                vanity_pharma: {
                    vanity_pharma_display_url_mode: string;
                    vanity_pharma_text: string;
                };
                selective_optimization: {
                    conversion_actions: string;
                };
                tracking_setting: {
                    tracking_url: string;
                };
                payment_mode: string;
                bidding_strategy: string;
                commission: {
                    commission_rate_micros: string;
                };
                manual_cpc: {
                    enhanced_cpc_enabled: string;
                };
                manual_cpm: {};
                manual_cpv: {};
                maximize_conversions: {};
                maximize_conversion_value: {
                    target_roas: string;
                };
                target_cpa: {
                    target_cpa_micros: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_impression_share: {
                    location: string;
                    location_fraction_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                target_roas: {
                    target_roas: string;
                    cpc_bid_ceiling_micros: string;
                    cpc_bid_floor_micros: string;
                };
                target_spend: {
                    target_spend_micros: string;
                    cpc_bid_ceiling_micros: string;
                };
                percent_cpc: {
                    cpc_bid_ceiling_micros: string;
                    enhanced_cpc_enabled: string;
                };
                target_cpm: {};
            };
            remove: string;
        };
        campaign_shared_set_operation: {
            create: {
                resource_name: string;
                campaign: string;
                shared_set: string;
                status: string;
            };
            remove: string;
        };
        conversion_action_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                category: string;
                owner_customer: string;
                include_in_conversions_metric: string;
                click_through_lookback_window_days: string;
                view_through_lookback_window_days: string;
                value_settings: {
                    default_value: string;
                    default_currency_code: string;
                    always_use_default_value: string;
                };
                counting_type: string;
                attribution_model_settings: {
                    attribution_model: string;
                    data_driven_model_status: string;
                };
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
                phone_call_duration_seconds: string;
                app_id: string;
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                status: string;
                type: string;
                category: string;
                owner_customer: string;
                include_in_conversions_metric: string;
                click_through_lookback_window_days: string;
                view_through_lookback_window_days: string;
                value_settings: {
                    default_value: string;
                    default_currency_code: string;
                    always_use_default_value: string;
                };
                counting_type: string;
                attribution_model_settings: {
                    attribution_model: string;
                    data_driven_model_status: string;
                };
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
                phone_call_duration_seconds: string;
                app_id: string;
            };
            remove: string;
        };
        customer_extension_setting_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                extension_type: string;
                extension_feed_items: string;
                device: string;
            };
            update: {
                resource_name: string;
                extension_type: string;
                extension_feed_items: string;
                device: string;
            };
            remove: string;
        };
        customer_feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            update: {
                resource_name: string;
                feed: string;
                placeholder_types: string;
                matching_function: {
                    function_string: string;
                    operator: string;
                    left_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                    right_operands: {
                        constant_operand: {
                            string_value: string;
                            long_value: string;
                            boolean_value: string;
                            double_value: string;
                        };
                        feed_attribute_operand: {
                            feed_id: string;
                            feed_attribute_id: string;
                        };
                        function_operand: null;
                        request_context_operand: {
                            context_type: string;
                        };
                    };
                };
                status: string;
            };
            remove: string;
        };
        customer_label_operation: {
            create: {
                resource_name: string;
                customer: string;
                label: string;
            };
            remove: string;
        };
        customer_negative_criterion_operation: {
            create: {
                resource_name: string;
                id: string;
                type: string;
                content_label: {
                    type: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                placement: {
                    url: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
            };
            remove: string;
        };
        customer_operation: {
            update: {
                resource_name: string;
                id: string;
                descriptive_name: string;
                currency_code: string;
                time_zone: string;
                tracking_url_template: string;
                final_url_suffix: string;
                auto_tagging_enabled: string;
                has_partners_badge: string;
                manager: string;
                test_account: string;
                call_reporting_setting: {
                    call_reporting_enabled: string;
                    call_conversion_reporting_enabled: string;
                    call_conversion_action: string;
                };
                conversion_tracking_setting: {
                    conversion_tracking_id: string;
                    cross_account_conversion_tracking_id: string;
                };
                remarketing_setting: {
                    google_global_site_tag: string;
                };
                pay_per_conversion_eligibility_failure_reasons: string;
            };
            update_mask: {
                paths: string;
            };
        };
        extension_feed_item_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                extension_type: string;
                start_date_time: string;
                end_date_time: string;
                ad_schedules: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                device: string;
                targeted_geo_target_constant: string;
                targeted_keyword: {
                    text: string;
                    match_type: string;
                };
                status: string;
                sitelink_feed_item: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                structured_snippet_feed_item: {
                    header: string;
                    values: string;
                };
                app_feed_item: {
                    link_text: string;
                    app_id: string;
                    app_store: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                call_feed_item: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
                callout_feed_item: {
                    callout_text: string;
                };
                text_message_feed_item: {
                    business_name: string;
                    country_code: string;
                    phone_number: string;
                    text: string;
                    extension_text: string;
                };
                price_feed_item: {
                    type: string;
                    price_qualifier: string;
                    tracking_url_template: string;
                    language_code: string;
                    price_offerings: {
                        header: string;
                        description: string;
                        price: {
                            currency_code: string;
                            amount_micros: string;
                        };
                        unit: string;
                        final_urls: string;
                        final_mobile_urls: string;
                    };
                    final_url_suffix: string;
                };
                promotion_feed_item: {
                    promotion_target: string;
                    discount_modifier: string;
                    promotion_start_date: string;
                    promotion_end_date: string;
                    occasion: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                    language_code: string;
                    percent_off: string;
                    money_amount_off: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    promotion_code: string;
                    orders_over_amount: {
                        currency_code: string;
                        amount_micros: string;
                    };
                };
                location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                };
                affiliate_location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                    chain_id: string;
                    chain_name: string;
                };
                hotel_callout_feed_item: {
                    text: string;
                    language_code: string;
                };
                targeted_campaign: string;
                targeted_ad_group: string;
            };
            update: {
                resource_name: string;
                id: string;
                extension_type: string;
                start_date_time: string;
                end_date_time: string;
                ad_schedules: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
                device: string;
                targeted_geo_target_constant: string;
                targeted_keyword: {
                    text: string;
                    match_type: string;
                };
                status: string;
                sitelink_feed_item: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                structured_snippet_feed_item: {
                    header: string;
                    values: string;
                };
                app_feed_item: {
                    link_text: string;
                    app_id: string;
                    app_store: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
                call_feed_item: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
                callout_feed_item: {
                    callout_text: string;
                };
                text_message_feed_item: {
                    business_name: string;
                    country_code: string;
                    phone_number: string;
                    text: string;
                    extension_text: string;
                };
                price_feed_item: {
                    type: string;
                    price_qualifier: string;
                    tracking_url_template: string;
                    language_code: string;
                    price_offerings: {
                        header: string;
                        description: string;
                        price: {
                            currency_code: string;
                            amount_micros: string;
                        };
                        unit: string;
                        final_urls: string;
                        final_mobile_urls: string;
                    };
                    final_url_suffix: string;
                };
                promotion_feed_item: {
                    promotion_target: string;
                    discount_modifier: string;
                    promotion_start_date: string;
                    promotion_end_date: string;
                    occasion: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                    language_code: string;
                    percent_off: string;
                    money_amount_off: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    promotion_code: string;
                    orders_over_amount: {
                        currency_code: string;
                        amount_micros: string;
                    };
                };
                location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                };
                affiliate_location_feed_item: {
                    business_name: string;
                    address_line1: string;
                    address_line2: string;
                    city: string;
                    province: string;
                    postal_code: string;
                    country_code: string;
                    phone_number: string;
                    chain_id: string;
                    chain_name: string;
                };
                hotel_callout_feed_item: {
                    text: string;
                    language_code: string;
                };
                targeted_campaign: string;
                targeted_ad_group: string;
            };
            remove: string;
        };
        feed_item_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                feed: string;
                id: string;
                start_date_time: string;
                end_date_time: string;
                attribute_values: {
                    feed_attribute_id: string;
                    integer_value: string;
                    boolean_value: string;
                    string_value: string;
                    double_value: string;
                    price_value: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    integer_values: string;
                    boolean_values: string;
                    string_values: string;
                    double_values: string;
                };
                geo_targeting_restriction: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                status: string;
                policy_infos: {
                    placeholder_type_enum: string;
                    feed_mapping_resource_name: string;
                    review_status: string;
                    approval_status: string;
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    validation_status: string;
                    validation_errors: {};
                    quality_approval_status: string;
                    quality_disapproval_reasons: string;
                };
            };
            update: {
                resource_name: string;
                feed: string;
                id: string;
                start_date_time: string;
                end_date_time: string;
                attribute_values: {
                    feed_attribute_id: string;
                    integer_value: string;
                    boolean_value: string;
                    string_value: string;
                    double_value: string;
                    price_value: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    integer_values: string;
                    boolean_values: string;
                    string_values: string;
                    double_values: string;
                };
                geo_targeting_restriction: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                status: string;
                policy_infos: {
                    placeholder_type_enum: string;
                    feed_mapping_resource_name: string;
                    review_status: string;
                    approval_status: string;
                    policy_topic_entries: {
                        topic: string;
                        type: string;
                        evidences: {
                            website_list: {
                                websites: string;
                            };
                            text_list: {
                                texts: string;
                            };
                            language_code: string;
                            destination_text_list: {
                                destination_texts: string;
                            };
                            destination_mismatch: {
                                url_types: string;
                            };
                            destination_not_working: {
                                expanded_url: string;
                                device: string;
                                last_checked_date_time: string;
                                dns_error_type: string;
                                http_error_code: string;
                            };
                        };
                        constraints: {
                            country_constraint_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            reseller_constraint: {};
                            certificate_missing_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                            certificate_domain_mismatch_in_country_list: {
                                total_targeted_countries: string;
                                countries: {
                                    country_criterion: string;
                                };
                            };
                        };
                    };
                    validation_status: string;
                    validation_errors: {};
                    quality_approval_status: string;
                    quality_disapproval_reasons: string;
                };
            };
            remove: string;
        };
        feed_item_target_operation: {
            create: {
                resource_name: string;
                feed_item: string;
                feed_item_target_type: string;
                feed_item_target_id: string;
                status: string;
                campaign: string;
                ad_group: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                geo_target_constant: string;
                device: string;
                ad_schedule: {
                    start_minute: string;
                    end_minute: string;
                    start_hour: string;
                    end_hour: string;
                    day_of_week: string;
                };
            };
            remove: string;
        };
        feed_mapping_operation: {
            create: {
                resource_name: string;
                feed: string;
                attribute_field_mappings: {
                    feed_attribute_id: string;
                    field_id: string;
                    sitelink_field: string;
                    call_field: string;
                    app_field: string;
                    location_field: string;
                    affiliate_location_field: string;
                    callout_field: string;
                    structured_snippet_field: string;
                    message_field: string;
                    price_field: string;
                    promotion_field: string;
                    ad_customizer_field: string;
                    dsa_page_feed_field: string;
                    location_extension_targeting_field: string;
                    education_field: string;
                    flight_field: string;
                    custom_field: string;
                    hotel_field: string;
                    real_estate_field: string;
                    travel_field: string;
                    local_field: string;
                    job_field: string;
                };
                status: string;
                placeholder_type: string;
                criterion_type: string;
            };
            remove: string;
        };
        feed_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                attributes: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
                attribute_operations: {
                    operator: {};
                    value: {
                        id: string;
                        name: string;
                        type: string;
                        is_part_of_key: string;
                    };
                };
                origin: string;
                status: string;
                places_location_feed_data: {
                    oauth_info: {
                        http_method: string;
                        http_request_url: string;
                        http_authorization_header: string;
                    };
                    email_address: string;
                    business_account_id: string;
                    business_name_filter: string;
                    category_filters: string;
                    label_filters: string;
                };
                affiliate_location_feed_data: {
                    chain_ids: string;
                    relationship_type: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                attributes: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
                attribute_operations: {
                    operator: {};
                    value: {
                        id: string;
                        name: string;
                        type: string;
                        is_part_of_key: string;
                    };
                };
                origin: string;
                status: string;
                places_location_feed_data: {
                    oauth_info: {
                        http_method: string;
                        http_request_url: string;
                        http_authorization_header: string;
                    };
                    email_address: string;
                    business_account_id: string;
                    business_name_filter: string;
                    category_filters: string;
                    label_filters: string;
                };
                affiliate_location_feed_data: {
                    chain_ids: string;
                    relationship_type: string;
                };
            };
            remove: string;
        };
        label_operation: {
            update_mask: {
                paths: string;
            };
            create: {};
            update: {};
            remove: string;
        };
        media_file_operation: {
            create: {
                resource_name: string;
                id: string;
                type: string;
                mime_type: string;
                source_url: string;
                name: string;
                file_size: string;
                image: {
                    data: string;
                };
                media_bundle: {
                    data: string;
                };
                audio: {
                    ad_duration_millis: string;
                };
                video: {
                    ad_duration_millis: string;
                    youtube_video_id: string;
                    advertising_id_code: string;
                    isci_code: string;
                };
            };
        };
        remarketing_action_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                name: string;
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
            };
            update: {
                resource_name: string;
                id: string;
                name: string;
                tag_snippets: {
                    type: string;
                    page_format: string;
                    global_site_tag: string;
                    event_snippet: string;
                };
            };
        };
        shared_criterion_operation: {
            create: {
                resource_name: string;
                shared_set: string;
                criterion_id: string;
                type: string;
                keyword: {
                    text: string;
                    match_type: string;
                };
                youtube_video: {
                    video_id: string;
                };
                youtube_channel: {
                    channel_id: string;
                };
                placement: {
                    url: string;
                };
                mobile_app_category: {
                    mobile_app_category_constant: string;
                };
                mobile_application: {
                    app_id: string;
                    name: string;
                };
            };
            remove: string;
        };
        shared_set_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                type: string;
                name: string;
                status: string;
                member_count: string;
                reference_count: string;
            };
            update: {
                resource_name: string;
                id: string;
                type: string;
                name: string;
                status: string;
                member_count: string;
                reference_count: string;
            };
            remove: string;
        };
        user_list_operation: {
            update_mask: {
                paths: string;
            };
            create: {
                resource_name: string;
                id: string;
                read_only: string;
                name: string;
                description: string;
                membership_status: string;
                integration_code: string;
                membership_life_span: string;
                size_for_display: string;
                size_range_for_display: string;
                size_for_search: string;
                size_range_for_search: string;
                type: string;
                closing_reason: string;
                access_reason: string;
                account_user_list_status: string;
                eligible_for_search: string;
                eligible_for_display: string;
                crm_based_user_list: {
                    app_id: string;
                    upload_key_type: string;
                    data_source_type: string;
                };
                similar_user_list: {
                    seed_user_list: string;
                };
                rule_based_user_list: {
                    prepopulation_status: string;
                    combined_rule_user_list: {
                        left_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        right_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        rule_operator: string;
                    };
                    date_specific_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        start_date: string;
                        end_date: string;
                    };
                    expression_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                    };
                };
                logical_user_list: {
                    rules: {
                        operator: string;
                        rule_operands: {
                            user_list: string;
                        };
                    };
                };
                basic_user_list: {
                    actions: {
                        conversion_action: string;
                        remarketing_action: string;
                    };
                };
            };
            update: {
                resource_name: string;
                id: string;
                read_only: string;
                name: string;
                description: string;
                membership_status: string;
                integration_code: string;
                membership_life_span: string;
                size_for_display: string;
                size_range_for_display: string;
                size_for_search: string;
                size_range_for_search: string;
                type: string;
                closing_reason: string;
                access_reason: string;
                account_user_list_status: string;
                eligible_for_search: string;
                eligible_for_display: string;
                crm_based_user_list: {
                    app_id: string;
                    upload_key_type: string;
                    data_source_type: string;
                };
                similar_user_list: {
                    seed_user_list: string;
                };
                rule_based_user_list: {
                    prepopulation_status: string;
                    combined_rule_user_list: {
                        left_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        right_operand: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        rule_operator: string;
                    };
                    date_specific_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                        start_date: string;
                        end_date: string;
                    };
                    expression_rule_user_list: {
                        rule: {
                            rule_type: string;
                            rule_item_groups: {
                                rule_items: {
                                    name: string;
                                    number_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    string_rule_item: {
                                        operator: string;
                                        value: string;
                                    };
                                    date_rule_item: {
                                        operator: string;
                                        value: string;
                                        offset_in_days: string;
                                    };
                                };
                            };
                        };
                    };
                };
                logical_user_list: {
                    rules: {
                        operator: string;
                        rule_operands: {
                            user_list: string;
                        };
                    };
                };
                basic_user_list: {
                    actions: {
                        conversion_action: string;
                        remarketing_action: string;
                    };
                };
            };
            remove: string;
        };
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateGoogleAdsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    mutate_operation_responses: {
        ad_group_ad_label_result: {
            resource_name: string;
        };
        ad_group_ad_result: {
            resource_name: string;
        };
        ad_group_bid_modifier_result: {
            resource_name: string;
        };
        ad_group_criterion_label_result: {
            resource_name: string;
        };
        ad_group_criterion_result: {
            resource_name: string;
        };
        ad_group_extension_setting_result: {
            resource_name: string;
        };
        ad_group_feed_result: {
            resource_name: string;
        };
        ad_group_label_result: {
            resource_name: string;
        };
        ad_group_result: {
            resource_name: string;
        };
        ad_parameter_result: {
            resource_name: string;
        };
        asset_result: {
            resource_name: string;
        };
        bidding_strategy_result: {
            resource_name: string;
        };
        campaign_bid_modifier_result: {
            resource_name: string;
        };
        campaign_budget_result: {
            resource_name: string;
        };
        campaign_criterion_result: {
            resource_name: string;
        };
        campaign_draft_result: {
            resource_name: string;
        };
        campaign_experiment_result: {
            resource_name: string;
        };
        campaign_extension_setting_result: {
            resource_name: string;
        };
        campaign_feed_result: {
            resource_name: string;
        };
        campaign_label_result: {
            resource_name: string;
        };
        campaign_result: {
            resource_name: string;
        };
        campaign_shared_set_result: {
            resource_name: string;
        };
        conversion_action_result: {
            resource_name: string;
        };
        customer_extension_setting_result: {
            resource_name: string;
        };
        customer_feed_result: {
            resource_name: string;
        };
        customer_label_result: {
            resource_name: string;
        };
        customer_negative_criterion_result: {
            resource_name: string;
        };
        customer_result: {
            resource_name: string;
        };
        extension_feed_item_result: {
            resource_name: string;
        };
        feed_item_result: {
            resource_name: string;
        };
        feed_item_target_result: {
            resource_name: string;
        };
        feed_mapping_result: {
            resource_name: string;
        };
        feed_result: {
            resource_name: string;
        };
        label_result: {
            resource_name: string;
        };
        media_file_result: {
            resource_name: string;
        };
        remarketing_action_result: {
            resource_name: string;
        };
        shared_criterion_result: {
            resource_name: string;
        };
        shared_set_result: {
            resource_name: string;
        };
        user_list_result: {
            resource_name: string;
        };
    };
};
export declare const MutateJobService: {};
export declare const KeywordPlanAdGroupOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        name: string;
        cpc_bid_micros: string;
    };
    update: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        name: string;
        cpc_bid_micros: string;
    };
    remove: string;
};
export declare const MutateKeywordPlanAdGroupsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        update: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateKeywordPlanAdGroupResult: {
    resource_name: string;
};
export declare const MutateKeywordPlanAdGroupsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const KeywordPlanCampaignOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        keyword_plan: string;
        id: string;
        name: string;
        language_constants: string;
        keyword_plan_network: string;
        cpc_bid_micros: string;
        geo_targets: {
            geo_target_constant: string;
        };
    };
    update: {
        resource_name: string;
        keyword_plan: string;
        id: string;
        name: string;
        language_constants: string;
        keyword_plan_network: string;
        cpc_bid_micros: string;
        geo_targets: {
            geo_target_constant: string;
        };
    };
    remove: string;
};
export declare const MutateKeywordPlanCampaignsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        update: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateKeywordPlanCampaignResult: {
    resource_name: string;
};
export declare const MutateKeywordPlanCampaignsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const KeywordPlanKeywordOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        keyword_plan_ad_group: string;
        id: string;
        text: string;
        match_type: string;
        cpc_bid_micros: string;
    };
    update: {
        resource_name: string;
        keyword_plan_ad_group: string;
        id: string;
        text: string;
        match_type: string;
        cpc_bid_micros: string;
    };
    remove: string;
};
export declare const MutateKeywordPlanKeywordsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        update: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateKeywordPlanKeywordResult: {
    resource_name: string;
};
export declare const MutateKeywordPlanKeywordsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const KeywordPlanNegativeKeywordOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        text: string;
        match_type: string;
    };
    update: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        text: string;
        match_type: string;
    };
    remove: string;
};
export declare const MutateKeywordPlanNegativeKeywordsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        update: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateKeywordPlanNegativeKeywordResult: {
    resource_name: string;
};
export declare const MutateKeywordPlanNegativeKeywordsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const KeywordPlanOperation: {
    update_mask: {
        paths: string;
    };
    create: {
        resource_name: string;
        id: string;
        name: string;
        forecast_period: {
            date_interval: string;
            date_range: {
                start_date: string;
                end_date: string;
            };
        };
    };
    update: {
        resource_name: string;
        id: string;
        name: string;
        forecast_period: {
            date_interval: string;
            date_range: {
                start_date: string;
                end_date: string;
            };
        };
    };
    remove: string;
};
export declare const MutateKeywordPlansRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateKeywordPlansResult: {
    resource_name: string;
};
export declare const MutateKeywordPlansResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateLabelsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {};
        update: {};
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateLabelsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateMediaFilesRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateMediaFilesResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MerchantCenterLinkOperation: {
    update_mask: {
        paths: string;
    };
    update: {
        resource_name: string;
        id: string;
        merchant_center_account_name: string;
        status: string;
    };
    remove: string;
};
export declare const MutateMerchantCenterLinkRequest: {
    customer_id: string;
    operation: {
        update_mask: {
            paths: string;
        };
        update: {
            resource_name: string;
            id: string;
            merchant_center_account_name: string;
            status: string;
        };
        remove: string;
    };
};
export declare const MutateMerchantCenterLinkResult: {
    resource_name: string;
};
export declare const MutateMerchantCenterLinkResponse: {
    result: {
        resource_name: string;
    };
};
export declare const MutateRemarketingActionsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        update: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateRemarketingActionsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateSharedCriteriaRequest: {
    customer_id: string;
    operations: {
        create: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateSharedCriteriaResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateSharedSetsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        update: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateSharedSetsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const MutateUserListsRequest: {
    customer_id: string;
    operations: {
        update_mask: {
            paths: string;
        };
        create: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        update: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        remove: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const MutateUserListsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        resource_name: string;
    };
};
export declare const OperatingSystemVersionConstantService: {};
export declare const PaidOrganicSearchTermViewService: {};
export declare const ParentalStatusViewService: {};
export declare const PaymentsAccountService: {};
export declare const ProductBiddingCategoryConstantService: {};
export declare const ProductGroupViewService: {};
export declare const PromoteCampaignDraftRequest: {
    campaign_draft: string;
};
export declare const PromoteCampaignExperimentRequest: {
    campaign_experiment: string;
};
export declare const ReachPlanService: {};
export declare const RecommendationService: {};
export declare const RemarketingActionService: {};
export declare const RunMutateJobRequest: {
    resource_name: string;
};
export declare const SearchGoogleAdsFieldsRequest: {
    query: string;
    page_token: string;
    page_size: string;
};
export declare const SearchGoogleAdsFieldsResponse: {
    results: {
        resource_name: string;
        name: string;
        category: string;
        selectable: string;
        filterable: string;
        sortable: string;
        selectable_with: string;
        attribute_resources: string;
        metrics: string;
        segments: string;
        enum_values: string;
        data_type: string;
        type_url: string;
        is_repeated: string;
    };
    next_page_token: string;
    total_results_count: string;
};
export declare const SearchGoogleAdsRequest: {
    customer_id: string;
    query: string;
    page_token: string;
    page_size: string;
    validate_only: string;
    return_total_results_count: string;
    summary_row_setting: string;
};
export declare const GoogleAdsRow: {
    account_budget: {
        resource_name: string;
        id: string;
        billing_setup: string;
        status: string;
        name: string;
        proposed_start_date_time: string;
        approved_start_date_time: string;
        total_adjustments_micros: string;
        amount_served_micros: string;
        purchase_order_number: string;
        notes: string;
        pending_proposal: {
            account_budget_proposal: string;
            proposal_type: string;
            name: string;
            start_date_time: string;
            purchase_order_number: string;
            notes: string;
            creation_date_time: string;
            end_date_time: string;
            end_time_type: string;
            spending_limit_micros: string;
            spending_limit_type: string;
        };
        proposed_end_date_time: string;
        proposed_end_time_type: string;
        approved_end_date_time: string;
        approved_end_time_type: string;
        proposed_spending_limit_micros: string;
        proposed_spending_limit_type: string;
        approved_spending_limit_micros: string;
        approved_spending_limit_type: string;
        adjusted_spending_limit_micros: string;
        adjusted_spending_limit_type: string;
    };
    account_budget_proposal: {
        resource_name: string;
        id: string;
        billing_setup: string;
        account_budget: string;
        proposal_type: string;
        status: string;
        proposed_name: string;
        approved_start_date_time: string;
        proposed_purchase_order_number: string;
        proposed_notes: string;
        creation_date_time: string;
        approval_date_time: string;
        proposed_start_date_time: string;
        proposed_start_time_type: string;
        proposed_end_date_time: string;
        proposed_end_time_type: string;
        approved_end_date_time: string;
        approved_end_time_type: string;
        proposed_spending_limit_micros: string;
        proposed_spending_limit_type: string;
        approved_spending_limit_micros: string;
        approved_spending_limit_type: string;
    };
    ad_group: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        ad_rotation_mode: string;
        base_ad_group: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        campaign: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        target_cpa_micros: string;
        cpv_bid_micros: string;
        target_cpm_micros: string;
        target_roas: string;
        percent_cpc_bid_micros: string;
        explorer_auto_optimizer_setting: {
            opt_in: string;
        };
        display_custom_bid_dimension: string;
        final_url_suffix: string;
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        effective_target_cpa_micros: string;
        effective_target_cpa_source: string;
        effective_target_roas: string;
        effective_target_roas_source: string;
        labels: string;
    };
    ad_group_ad: {
        resource_name: string;
        status: string;
        ad_group: string;
        ad: {
            resource_name: string;
            id: string;
            final_urls: string;
            final_app_urls: {
                os_type: string;
                url: string;
            };
            final_mobile_urls: string;
            tracking_url_template: string;
            final_url_suffix: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            display_url: string;
            type: string;
            added_by_google_ads: string;
            device_preference: string;
            url_collections: {
                url_collection_id: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
            };
            name: string;
            system_managed_resource_source: string;
            text_ad: {
                headline: string;
                description1: string;
                description2: string;
            };
            expanded_text_ad: {
                headline_part1: string;
                headline_part2: string;
                headline_part3: string;
                description: string;
                description2: string;
                path1: string;
                path2: string;
            };
            call_only_ad: {
                country_code: string;
                phone_number: string;
                business_name: string;
                headline1: string;
                headline2: string;
                description1: string;
                description2: string;
                call_tracked: string;
                disable_call_conversion: string;
                phone_number_verification_url: string;
                conversion_action: string;
                conversion_reporting_state: string;
            };
            expanded_dynamic_search_ad: {
                description: string;
                description2: string;
            };
            hotel_ad: {};
            shopping_smart_ad: {};
            shopping_product_ad: {};
            gmail_ad: {
                teaser: {
                    headline: string;
                    description: string;
                    business_name: string;
                    logo_image: string;
                };
                header_image: string;
                marketing_image: string;
                marketing_image_headline: string;
                marketing_image_description: string;
                marketing_image_display_call_to_action: {
                    text: string;
                    text_color: string;
                    url_collection_id: string;
                };
                product_images: {
                    product_image: string;
                    description: string;
                    display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                };
                product_videos: {
                    product_video: string;
                };
            };
            image_ad: {
                pixel_width: string;
                pixel_height: string;
                image_url: string;
                preview_pixel_width: string;
                preview_pixel_height: string;
                preview_image_url: string;
                mime_type: string;
                name: string;
                media_file: string;
                data: string;
                ad_id_to_copy_image_from: string;
            };
            video_ad: {
                media_file: string;
                in_stream: {
                    action_button_label: string;
                    action_headline: string;
                    companion_banner: string;
                };
                bumper: {
                    companion_banner: string;
                };
                out_stream: {
                    headline: string;
                    description: string;
                };
                non_skippable: {
                    companion_banner: string;
                };
                discovery: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
            };
            responsive_search_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                path1: string;
                path2: string;
            };
            legacy_responsive_display_ad: {
                short_headline: string;
                long_headline: string;
                description: string;
                business_name: string;
                allow_flexible_color: string;
                accent_color: string;
                main_color: string;
                call_to_action_text: string;
                logo_image: string;
                square_logo_image: string;
                marketing_image: string;
                square_marketing_image: string;
                format_setting: string;
                price_prefix: string;
                promo_text: string;
            };
            app_ad: {
                mandatory_ad_text: {
                    text: string;
                    pinned_field: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                youtube_videos: {
                    asset: string;
                };
                html_5_media_bundles: {
                    asset: string;
                };
            };
            legacy_app_install_ad: {
                app_id: string;
                app_store: string;
                headline: string;
                description1: string;
                description2: string;
            };
            responsive_display_ad: {
                marketing_images: {
                    asset: string;
                };
                square_marketing_images: {
                    asset: string;
                };
                logo_images: {
                    asset: string;
                };
                square_logo_images: {
                    asset: string;
                };
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                long_headline: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                youtube_videos: {
                    asset: string;
                };
                business_name: string;
                main_color: string;
                accent_color: string;
                allow_flexible_color: string;
                call_to_action_text: string;
                price_prefix: string;
                promo_text: string;
                format_setting: string;
            };
            display_upload_ad: {
                display_upload_product_type: string;
                media_bundle: {
                    asset: string;
                };
            };
            app_engagement_ad: {
                headlines: {
                    text: string;
                    pinned_field: string;
                };
                descriptions: {
                    text: string;
                    pinned_field: string;
                };
                images: {
                    asset: string;
                };
                videos: {
                    asset: string;
                };
            };
            shopping_comparison_listing_ad: {
                headline: string;
            };
        };
        policy_summary: {
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            review_status: string;
            approval_status: string;
        };
        ad_strength: string;
    };
    ad_group_ad_asset_view: {
        resource_name: string;
        ad_group_ad: string;
        asset: string;
        field_type: string;
        policy_summary: {
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            review_status: string;
            approval_status: string;
        };
        performance_label: string;
    };
    ad_group_ad_label: {
        resource_name: string;
        ad_group_ad: string;
        label: string;
    };
    ad_group_audience_view: {
        resource_name: string;
    };
    ad_group_bid_modifier: {
        resource_name: string;
        ad_group: string;
        criterion_id: string;
        bid_modifier: string;
        base_ad_group: string;
        bid_modifier_source: string;
        hotel_date_selection_type: {
            type: string;
        };
        hotel_advance_booking_window: {
            min_days: string;
            max_days: string;
        };
        hotel_length_of_stay: {
            min_nights: string;
            max_nights: string;
        };
        hotel_check_in_day: {
            day_of_week: string;
        };
        device: {
            type: string;
        };
        preferred_content: {
            type: string;
        };
    };
    ad_group_criterion: {
        resource_name: string;
        criterion_id: string;
        status: string;
        quality_info: {
            quality_score: string;
            creative_quality_score: string;
            post_click_quality_score: string;
            search_predicted_ctr: string;
        };
        ad_group: string;
        type: string;
        negative: string;
        system_serving_status: string;
        approval_status: string;
        bid_modifier: string;
        cpc_bid_micros: string;
        cpm_bid_micros: string;
        cpv_bid_micros: string;
        percent_cpc_bid_micros: string;
        effective_cpc_bid_micros: string;
        effective_cpm_bid_micros: string;
        effective_cpv_bid_micros: string;
        effective_percent_cpc_bid_micros: string;
        effective_cpc_bid_source: string;
        effective_cpm_bid_source: string;
        effective_cpv_bid_source: string;
        effective_percent_cpc_bid_source: string;
        position_estimates: {
            first_page_cpc_micros: string;
            first_position_cpc_micros: string;
            top_of_page_cpc_micros: string;
            estimated_add_clicks_at_first_position_cpc: string;
            estimated_add_cost_at_first_position_cpc: string;
        };
        final_urls: string;
        final_mobile_urls: string;
        final_url_suffix: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        listing_group: {
            type: string;
            case_value: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
            parent_ad_group_criterion: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        app_payment_model: {
            type: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
        custom_intent: {
            custom_intent: string;
        };
    };
    ad_group_criterion_label: {
        resource_name: string;
        ad_group_criterion: string;
        label: string;
    };
    ad_group_criterion_simulation: {
        resource_name: string;
        ad_group_id: string;
        criterion_id: string;
        type: string;
        modification_method: string;
        start_date: string;
        end_date: string;
        cpc_bid_point_list: {
            points: {
                cpc_bid_micros: string;
                biddable_conversions: string;
                biddable_conversions_value: string;
                clicks: string;
                cost_micros: string;
                impressions: string;
                top_slot_impressions: string;
            };
        };
    };
    ad_group_extension_setting: {
        resource_name: string;
        extension_type: string;
        ad_group: string;
        extension_feed_items: string;
        device: string;
    };
    ad_group_feed: {
        resource_name: string;
        feed: string;
        ad_group: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    ad_group_label: {
        resource_name: string;
        ad_group: string;
        label: string;
    };
    ad_group_simulation: {
        resource_name: string;
        ad_group_id: string;
        type: string;
        modification_method: string;
        start_date: string;
        end_date: string;
        cpc_bid_point_list: {
            points: {
                cpc_bid_micros: string;
                biddable_conversions: string;
                biddable_conversions_value: string;
                clicks: string;
                cost_micros: string;
                impressions: string;
                top_slot_impressions: string;
            };
        };
        cpv_bid_point_list: {
            points: {
                cpv_bid_micros: string;
                cost_micros: string;
                impressions: string;
                views: string;
            };
        };
        target_cpa_point_list: {
            points: {
                target_cpa_micros: string;
                biddable_conversions: string;
                biddable_conversions_value: string;
                clicks: string;
                cost_micros: string;
                impressions: string;
                top_slot_impressions: string;
            };
        };
    };
    ad_parameter: {
        resource_name: string;
        ad_group_criterion: string;
        parameter_index: string;
        insertion_text: string;
    };
    age_range_view: {
        resource_name: string;
    };
    ad_schedule_view: {
        resource_name: string;
    };
    domain_category: {
        resource_name: string;
        campaign: string;
        category: string;
        language_code: string;
        domain: string;
        coverage_fraction: string;
        category_rank: string;
        has_children: string;
        recommended_cpc_bid_micros: string;
    };
    asset: {
        resource_name: string;
        id: string;
        name: string;
        type: string;
        youtube_video_asset: {
            youtube_video_id: string;
        };
        media_bundle_asset: {
            data: string;
        };
        image_asset: {
            data: string;
            file_size: string;
            mime_type: string;
            full_size: {
                height_pixels: string;
                width_pixels: string;
                url: string;
            };
        };
        text_asset: {
            text: string;
        };
    };
    bidding_strategy: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        campaign_count: string;
        non_removed_campaign_count: string;
        enhanced_cpc: {};
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
    };
    billing_setup: {
        resource_name: string;
        id: string;
        status: string;
        payments_account: string;
        payments_account_info: {
            payments_account_id: string;
            payments_account_name: string;
            payments_profile_id: string;
            payments_profile_name: string;
            secondary_payments_profile_id: string;
        };
        start_date_time: string;
        start_time_type: string;
        end_date_time: string;
        end_time_type: string;
    };
    campaign_budget: {
        resource_name: string;
        id: string;
        name: string;
        amount_micros: string;
        total_amount_micros: string;
        status: string;
        delivery_method: string;
        explicitly_shared: string;
        reference_count: string;
        has_recommended_budget: string;
        recommended_budget_amount_micros: string;
        period: string;
        recommended_budget_estimated_change_weekly_clicks: string;
        recommended_budget_estimated_change_weekly_cost_micros: string;
        recommended_budget_estimated_change_weekly_interactions: string;
        recommended_budget_estimated_change_weekly_views: string;
        type: string;
    };
    campaign: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        serving_status: string;
        ad_serving_optimization_status: string;
        advertising_channel_type: string;
        advertising_channel_sub_type: string;
        tracking_url_template: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        real_time_bidding_setting: {
            opt_in: string;
        };
        network_settings: {
            target_google_search: string;
            target_search_network: string;
            target_content_network: string;
            target_partner_search_network: string;
        };
        hotel_setting: {
            hotel_center_id: string;
        };
        dynamic_search_ads_setting: {
            domain_name: string;
            language_code: string;
            use_supplied_urls_only: string;
            feeds: string;
        };
        shopping_setting: {
            merchant_id: string;
            sales_country: string;
            campaign_priority: string;
            enable_local: string;
        };
        targeting_setting: {
            target_restrictions: {
                targeting_dimension: string;
                bid_only: string;
            };
            target_restriction_operations: {
                operator: {};
                value: {
                    targeting_dimension: string;
                    bid_only: string;
                };
            };
        };
        geo_target_type_setting: {
            positive_geo_target_type: string;
            negative_geo_target_type: string;
        };
        app_campaign_setting: {
            bidding_strategy_goal_type: string;
            app_id: string;
            app_store: string;
        };
        labels: string;
        experiment_type: string;
        base_campaign: string;
        campaign_budget: string;
        bidding_strategy_type: string;
        start_date: string;
        end_date: string;
        final_url_suffix: string;
        frequency_caps: {
            key: {
                level: string;
                event_type: string;
                time_unit: string;
                time_length: string;
            };
            cap: string;
        };
        video_brand_safety_suitability: string;
        vanity_pharma: {
            vanity_pharma_display_url_mode: string;
            vanity_pharma_text: string;
        };
        selective_optimization: {
            conversion_actions: string;
        };
        tracking_setting: {
            tracking_url: string;
        };
        payment_mode: string;
        bidding_strategy: string;
        commission: {
            commission_rate_micros: string;
        };
        manual_cpc: {
            enhanced_cpc_enabled: string;
        };
        manual_cpm: {};
        manual_cpv: {};
        maximize_conversions: {};
        maximize_conversion_value: {
            target_roas: string;
        };
        target_cpa: {
            target_cpa_micros: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_impression_share: {
            location: string;
            location_fraction_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        target_roas: {
            target_roas: string;
            cpc_bid_ceiling_micros: string;
            cpc_bid_floor_micros: string;
        };
        target_spend: {
            target_spend_micros: string;
            cpc_bid_ceiling_micros: string;
        };
        percent_cpc: {
            cpc_bid_ceiling_micros: string;
            enhanced_cpc_enabled: string;
        };
        target_cpm: {};
    };
    campaign_audience_view: {
        resource_name: string;
    };
    campaign_bid_modifier: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        interaction_type: {
            type: string;
        };
    };
    campaign_criterion: {
        resource_name: string;
        campaign: string;
        criterion_id: string;
        bid_modifier: string;
        negative: string;
        type: string;
        status: string;
        keyword: {
            text: string;
            match_type: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        location: {
            geo_target_constant: string;
        };
        device: {
            type: string;
        };
        ad_schedule: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        age_range: {
            type: string;
        };
        gender: {
            type: string;
        };
        income_range: {
            type: string;
        };
        parental_status: {
            type: string;
        };
        user_list: {
            user_list: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        proximity: {
            geo_point: {
                longitude_in_micro_degrees: string;
                latitude_in_micro_degrees: string;
            };
            radius: string;
            radius_units: string;
            address: {
                postal_code: string;
                province_code: string;
                country_code: string;
                province_name: string;
                street_address: string;
                street_address2: string;
                city_name: string;
            };
        };
        topic: {
            topic_constant: string;
            path: string;
        };
        listing_scope: {
            dimensions: {
                hotel_id: {
                    value: string;
                };
                hotel_class: {
                    value: string;
                };
                hotel_country_region: {
                    country_region_criterion: string;
                };
                hotel_state: {
                    state_criterion: string;
                };
                hotel_city: {
                    city_criterion: string;
                };
                product_bidding_category: {
                    id: string;
                    country_code: string;
                    level: string;
                };
                product_brand: {
                    value: string;
                };
                product_channel: {
                    channel: string;
                };
                product_channel_exclusivity: {
                    channel_exclusivity: string;
                };
                product_condition: {
                    condition: string;
                };
                product_custom_attribute: {
                    value: string;
                    index: string;
                };
                product_item_id: {
                    value: string;
                };
                product_type: {
                    value: string;
                    level: string;
                };
                unknown_listing_dimension: {};
            };
        };
        language: {
            language_constant: string;
        };
        ip_block: {
            ip_address: string;
        };
        content_label: {
            type: string;
        };
        carrier: {
            carrier_constant: string;
        };
        user_interest: {
            user_interest_category: string;
        };
        webpage: {
            criterion_name: string;
            conditions: {
                operand: string;
                operator: string;
                argument: string;
            };
        };
        operating_system_version: {
            operating_system_version_constant: string;
        };
        mobile_device: {
            mobile_device_constant: string;
        };
        location_group: {
            feed: string;
            geo_target_constants: string;
            radius: string;
            radius_units: string;
        };
        custom_affinity: {
            custom_affinity: string;
        };
    };
    campaign_criterion_simulation: {
        resource_name: string;
        campaign_id: string;
        criterion_id: string;
        type: string;
        modification_method: string;
        start_date: string;
        end_date: string;
        bid_modifier_point_list: {
            points: {
                bid_modifier: string;
                biddable_conversions: string;
                biddable_conversions_value: string;
                clicks: string;
                cost_micros: string;
                impressions: string;
                top_slot_impressions: string;
                parent_biddable_conversions: string;
                parent_biddable_conversions_value: string;
                parent_clicks: string;
                parent_cost_micros: string;
                parent_impressions: string;
                parent_top_slot_impressions: string;
                parent_required_budget_micros: string;
            };
        };
    };
    campaign_draft: {
        resource_name: string;
        draft_id: string;
        base_campaign: string;
        name: string;
        draft_campaign: string;
        status: string;
        has_experiment_running: string;
        long_running_operation: string;
    };
    campaign_experiment: {
        resource_name: string;
        id: string;
        campaign_draft: string;
        name: string;
        description: string;
        traffic_split_percent: string;
        traffic_split_type: string;
        experiment_campaign: string;
        status: string;
        long_running_operation: string;
        start_date: string;
        end_date: string;
    };
    campaign_extension_setting: {
        resource_name: string;
        extension_type: string;
        campaign: string;
        extension_feed_items: string;
        device: string;
    };
    campaign_feed: {
        resource_name: string;
        feed: string;
        campaign: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    campaign_label: {
        resource_name: string;
        campaign: string;
        label: string;
    };
    campaign_shared_set: {
        resource_name: string;
        campaign: string;
        shared_set: string;
        status: string;
    };
    carrier_constant: {
        resource_name: string;
        id: string;
        name: string;
        country_code: string;
    };
    change_status: {
        resource_name: string;
        last_change_date_time: string;
        resource_type: string;
        campaign: string;
        ad_group: string;
        resource_status: string;
        ad_group_ad: string;
        ad_group_criterion: string;
        campaign_criterion: string;
        feed: string;
        feed_item: string;
        ad_group_feed: string;
        campaign_feed: string;
        ad_group_bid_modifier: string;
    };
    conversion_action: {
        resource_name: string;
        id: string;
        name: string;
        status: string;
        type: string;
        category: string;
        owner_customer: string;
        include_in_conversions_metric: string;
        click_through_lookback_window_days: string;
        view_through_lookback_window_days: string;
        value_settings: {
            default_value: string;
            default_currency_code: string;
            always_use_default_value: string;
        };
        counting_type: string;
        attribution_model_settings: {
            attribution_model: string;
            data_driven_model_status: string;
        };
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
        phone_call_duration_seconds: string;
        app_id: string;
    };
    click_view: {
        resource_name: string;
        gclid: string;
        area_of_interest: {
            city: string;
            country: string;
            metro: string;
            most_specific: string;
            region: string;
        };
        location_of_presence: {
            city: string;
            country: string;
            metro: string;
            most_specific: string;
            region: string;
        };
        page_number: string;
        ad_group_ad: string;
    };
    currency_constant: {
        resource_name: string;
        code: string;
        name: string;
        symbol: string;
        billable_unit_micros: string;
    };
    custom_interest: {
        resource_name: string;
        id: string;
        status: string;
        name: string;
        type: string;
        description: string;
        members: {
            member_type: string;
            parameter: string;
        };
    };
    customer: {
        resource_name: string;
        id: string;
        descriptive_name: string;
        currency_code: string;
        time_zone: string;
        tracking_url_template: string;
        final_url_suffix: string;
        auto_tagging_enabled: string;
        has_partners_badge: string;
        manager: string;
        test_account: string;
        call_reporting_setting: {
            call_reporting_enabled: string;
            call_conversion_reporting_enabled: string;
            call_conversion_action: string;
        };
        conversion_tracking_setting: {
            conversion_tracking_id: string;
            cross_account_conversion_tracking_id: string;
        };
        remarketing_setting: {
            google_global_site_tag: string;
        };
        pay_per_conversion_eligibility_failure_reasons: string;
    };
    customer_manager_link: {
        resource_name: string;
        manager_customer: string;
        manager_link_id: string;
        status: string;
    };
    customer_client_link: {
        resource_name: string;
        client_customer: string;
        manager_link_id: string;
        status: string;
        hidden: string;
    };
    customer_client: {
        resource_name: string;
        client_customer: string;
        hidden: string;
        level: string;
        time_zone: string;
        test_account: string;
        manager: string;
        descriptive_name: string;
        currency_code: string;
        id: string;
    };
    customer_extension_setting: {
        resource_name: string;
        extension_type: string;
        extension_feed_items: string;
        device: string;
    };
    customer_feed: {
        resource_name: string;
        feed: string;
        placeholder_types: string;
        matching_function: {
            function_string: string;
            operator: string;
            left_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
            right_operands: {
                constant_operand: {
                    string_value: string;
                    long_value: string;
                    boolean_value: string;
                    double_value: string;
                };
                feed_attribute_operand: {
                    feed_id: string;
                    feed_attribute_id: string;
                };
                function_operand: null;
                request_context_operand: {
                    context_type: string;
                };
            };
        };
        status: string;
    };
    customer_label: {
        resource_name: string;
        customer: string;
        label: string;
    };
    customer_negative_criterion: {
        resource_name: string;
        id: string;
        type: string;
        content_label: {
            type: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        placement: {
            url: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
    };
    detail_placement_view: {
        resource_name: string;
        placement: string;
        display_name: string;
        group_placement_target_url: string;
        target_url: string;
        placement_type: string;
    };
    display_keyword_view: {
        resource_name: string;
    };
    distance_view: {
        resource_name: string;
        distance_bucket: string;
        metric_system: string;
    };
    dynamic_search_ads_search_term_view: {
        resource_name: string;
        search_term: string;
        headline: string;
        landing_page: string;
        page_url: string;
        has_negative_keyword: string;
        has_matching_keyword: string;
        has_negative_url: string;
    };
    expanded_landing_page_view: {
        resource_name: string;
        expanded_final_url: string;
    };
    extension_feed_item: {
        resource_name: string;
        id: string;
        extension_type: string;
        start_date_time: string;
        end_date_time: string;
        ad_schedules: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
        device: string;
        targeted_geo_target_constant: string;
        targeted_keyword: {
            text: string;
            match_type: string;
        };
        status: string;
        sitelink_feed_item: {
            link_text: string;
            line1: string;
            line2: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        structured_snippet_feed_item: {
            header: string;
            values: string;
        };
        app_feed_item: {
            link_text: string;
            app_id: string;
            app_store: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
        };
        call_feed_item: {
            phone_number: string;
            country_code: string;
            call_tracking_enabled: string;
            call_conversion_action: string;
            call_conversion_tracking_disabled: string;
            call_conversion_reporting_state: string;
        };
        callout_feed_item: {
            callout_text: string;
        };
        text_message_feed_item: {
            business_name: string;
            country_code: string;
            phone_number: string;
            text: string;
            extension_text: string;
        };
        price_feed_item: {
            type: string;
            price_qualifier: string;
            tracking_url_template: string;
            language_code: string;
            price_offerings: {
                header: string;
                description: string;
                price: {
                    currency_code: string;
                    amount_micros: string;
                };
                unit: string;
                final_urls: string;
                final_mobile_urls: string;
            };
            final_url_suffix: string;
        };
        promotion_feed_item: {
            promotion_target: string;
            discount_modifier: string;
            promotion_start_date: string;
            promotion_end_date: string;
            occasion: string;
            final_urls: string;
            final_mobile_urls: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            final_url_suffix: string;
            language_code: string;
            percent_off: string;
            money_amount_off: {
                currency_code: string;
                amount_micros: string;
            };
            promotion_code: string;
            orders_over_amount: {
                currency_code: string;
                amount_micros: string;
            };
        };
        location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
        };
        affiliate_location_feed_item: {
            business_name: string;
            address_line1: string;
            address_line2: string;
            city: string;
            province: string;
            postal_code: string;
            country_code: string;
            phone_number: string;
            chain_id: string;
            chain_name: string;
        };
        hotel_callout_feed_item: {
            text: string;
            language_code: string;
        };
        targeted_campaign: string;
        targeted_ad_group: string;
    };
    feed: {
        resource_name: string;
        id: string;
        name: string;
        attributes: {
            id: string;
            name: string;
            type: string;
            is_part_of_key: string;
        };
        attribute_operations: {
            operator: {};
            value: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
        };
        origin: string;
        status: string;
        places_location_feed_data: {
            oauth_info: {
                http_method: string;
                http_request_url: string;
                http_authorization_header: string;
            };
            email_address: string;
            business_account_id: string;
            business_name_filter: string;
            category_filters: string;
            label_filters: string;
        };
        affiliate_location_feed_data: {
            chain_ids: string;
            relationship_type: string;
        };
    };
    feed_item: {
        resource_name: string;
        feed: string;
        id: string;
        start_date_time: string;
        end_date_time: string;
        attribute_values: {
            feed_attribute_id: string;
            integer_value: string;
            boolean_value: string;
            string_value: string;
            double_value: string;
            price_value: {
                currency_code: string;
                amount_micros: string;
            };
            integer_values: string;
            boolean_values: string;
            string_values: string;
            double_values: string;
        };
        geo_targeting_restriction: string;
        url_custom_parameters: {
            key: string;
            value: string;
        };
        status: string;
        policy_infos: {
            placeholder_type_enum: string;
            feed_mapping_resource_name: string;
            review_status: string;
            approval_status: string;
            policy_topic_entries: {
                topic: string;
                type: string;
                evidences: {
                    website_list: {
                        websites: string;
                    };
                    text_list: {
                        texts: string;
                    };
                    language_code: string;
                    destination_text_list: {
                        destination_texts: string;
                    };
                    destination_mismatch: {
                        url_types: string;
                    };
                    destination_not_working: {
                        expanded_url: string;
                        device: string;
                        last_checked_date_time: string;
                        dns_error_type: string;
                        http_error_code: string;
                    };
                };
                constraints: {
                    country_constraint_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    reseller_constraint: {};
                    certificate_missing_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                    certificate_domain_mismatch_in_country_list: {
                        total_targeted_countries: string;
                        countries: {
                            country_criterion: string;
                        };
                    };
                };
            };
            validation_status: string;
            validation_errors: {};
            quality_approval_status: string;
            quality_disapproval_reasons: string;
        };
    };
    feed_item_target: {
        resource_name: string;
        feed_item: string;
        feed_item_target_type: string;
        feed_item_target_id: string;
        status: string;
        campaign: string;
        ad_group: string;
        keyword: {
            text: string;
            match_type: string;
        };
        geo_target_constant: string;
        device: string;
        ad_schedule: {
            start_minute: string;
            end_minute: string;
            start_hour: string;
            end_hour: string;
            day_of_week: string;
        };
    };
    feed_mapping: {
        resource_name: string;
        feed: string;
        attribute_field_mappings: {
            feed_attribute_id: string;
            field_id: string;
            sitelink_field: string;
            call_field: string;
            app_field: string;
            location_field: string;
            affiliate_location_field: string;
            callout_field: string;
            structured_snippet_field: string;
            message_field: string;
            price_field: string;
            promotion_field: string;
            ad_customizer_field: string;
            dsa_page_feed_field: string;
            location_extension_targeting_field: string;
            education_field: string;
            flight_field: string;
            custom_field: string;
            hotel_field: string;
            real_estate_field: string;
            travel_field: string;
            local_field: string;
            job_field: string;
        };
        status: string;
        placeholder_type: string;
        criterion_type: string;
    };
    feed_placeholder_view: {
        resource_name: string;
        placeholder_type: string;
    };
    gender_view: {
        resource_name: string;
    };
    geo_target_constant: {
        resource_name: string;
        id: string;
        name: string;
        country_code: string;
        target_type: string;
        status: string;
        canonical_name: string;
    };
    geographic_view: {
        resource_name: string;
        location_type: string;
        country_criterion_id: string;
    };
    group_placement_view: {
        resource_name: string;
        placement: string;
        display_name: string;
        target_url: string;
        placement_type: string;
    };
    hotel_group_view: {
        resource_name: string;
    };
    hotel_performance_view: {
        resource_name: string;
    };
    keyword_view: {
        resource_name: string;
    };
    keyword_plan: {
        resource_name: string;
        id: string;
        name: string;
        forecast_period: {
            date_interval: string;
            date_range: {
                start_date: string;
                end_date: string;
            };
        };
    };
    keyword_plan_campaign: {
        resource_name: string;
        keyword_plan: string;
        id: string;
        name: string;
        language_constants: string;
        keyword_plan_network: string;
        cpc_bid_micros: string;
        geo_targets: {
            geo_target_constant: string;
        };
    };
    keyword_plan_negative_keyword: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        text: string;
        match_type: string;
    };
    keyword_plan_ad_group: {
        resource_name: string;
        keyword_plan_campaign: string;
        id: string;
        name: string;
        cpc_bid_micros: string;
    };
    keyword_plan_keyword: {
        resource_name: string;
        keyword_plan_ad_group: string;
        id: string;
        text: string;
        match_type: string;
        cpc_bid_micros: string;
    };
    label: {};
    landing_page_view: {
        resource_name: string;
        unexpanded_final_url: string;
    };
    language_constant: {
        resource_name: string;
        id: string;
        code: string;
        name: string;
        targetable: string;
    };
    location_view: {
        resource_name: string;
    };
    managed_placement_view: {
        resource_name: string;
    };
    media_file: {
        resource_name: string;
        id: string;
        type: string;
        mime_type: string;
        source_url: string;
        name: string;
        file_size: string;
        image: {
            data: string;
        };
        media_bundle: {
            data: string;
        };
        audio: {
            ad_duration_millis: string;
        };
        video: {
            ad_duration_millis: string;
            youtube_video_id: string;
            advertising_id_code: string;
            isci_code: string;
        };
    };
    mobile_app_category_constant: {
        resource_name: string;
        id: string;
        name: string;
    };
    mobile_device_constant: {
        resource_name: string;
        id: string;
        name: string;
        manufacturer_name: string;
        operating_system_name: string;
        type: string;
    };
    mutate_job: {
        resource_name: string;
        id: string;
        next_add_sequence_token: string;
        metadata: {
            creation_date_time: string;
            completion_date_time: string;
            estimated_completion_ratio: string;
            operation_count: string;
            executed_operation_count: string;
        };
        status: string;
        long_running_operation: string;
    };
    operating_system_version_constant: {
        resource_name: string;
        id: string;
        name: string;
        os_major_version: string;
        os_minor_version: string;
        operator_type: string;
    };
    paid_organic_search_term_view: {
        resource_name: string;
        search_term: string;
    };
    parental_status_view: {
        resource_name: string;
    };
    product_bidding_category_constant: {
        resource_name: string;
        id: string;
        country_code: string;
        product_bidding_category_constant_parent: string;
        level: string;
        status: string;
        language_code: string;
        localized_name: string;
    };
    product_group_view: {
        resource_name: string;
    };
    recommendation: {
        resource_name: string;
        type: string;
        impact: {
            base_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
            potential_metrics: {
                impressions: string;
                clicks: string;
                cost_micros: string;
                conversions: string;
                video_views: string;
            };
        };
        campaign_budget: string;
        campaign: string;
        ad_group: string;
        dismissed: string;
        campaign_budget_recommendation: {
            current_budget_amount_micros: string;
            recommended_budget_amount_micros: string;
            budget_options: {
                budget_amount_micros: string;
                impact: {
                    base_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                    potential_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                };
            };
        };
        keyword_recommendation: {
            keyword: {
                text: string;
                match_type: string;
            };
            recommended_cpc_bid_micros: string;
        };
        text_ad_recommendation: {
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            creation_date: string;
            auto_apply_date: string;
        };
        target_cpa_opt_in_recommendation: {
            options: {
                goal: string;
                target_cpa_micros: string;
                required_campaign_budget_amount_micros: string;
                impact: {
                    base_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                    potential_metrics: {
                        impressions: string;
                        clicks: string;
                        cost_micros: string;
                        conversions: string;
                        video_views: string;
                    };
                };
            };
            recommended_target_cpa_micros: string;
        };
        maximize_conversions_opt_in_recommendation: {
            recommended_budget_amount_micros: string;
        };
        enhanced_cpc_opt_in_recommendation: {};
        search_partners_opt_in_recommendation: {};
        maximize_clicks_opt_in_recommendation: {
            recommended_budget_amount_micros: string;
        };
        optimize_ad_rotation_recommendation: {};
        callout_extension_recommendation: {
            recommended_extensions: {
                callout_text: string;
            };
        };
        sitelink_extension_recommendation: {
            recommended_extensions: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
        };
        call_extension_recommendation: {
            recommended_extensions: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
        };
        keyword_match_type_recommendation: {
            keyword: {
                text: string;
                match_type: string;
            };
            recommended_match_type: string;
        };
        move_unused_budget_recommendation: {
            excess_campaign_budget: string;
            budget_recommendation: {
                current_budget_amount_micros: string;
                recommended_budget_amount_micros: string;
                budget_options: {
                    budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
            };
        };
    };
    search_term_view: {
        resource_name: string;
        search_term: string;
        ad_group: string;
        status: string;
    };
    shared_criterion: {
        resource_name: string;
        shared_set: string;
        criterion_id: string;
        type: string;
        keyword: {
            text: string;
            match_type: string;
        };
        youtube_video: {
            video_id: string;
        };
        youtube_channel: {
            channel_id: string;
        };
        placement: {
            url: string;
        };
        mobile_app_category: {
            mobile_app_category_constant: string;
        };
        mobile_application: {
            app_id: string;
            name: string;
        };
    };
    shared_set: {
        resource_name: string;
        id: string;
        type: string;
        name: string;
        status: string;
        member_count: string;
        reference_count: string;
    };
    shopping_performance_view: {
        resource_name: string;
    };
    topic_view: {
        resource_name: string;
    };
    user_interest: {
        resource_name: string;
        taxonomy_type: string;
        user_interest_id: string;
        name: string;
        user_interest_parent: string;
        launched_to_all: string;
        availabilities: {
            channel: {
                availability_mode: string;
                advertising_channel_type: string;
                advertising_channel_sub_type: string;
                include_default_channel_sub_type: string;
            };
            locale: {
                availability_mode: string;
                country_code: string;
                language_code: string;
            };
        };
    };
    user_list: {
        resource_name: string;
        id: string;
        read_only: string;
        name: string;
        description: string;
        membership_status: string;
        integration_code: string;
        membership_life_span: string;
        size_for_display: string;
        size_range_for_display: string;
        size_for_search: string;
        size_range_for_search: string;
        type: string;
        closing_reason: string;
        access_reason: string;
        account_user_list_status: string;
        eligible_for_search: string;
        eligible_for_display: string;
        crm_based_user_list: {
            app_id: string;
            upload_key_type: string;
            data_source_type: string;
        };
        similar_user_list: {
            seed_user_list: string;
        };
        rule_based_user_list: {
            prepopulation_status: string;
            combined_rule_user_list: {
                left_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                right_operand: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                rule_operator: string;
            };
            date_specific_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
                start_date: string;
                end_date: string;
            };
            expression_rule_user_list: {
                rule: {
                    rule_type: string;
                    rule_item_groups: {
                        rule_items: {
                            name: string;
                            number_rule_item: {
                                operator: string;
                                value: string;
                            };
                            string_rule_item: {
                                operator: string;
                                value: string;
                            };
                            date_rule_item: {
                                operator: string;
                                value: string;
                                offset_in_days: string;
                            };
                        };
                    };
                };
            };
        };
        logical_user_list: {
            rules: {
                operator: string;
                rule_operands: {
                    user_list: string;
                };
            };
        };
        basic_user_list: {
            actions: {
                conversion_action: string;
                remarketing_action: string;
            };
        };
    };
    user_location_view: {
        resource_name: string;
        country_criterion_id: string;
        targeting_location: string;
    };
    remarketing_action: {
        resource_name: string;
        id: string;
        name: string;
        tag_snippets: {
            type: string;
            page_format: string;
            global_site_tag: string;
            event_snippet: string;
        };
    };
    topic_constant: {
        resource_name: string;
        id: string;
        topic_constant_parent: string;
        path: string;
    };
    video: {
        resource_name: string;
        id: string;
        channel_id: string;
        duration_millis: string;
        title: string;
    };
    metrics: {
        absolute_top_impression_percentage: string;
        active_view_cpm: string;
        active_view_ctr: string;
        active_view_impressions: string;
        active_view_measurability: string;
        active_view_measurable_cost_micros: string;
        active_view_measurable_impressions: string;
        active_view_viewability: string;
        all_conversions_from_interactions_rate: string;
        all_conversions_value: string;
        all_conversions: string;
        all_conversions_value_per_cost: string;
        all_conversions_from_click_to_call: string;
        all_conversions_from_directions: string;
        all_conversions_from_interactions_value_per_interaction: string;
        all_conversions_from_menu: string;
        all_conversions_from_order: string;
        all_conversions_from_other_engagement: string;
        all_conversions_from_store_visit: string;
        all_conversions_from_store_website: string;
        average_cost: string;
        average_cpc: string;
        average_cpe: string;
        average_cpm: string;
        average_cpv: string;
        average_page_views: string;
        average_time_on_site: string;
        benchmark_average_max_cpc: string;
        benchmark_ctr: string;
        bounce_rate: string;
        clicks: string;
        combined_clicks: string;
        combined_clicks_per_query: string;
        combined_queries: string;
        content_budget_lost_impression_share: string;
        content_impression_share: string;
        conversion_last_received_request_date_time: string;
        conversion_last_conversion_date: string;
        content_rank_lost_impression_share: string;
        conversions_from_interactions_rate: string;
        conversions_value: string;
        conversions_value_per_cost: string;
        conversions_from_interactions_value_per_interaction: string;
        conversions: string;
        cost_micros: string;
        cost_per_all_conversions: string;
        cost_per_conversion: string;
        cost_per_current_model_attributed_conversion: string;
        cross_device_conversions: string;
        ctr: string;
        current_model_attributed_conversions: string;
        current_model_attributed_conversions_from_interactions_rate: string;
        current_model_attributed_conversions_from_interactions_value_per_interaction: string;
        current_model_attributed_conversions_value: string;
        current_model_attributed_conversions_value_per_cost: string;
        engagement_rate: string;
        engagements: string;
        hotel_average_lead_value_micros: string;
        hotel_price_difference_percentage: string;
        historical_creative_quality_score: string;
        historical_landing_page_quality_score: string;
        historical_quality_score: string;
        historical_search_predicted_ctr: string;
        gmail_forwards: string;
        gmail_saves: string;
        gmail_secondary_clicks: string;
        impressions_from_store_reach: string;
        impressions: string;
        interaction_rate: string;
        interactions: string;
        interaction_event_types: string;
        invalid_click_rate: string;
        invalid_clicks: string;
        message_chats: string;
        message_impressions: string;
        message_chat_rate: string;
        mobile_friendly_clicks_percentage: string;
        organic_clicks: string;
        organic_clicks_per_query: string;
        organic_impressions: string;
        organic_impressions_per_query: string;
        organic_queries: string;
        percent_new_visitors: string;
        phone_calls: string;
        phone_impressions: string;
        phone_through_rate: string;
        relative_ctr: string;
        search_absolute_top_impression_share: string;
        search_budget_lost_absolute_top_impression_share: string;
        search_budget_lost_impression_share: string;
        search_budget_lost_top_impression_share: string;
        search_click_share: string;
        search_exact_match_impression_share: string;
        search_impression_share: string;
        search_rank_lost_absolute_top_impression_share: string;
        search_rank_lost_impression_share: string;
        search_rank_lost_top_impression_share: string;
        search_top_impression_share: string;
        speed_score: string;
        top_impression_percentage: string;
        valid_accelerated_mobile_pages_clicks_percentage: string;
        value_per_all_conversions: string;
        value_per_conversion: string;
        value_per_current_model_attributed_conversion: string;
        video_quartile_100_rate: string;
        video_quartile_25_rate: string;
        video_quartile_50_rate: string;
        video_quartile_75_rate: string;
        video_view_rate: string;
        video_views: string;
        view_through_conversions: string;
    };
    segments: {
        ad_network_type: string;
        click_type: string;
        conversion_action: string;
        conversion_action_category: string;
        conversion_action_name: string;
        conversion_adjustment: string;
        conversion_attribution_event_type: string;
        conversion_lag_bucket: string;
        conversion_or_adjustment_lag_bucket: string;
        date: string;
        day_of_week: string;
        device: string;
        external_conversion_source: string;
        geo_target_airport: string;
        geo_target_canton: string;
        geo_target_city: string;
        geo_target_country: string;
        geo_target_county: string;
        geo_target_district: string;
        geo_target_metro: string;
        geo_target_most_specific_location: string;
        geo_target_postal_code: string;
        geo_target_province: string;
        geo_target_region: string;
        geo_target_state: string;
        hotel_booking_window_days: string;
        hotel_center_id: string;
        hotel_check_in_date: string;
        hotel_check_in_day_of_week: string;
        hotel_city: string;
        hotel_class: string;
        hotel_country: string;
        hotel_date_selection_type: string;
        hotel_length_of_stay: string;
        hotel_rate_rule_id: string;
        hotel_rate_type: string;
        hotel_price_bucket: string;
        hotel_state: string;
        hour: string;
        interaction_on_this_extension: string;
        keyword: {
            ad_group_criterion: string;
            info: {
                text: string;
                match_type: string;
            };
        };
        month: string;
        month_of_year: string;
        partner_hotel_id: string;
        placeholder_type: string;
        product_aggregator_id: string;
        product_bidding_category_level1: string;
        product_bidding_category_level2: string;
        product_bidding_category_level3: string;
        product_bidding_category_level4: string;
        product_bidding_category_level5: string;
        product_brand: string;
        product_channel: string;
        product_channel_exclusivity: string;
        product_condition: string;
        product_country: string;
        product_custom_attribute0: string;
        product_custom_attribute1: string;
        product_custom_attribute2: string;
        product_custom_attribute3: string;
        product_custom_attribute4: string;
        product_item_id: string;
        product_language: string;
        product_merchant_id: string;
        product_store_id: string;
        product_title: string;
        product_type_l1: string;
        product_type_l2: string;
        product_type_l3: string;
        product_type_l4: string;
        product_type_l5: string;
        quarter: string;
        search_engine_results_page_type: string;
        search_term_match_type: string;
        slot: string;
        webpage: string;
        week: string;
        year: string;
    };
};
export declare const SearchGoogleAdsResponse: {
    results: {
        account_budget: {
            resource_name: string;
            id: string;
            billing_setup: string;
            status: string;
            name: string;
            proposed_start_date_time: string;
            approved_start_date_time: string;
            total_adjustments_micros: string;
            amount_served_micros: string;
            purchase_order_number: string;
            notes: string;
            pending_proposal: {
                account_budget_proposal: string;
                proposal_type: string;
                name: string;
                start_date_time: string;
                purchase_order_number: string;
                notes: string;
                creation_date_time: string;
                end_date_time: string;
                end_time_type: string;
                spending_limit_micros: string;
                spending_limit_type: string;
            };
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
            adjusted_spending_limit_micros: string;
            adjusted_spending_limit_type: string;
        };
        account_budget_proposal: {
            resource_name: string;
            id: string;
            billing_setup: string;
            account_budget: string;
            proposal_type: string;
            status: string;
            proposed_name: string;
            approved_start_date_time: string;
            proposed_purchase_order_number: string;
            proposed_notes: string;
            creation_date_time: string;
            approval_date_time: string;
            proposed_start_date_time: string;
            proposed_start_time_type: string;
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
        };
        ad_group: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        ad_group_ad: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        ad_group_ad_asset_view: {
            resource_name: string;
            ad_group_ad: string;
            asset: string;
            field_type: string;
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            performance_label: string;
        };
        ad_group_ad_label: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        ad_group_audience_view: {
            resource_name: string;
        };
        ad_group_bid_modifier: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        ad_group_criterion: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        ad_group_criterion_label: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        ad_group_criterion_simulation: {
            resource_name: string;
            ad_group_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_group_extension_setting: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        ad_group_feed: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        ad_group_label: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        ad_group_simulation: {
            resource_name: string;
            ad_group_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
            cpv_bid_point_list: {
                points: {
                    cpv_bid_micros: string;
                    cost_micros: string;
                    impressions: string;
                    views: string;
                };
            };
            target_cpa_point_list: {
                points: {
                    target_cpa_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_parameter: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        age_range_view: {
            resource_name: string;
        };
        ad_schedule_view: {
            resource_name: string;
        };
        domain_category: {
            resource_name: string;
            campaign: string;
            category: string;
            language_code: string;
            domain: string;
            coverage_fraction: string;
            category_rank: string;
            has_children: string;
            recommended_cpc_bid_micros: string;
        };
        asset: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
        bidding_strategy: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        billing_setup: {
            resource_name: string;
            id: string;
            status: string;
            payments_account: string;
            payments_account_info: {
                payments_account_id: string;
                payments_account_name: string;
                payments_profile_id: string;
                payments_profile_name: string;
                secondary_payments_profile_id: string;
            };
            start_date_time: string;
            start_time_type: string;
            end_date_time: string;
            end_time_type: string;
        };
        campaign_budget: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        campaign: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        campaign_audience_view: {
            resource_name: string;
        };
        campaign_bid_modifier: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        campaign_criterion: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        campaign_criterion_simulation: {
            resource_name: string;
            campaign_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            bid_modifier_point_list: {
                points: {
                    bid_modifier: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                    parent_biddable_conversions: string;
                    parent_biddable_conversions_value: string;
                    parent_clicks: string;
                    parent_cost_micros: string;
                    parent_impressions: string;
                    parent_top_slot_impressions: string;
                    parent_required_budget_micros: string;
                };
            };
        };
        campaign_draft: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        campaign_experiment: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        campaign_extension_setting: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        campaign_feed: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        campaign_label: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        campaign_shared_set: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        carrier_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
        };
        change_status: {
            resource_name: string;
            last_change_date_time: string;
            resource_type: string;
            campaign: string;
            ad_group: string;
            resource_status: string;
            ad_group_ad: string;
            ad_group_criterion: string;
            campaign_criterion: string;
            feed: string;
            feed_item: string;
            ad_group_feed: string;
            campaign_feed: string;
            ad_group_bid_modifier: string;
        };
        conversion_action: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        click_view: {
            resource_name: string;
            gclid: string;
            area_of_interest: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            location_of_presence: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            page_number: string;
            ad_group_ad: string;
        };
        currency_constant: {
            resource_name: string;
            code: string;
            name: string;
            symbol: string;
            billable_unit_micros: string;
        };
        custom_interest: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
        customer: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        customer_manager_link: {
            resource_name: string;
            manager_customer: string;
            manager_link_id: string;
            status: string;
        };
        customer_client_link: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
        customer_client: {
            resource_name: string;
            client_customer: string;
            hidden: string;
            level: string;
            time_zone: string;
            test_account: string;
            manager: string;
            descriptive_name: string;
            currency_code: string;
            id: string;
        };
        customer_extension_setting: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        customer_feed: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        customer_label: {
            resource_name: string;
            customer: string;
            label: string;
        };
        customer_negative_criterion: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        detail_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            group_placement_target_url: string;
            target_url: string;
            placement_type: string;
        };
        display_keyword_view: {
            resource_name: string;
        };
        distance_view: {
            resource_name: string;
            distance_bucket: string;
            metric_system: string;
        };
        dynamic_search_ads_search_term_view: {
            resource_name: string;
            search_term: string;
            headline: string;
            landing_page: string;
            page_url: string;
            has_negative_keyword: string;
            has_matching_keyword: string;
            has_negative_url: string;
        };
        expanded_landing_page_view: {
            resource_name: string;
            expanded_final_url: string;
        };
        extension_feed_item: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        feed: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        feed_item: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        feed_item_target: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        feed_mapping: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        feed_placeholder_view: {
            resource_name: string;
            placeholder_type: string;
        };
        gender_view: {
            resource_name: string;
        };
        geo_target_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
        geographic_view: {
            resource_name: string;
            location_type: string;
            country_criterion_id: string;
        };
        group_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            target_url: string;
            placement_type: string;
        };
        hotel_group_view: {
            resource_name: string;
        };
        hotel_performance_view: {
            resource_name: string;
        };
        keyword_view: {
            resource_name: string;
        };
        keyword_plan: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        keyword_plan_campaign: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        keyword_plan_negative_keyword: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        keyword_plan_ad_group: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        keyword_plan_keyword: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        label: {};
        landing_page_view: {
            resource_name: string;
            unexpanded_final_url: string;
        };
        language_constant: {
            resource_name: string;
            id: string;
            code: string;
            name: string;
            targetable: string;
        };
        location_view: {
            resource_name: string;
        };
        managed_placement_view: {
            resource_name: string;
        };
        media_file: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
        mobile_app_category_constant: {
            resource_name: string;
            id: string;
            name: string;
        };
        mobile_device_constant: {
            resource_name: string;
            id: string;
            name: string;
            manufacturer_name: string;
            operating_system_name: string;
            type: string;
        };
        mutate_job: {
            resource_name: string;
            id: string;
            next_add_sequence_token: string;
            metadata: {
                creation_date_time: string;
                completion_date_time: string;
                estimated_completion_ratio: string;
                operation_count: string;
                executed_operation_count: string;
            };
            status: string;
            long_running_operation: string;
        };
        operating_system_version_constant: {
            resource_name: string;
            id: string;
            name: string;
            os_major_version: string;
            os_minor_version: string;
            operator_type: string;
        };
        paid_organic_search_term_view: {
            resource_name: string;
            search_term: string;
        };
        parental_status_view: {
            resource_name: string;
        };
        product_bidding_category_constant: {
            resource_name: string;
            id: string;
            country_code: string;
            product_bidding_category_constant_parent: string;
            level: string;
            status: string;
            language_code: string;
            localized_name: string;
        };
        product_group_view: {
            resource_name: string;
        };
        recommendation: {
            resource_name: string;
            type: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
            campaign_budget: string;
            campaign: string;
            ad_group: string;
            dismissed: string;
            campaign_budget_recommendation: {
                current_budget_amount_micros: string;
                recommended_budget_amount_micros: string;
                budget_options: {
                    budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
            };
            keyword_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_cpc_bid_micros: string;
            };
            text_ad_recommendation: {
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                creation_date: string;
                auto_apply_date: string;
            };
            target_cpa_opt_in_recommendation: {
                options: {
                    goal: string;
                    target_cpa_micros: string;
                    required_campaign_budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
                recommended_target_cpa_micros: string;
            };
            maximize_conversions_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            enhanced_cpc_opt_in_recommendation: {};
            search_partners_opt_in_recommendation: {};
            maximize_clicks_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            optimize_ad_rotation_recommendation: {};
            callout_extension_recommendation: {
                recommended_extensions: {
                    callout_text: string;
                };
            };
            sitelink_extension_recommendation: {
                recommended_extensions: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
            };
            call_extension_recommendation: {
                recommended_extensions: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
            };
            keyword_match_type_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_match_type: string;
            };
            move_unused_budget_recommendation: {
                excess_campaign_budget: string;
                budget_recommendation: {
                    current_budget_amount_micros: string;
                    recommended_budget_amount_micros: string;
                    budget_options: {
                        budget_amount_micros: string;
                        impact: {
                            base_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                            potential_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                        };
                    };
                };
            };
        };
        search_term_view: {
            resource_name: string;
            search_term: string;
            ad_group: string;
            status: string;
        };
        shared_criterion: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        shared_set: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        shopping_performance_view: {
            resource_name: string;
        };
        topic_view: {
            resource_name: string;
        };
        user_interest: {
            resource_name: string;
            taxonomy_type: string;
            user_interest_id: string;
            name: string;
            user_interest_parent: string;
            launched_to_all: string;
            availabilities: {
                channel: {
                    availability_mode: string;
                    advertising_channel_type: string;
                    advertising_channel_sub_type: string;
                    include_default_channel_sub_type: string;
                };
                locale: {
                    availability_mode: string;
                    country_code: string;
                    language_code: string;
                };
            };
        };
        user_list: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        user_location_view: {
            resource_name: string;
            country_criterion_id: string;
            targeting_location: string;
        };
        remarketing_action: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        topic_constant: {
            resource_name: string;
            id: string;
            topic_constant_parent: string;
            path: string;
        };
        video: {
            resource_name: string;
            id: string;
            channel_id: string;
            duration_millis: string;
            title: string;
        };
        metrics: {
            absolute_top_impression_percentage: string;
            active_view_cpm: string;
            active_view_ctr: string;
            active_view_impressions: string;
            active_view_measurability: string;
            active_view_measurable_cost_micros: string;
            active_view_measurable_impressions: string;
            active_view_viewability: string;
            all_conversions_from_interactions_rate: string;
            all_conversions_value: string;
            all_conversions: string;
            all_conversions_value_per_cost: string;
            all_conversions_from_click_to_call: string;
            all_conversions_from_directions: string;
            all_conversions_from_interactions_value_per_interaction: string;
            all_conversions_from_menu: string;
            all_conversions_from_order: string;
            all_conversions_from_other_engagement: string;
            all_conversions_from_store_visit: string;
            all_conversions_from_store_website: string;
            average_cost: string;
            average_cpc: string;
            average_cpe: string;
            average_cpm: string;
            average_cpv: string;
            average_page_views: string;
            average_time_on_site: string;
            benchmark_average_max_cpc: string;
            benchmark_ctr: string;
            bounce_rate: string;
            clicks: string;
            combined_clicks: string;
            combined_clicks_per_query: string;
            combined_queries: string;
            content_budget_lost_impression_share: string;
            content_impression_share: string;
            conversion_last_received_request_date_time: string;
            conversion_last_conversion_date: string;
            content_rank_lost_impression_share: string;
            conversions_from_interactions_rate: string;
            conversions_value: string;
            conversions_value_per_cost: string;
            conversions_from_interactions_value_per_interaction: string;
            conversions: string;
            cost_micros: string;
            cost_per_all_conversions: string;
            cost_per_conversion: string;
            cost_per_current_model_attributed_conversion: string;
            cross_device_conversions: string;
            ctr: string;
            current_model_attributed_conversions: string;
            current_model_attributed_conversions_from_interactions_rate: string;
            current_model_attributed_conversions_from_interactions_value_per_interaction: string;
            current_model_attributed_conversions_value: string;
            current_model_attributed_conversions_value_per_cost: string;
            engagement_rate: string;
            engagements: string;
            hotel_average_lead_value_micros: string;
            hotel_price_difference_percentage: string;
            historical_creative_quality_score: string;
            historical_landing_page_quality_score: string;
            historical_quality_score: string;
            historical_search_predicted_ctr: string;
            gmail_forwards: string;
            gmail_saves: string;
            gmail_secondary_clicks: string;
            impressions_from_store_reach: string;
            impressions: string;
            interaction_rate: string;
            interactions: string;
            interaction_event_types: string;
            invalid_click_rate: string;
            invalid_clicks: string;
            message_chats: string;
            message_impressions: string;
            message_chat_rate: string;
            mobile_friendly_clicks_percentage: string;
            organic_clicks: string;
            organic_clicks_per_query: string;
            organic_impressions: string;
            organic_impressions_per_query: string;
            organic_queries: string;
            percent_new_visitors: string;
            phone_calls: string;
            phone_impressions: string;
            phone_through_rate: string;
            relative_ctr: string;
            search_absolute_top_impression_share: string;
            search_budget_lost_absolute_top_impression_share: string;
            search_budget_lost_impression_share: string;
            search_budget_lost_top_impression_share: string;
            search_click_share: string;
            search_exact_match_impression_share: string;
            search_impression_share: string;
            search_rank_lost_absolute_top_impression_share: string;
            search_rank_lost_impression_share: string;
            search_rank_lost_top_impression_share: string;
            search_top_impression_share: string;
            speed_score: string;
            top_impression_percentage: string;
            valid_accelerated_mobile_pages_clicks_percentage: string;
            value_per_all_conversions: string;
            value_per_conversion: string;
            value_per_current_model_attributed_conversion: string;
            video_quartile_100_rate: string;
            video_quartile_25_rate: string;
            video_quartile_50_rate: string;
            video_quartile_75_rate: string;
            video_view_rate: string;
            video_views: string;
            view_through_conversions: string;
        };
        segments: {
            ad_network_type: string;
            click_type: string;
            conversion_action: string;
            conversion_action_category: string;
            conversion_action_name: string;
            conversion_adjustment: string;
            conversion_attribution_event_type: string;
            conversion_lag_bucket: string;
            conversion_or_adjustment_lag_bucket: string;
            date: string;
            day_of_week: string;
            device: string;
            external_conversion_source: string;
            geo_target_airport: string;
            geo_target_canton: string;
            geo_target_city: string;
            geo_target_country: string;
            geo_target_county: string;
            geo_target_district: string;
            geo_target_metro: string;
            geo_target_most_specific_location: string;
            geo_target_postal_code: string;
            geo_target_province: string;
            geo_target_region: string;
            geo_target_state: string;
            hotel_booking_window_days: string;
            hotel_center_id: string;
            hotel_check_in_date: string;
            hotel_check_in_day_of_week: string;
            hotel_city: string;
            hotel_class: string;
            hotel_country: string;
            hotel_date_selection_type: string;
            hotel_length_of_stay: string;
            hotel_rate_rule_id: string;
            hotel_rate_type: string;
            hotel_price_bucket: string;
            hotel_state: string;
            hour: string;
            interaction_on_this_extension: string;
            keyword: {
                ad_group_criterion: string;
                info: {
                    text: string;
                    match_type: string;
                };
            };
            month: string;
            month_of_year: string;
            partner_hotel_id: string;
            placeholder_type: string;
            product_aggregator_id: string;
            product_bidding_category_level1: string;
            product_bidding_category_level2: string;
            product_bidding_category_level3: string;
            product_bidding_category_level4: string;
            product_bidding_category_level5: string;
            product_brand: string;
            product_channel: string;
            product_channel_exclusivity: string;
            product_condition: string;
            product_country: string;
            product_custom_attribute0: string;
            product_custom_attribute1: string;
            product_custom_attribute2: string;
            product_custom_attribute3: string;
            product_custom_attribute4: string;
            product_item_id: string;
            product_language: string;
            product_merchant_id: string;
            product_store_id: string;
            product_title: string;
            product_type_l1: string;
            product_type_l2: string;
            product_type_l3: string;
            product_type_l4: string;
            product_type_l5: string;
            quarter: string;
            search_engine_results_page_type: string;
            search_term_match_type: string;
            slot: string;
            webpage: string;
            week: string;
            year: string;
        };
    };
    next_page_token: string;
    total_results_count: string;
    field_mask: {
        paths: string;
    };
    summary_row: {
        account_budget: {
            resource_name: string;
            id: string;
            billing_setup: string;
            status: string;
            name: string;
            proposed_start_date_time: string;
            approved_start_date_time: string;
            total_adjustments_micros: string;
            amount_served_micros: string;
            purchase_order_number: string;
            notes: string;
            pending_proposal: {
                account_budget_proposal: string;
                proposal_type: string;
                name: string;
                start_date_time: string;
                purchase_order_number: string;
                notes: string;
                creation_date_time: string;
                end_date_time: string;
                end_time_type: string;
                spending_limit_micros: string;
                spending_limit_type: string;
            };
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
            adjusted_spending_limit_micros: string;
            adjusted_spending_limit_type: string;
        };
        account_budget_proposal: {
            resource_name: string;
            id: string;
            billing_setup: string;
            account_budget: string;
            proposal_type: string;
            status: string;
            proposed_name: string;
            approved_start_date_time: string;
            proposed_purchase_order_number: string;
            proposed_notes: string;
            creation_date_time: string;
            approval_date_time: string;
            proposed_start_date_time: string;
            proposed_start_time_type: string;
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
        };
        ad_group: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        ad_group_ad: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        ad_group_ad_asset_view: {
            resource_name: string;
            ad_group_ad: string;
            asset: string;
            field_type: string;
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            performance_label: string;
        };
        ad_group_ad_label: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        ad_group_audience_view: {
            resource_name: string;
        };
        ad_group_bid_modifier: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        ad_group_criterion: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        ad_group_criterion_label: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        ad_group_criterion_simulation: {
            resource_name: string;
            ad_group_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_group_extension_setting: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        ad_group_feed: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        ad_group_label: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        ad_group_simulation: {
            resource_name: string;
            ad_group_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
            cpv_bid_point_list: {
                points: {
                    cpv_bid_micros: string;
                    cost_micros: string;
                    impressions: string;
                    views: string;
                };
            };
            target_cpa_point_list: {
                points: {
                    target_cpa_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_parameter: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        age_range_view: {
            resource_name: string;
        };
        ad_schedule_view: {
            resource_name: string;
        };
        domain_category: {
            resource_name: string;
            campaign: string;
            category: string;
            language_code: string;
            domain: string;
            coverage_fraction: string;
            category_rank: string;
            has_children: string;
            recommended_cpc_bid_micros: string;
        };
        asset: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
        bidding_strategy: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        billing_setup: {
            resource_name: string;
            id: string;
            status: string;
            payments_account: string;
            payments_account_info: {
                payments_account_id: string;
                payments_account_name: string;
                payments_profile_id: string;
                payments_profile_name: string;
                secondary_payments_profile_id: string;
            };
            start_date_time: string;
            start_time_type: string;
            end_date_time: string;
            end_time_type: string;
        };
        campaign_budget: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        campaign: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        campaign_audience_view: {
            resource_name: string;
        };
        campaign_bid_modifier: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        campaign_criterion: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        campaign_criterion_simulation: {
            resource_name: string;
            campaign_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            bid_modifier_point_list: {
                points: {
                    bid_modifier: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                    parent_biddable_conversions: string;
                    parent_biddable_conversions_value: string;
                    parent_clicks: string;
                    parent_cost_micros: string;
                    parent_impressions: string;
                    parent_top_slot_impressions: string;
                    parent_required_budget_micros: string;
                };
            };
        };
        campaign_draft: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        campaign_experiment: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        campaign_extension_setting: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        campaign_feed: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        campaign_label: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        campaign_shared_set: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        carrier_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
        };
        change_status: {
            resource_name: string;
            last_change_date_time: string;
            resource_type: string;
            campaign: string;
            ad_group: string;
            resource_status: string;
            ad_group_ad: string;
            ad_group_criterion: string;
            campaign_criterion: string;
            feed: string;
            feed_item: string;
            ad_group_feed: string;
            campaign_feed: string;
            ad_group_bid_modifier: string;
        };
        conversion_action: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        click_view: {
            resource_name: string;
            gclid: string;
            area_of_interest: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            location_of_presence: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            page_number: string;
            ad_group_ad: string;
        };
        currency_constant: {
            resource_name: string;
            code: string;
            name: string;
            symbol: string;
            billable_unit_micros: string;
        };
        custom_interest: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
        customer: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        customer_manager_link: {
            resource_name: string;
            manager_customer: string;
            manager_link_id: string;
            status: string;
        };
        customer_client_link: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
        customer_client: {
            resource_name: string;
            client_customer: string;
            hidden: string;
            level: string;
            time_zone: string;
            test_account: string;
            manager: string;
            descriptive_name: string;
            currency_code: string;
            id: string;
        };
        customer_extension_setting: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        customer_feed: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        customer_label: {
            resource_name: string;
            customer: string;
            label: string;
        };
        customer_negative_criterion: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        detail_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            group_placement_target_url: string;
            target_url: string;
            placement_type: string;
        };
        display_keyword_view: {
            resource_name: string;
        };
        distance_view: {
            resource_name: string;
            distance_bucket: string;
            metric_system: string;
        };
        dynamic_search_ads_search_term_view: {
            resource_name: string;
            search_term: string;
            headline: string;
            landing_page: string;
            page_url: string;
            has_negative_keyword: string;
            has_matching_keyword: string;
            has_negative_url: string;
        };
        expanded_landing_page_view: {
            resource_name: string;
            expanded_final_url: string;
        };
        extension_feed_item: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        feed: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        feed_item: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        feed_item_target: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        feed_mapping: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        feed_placeholder_view: {
            resource_name: string;
            placeholder_type: string;
        };
        gender_view: {
            resource_name: string;
        };
        geo_target_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
        geographic_view: {
            resource_name: string;
            location_type: string;
            country_criterion_id: string;
        };
        group_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            target_url: string;
            placement_type: string;
        };
        hotel_group_view: {
            resource_name: string;
        };
        hotel_performance_view: {
            resource_name: string;
        };
        keyword_view: {
            resource_name: string;
        };
        keyword_plan: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        keyword_plan_campaign: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        keyword_plan_negative_keyword: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        keyword_plan_ad_group: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        keyword_plan_keyword: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        label: {};
        landing_page_view: {
            resource_name: string;
            unexpanded_final_url: string;
        };
        language_constant: {
            resource_name: string;
            id: string;
            code: string;
            name: string;
            targetable: string;
        };
        location_view: {
            resource_name: string;
        };
        managed_placement_view: {
            resource_name: string;
        };
        media_file: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
        mobile_app_category_constant: {
            resource_name: string;
            id: string;
            name: string;
        };
        mobile_device_constant: {
            resource_name: string;
            id: string;
            name: string;
            manufacturer_name: string;
            operating_system_name: string;
            type: string;
        };
        mutate_job: {
            resource_name: string;
            id: string;
            next_add_sequence_token: string;
            metadata: {
                creation_date_time: string;
                completion_date_time: string;
                estimated_completion_ratio: string;
                operation_count: string;
                executed_operation_count: string;
            };
            status: string;
            long_running_operation: string;
        };
        operating_system_version_constant: {
            resource_name: string;
            id: string;
            name: string;
            os_major_version: string;
            os_minor_version: string;
            operator_type: string;
        };
        paid_organic_search_term_view: {
            resource_name: string;
            search_term: string;
        };
        parental_status_view: {
            resource_name: string;
        };
        product_bidding_category_constant: {
            resource_name: string;
            id: string;
            country_code: string;
            product_bidding_category_constant_parent: string;
            level: string;
            status: string;
            language_code: string;
            localized_name: string;
        };
        product_group_view: {
            resource_name: string;
        };
        recommendation: {
            resource_name: string;
            type: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
            campaign_budget: string;
            campaign: string;
            ad_group: string;
            dismissed: string;
            campaign_budget_recommendation: {
                current_budget_amount_micros: string;
                recommended_budget_amount_micros: string;
                budget_options: {
                    budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
            };
            keyword_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_cpc_bid_micros: string;
            };
            text_ad_recommendation: {
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                creation_date: string;
                auto_apply_date: string;
            };
            target_cpa_opt_in_recommendation: {
                options: {
                    goal: string;
                    target_cpa_micros: string;
                    required_campaign_budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
                recommended_target_cpa_micros: string;
            };
            maximize_conversions_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            enhanced_cpc_opt_in_recommendation: {};
            search_partners_opt_in_recommendation: {};
            maximize_clicks_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            optimize_ad_rotation_recommendation: {};
            callout_extension_recommendation: {
                recommended_extensions: {
                    callout_text: string;
                };
            };
            sitelink_extension_recommendation: {
                recommended_extensions: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
            };
            call_extension_recommendation: {
                recommended_extensions: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
            };
            keyword_match_type_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_match_type: string;
            };
            move_unused_budget_recommendation: {
                excess_campaign_budget: string;
                budget_recommendation: {
                    current_budget_amount_micros: string;
                    recommended_budget_amount_micros: string;
                    budget_options: {
                        budget_amount_micros: string;
                        impact: {
                            base_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                            potential_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                        };
                    };
                };
            };
        };
        search_term_view: {
            resource_name: string;
            search_term: string;
            ad_group: string;
            status: string;
        };
        shared_criterion: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        shared_set: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        shopping_performance_view: {
            resource_name: string;
        };
        topic_view: {
            resource_name: string;
        };
        user_interest: {
            resource_name: string;
            taxonomy_type: string;
            user_interest_id: string;
            name: string;
            user_interest_parent: string;
            launched_to_all: string;
            availabilities: {
                channel: {
                    availability_mode: string;
                    advertising_channel_type: string;
                    advertising_channel_sub_type: string;
                    include_default_channel_sub_type: string;
                };
                locale: {
                    availability_mode: string;
                    country_code: string;
                    language_code: string;
                };
            };
        };
        user_list: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        user_location_view: {
            resource_name: string;
            country_criterion_id: string;
            targeting_location: string;
        };
        remarketing_action: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        topic_constant: {
            resource_name: string;
            id: string;
            topic_constant_parent: string;
            path: string;
        };
        video: {
            resource_name: string;
            id: string;
            channel_id: string;
            duration_millis: string;
            title: string;
        };
        metrics: {
            absolute_top_impression_percentage: string;
            active_view_cpm: string;
            active_view_ctr: string;
            active_view_impressions: string;
            active_view_measurability: string;
            active_view_measurable_cost_micros: string;
            active_view_measurable_impressions: string;
            active_view_viewability: string;
            all_conversions_from_interactions_rate: string;
            all_conversions_value: string;
            all_conversions: string;
            all_conversions_value_per_cost: string;
            all_conversions_from_click_to_call: string;
            all_conversions_from_directions: string;
            all_conversions_from_interactions_value_per_interaction: string;
            all_conversions_from_menu: string;
            all_conversions_from_order: string;
            all_conversions_from_other_engagement: string;
            all_conversions_from_store_visit: string;
            all_conversions_from_store_website: string;
            average_cost: string;
            average_cpc: string;
            average_cpe: string;
            average_cpm: string;
            average_cpv: string;
            average_page_views: string;
            average_time_on_site: string;
            benchmark_average_max_cpc: string;
            benchmark_ctr: string;
            bounce_rate: string;
            clicks: string;
            combined_clicks: string;
            combined_clicks_per_query: string;
            combined_queries: string;
            content_budget_lost_impression_share: string;
            content_impression_share: string;
            conversion_last_received_request_date_time: string;
            conversion_last_conversion_date: string;
            content_rank_lost_impression_share: string;
            conversions_from_interactions_rate: string;
            conversions_value: string;
            conversions_value_per_cost: string;
            conversions_from_interactions_value_per_interaction: string;
            conversions: string;
            cost_micros: string;
            cost_per_all_conversions: string;
            cost_per_conversion: string;
            cost_per_current_model_attributed_conversion: string;
            cross_device_conversions: string;
            ctr: string;
            current_model_attributed_conversions: string;
            current_model_attributed_conversions_from_interactions_rate: string;
            current_model_attributed_conversions_from_interactions_value_per_interaction: string;
            current_model_attributed_conversions_value: string;
            current_model_attributed_conversions_value_per_cost: string;
            engagement_rate: string;
            engagements: string;
            hotel_average_lead_value_micros: string;
            hotel_price_difference_percentage: string;
            historical_creative_quality_score: string;
            historical_landing_page_quality_score: string;
            historical_quality_score: string;
            historical_search_predicted_ctr: string;
            gmail_forwards: string;
            gmail_saves: string;
            gmail_secondary_clicks: string;
            impressions_from_store_reach: string;
            impressions: string;
            interaction_rate: string;
            interactions: string;
            interaction_event_types: string;
            invalid_click_rate: string;
            invalid_clicks: string;
            message_chats: string;
            message_impressions: string;
            message_chat_rate: string;
            mobile_friendly_clicks_percentage: string;
            organic_clicks: string;
            organic_clicks_per_query: string;
            organic_impressions: string;
            organic_impressions_per_query: string;
            organic_queries: string;
            percent_new_visitors: string;
            phone_calls: string;
            phone_impressions: string;
            phone_through_rate: string;
            relative_ctr: string;
            search_absolute_top_impression_share: string;
            search_budget_lost_absolute_top_impression_share: string;
            search_budget_lost_impression_share: string;
            search_budget_lost_top_impression_share: string;
            search_click_share: string;
            search_exact_match_impression_share: string;
            search_impression_share: string;
            search_rank_lost_absolute_top_impression_share: string;
            search_rank_lost_impression_share: string;
            search_rank_lost_top_impression_share: string;
            search_top_impression_share: string;
            speed_score: string;
            top_impression_percentage: string;
            valid_accelerated_mobile_pages_clicks_percentage: string;
            value_per_all_conversions: string;
            value_per_conversion: string;
            value_per_current_model_attributed_conversion: string;
            video_quartile_100_rate: string;
            video_quartile_25_rate: string;
            video_quartile_50_rate: string;
            video_quartile_75_rate: string;
            video_view_rate: string;
            video_views: string;
            view_through_conversions: string;
        };
        segments: {
            ad_network_type: string;
            click_type: string;
            conversion_action: string;
            conversion_action_category: string;
            conversion_action_name: string;
            conversion_adjustment: string;
            conversion_attribution_event_type: string;
            conversion_lag_bucket: string;
            conversion_or_adjustment_lag_bucket: string;
            date: string;
            day_of_week: string;
            device: string;
            external_conversion_source: string;
            geo_target_airport: string;
            geo_target_canton: string;
            geo_target_city: string;
            geo_target_country: string;
            geo_target_county: string;
            geo_target_district: string;
            geo_target_metro: string;
            geo_target_most_specific_location: string;
            geo_target_postal_code: string;
            geo_target_province: string;
            geo_target_region: string;
            geo_target_state: string;
            hotel_booking_window_days: string;
            hotel_center_id: string;
            hotel_check_in_date: string;
            hotel_check_in_day_of_week: string;
            hotel_city: string;
            hotel_class: string;
            hotel_country: string;
            hotel_date_selection_type: string;
            hotel_length_of_stay: string;
            hotel_rate_rule_id: string;
            hotel_rate_type: string;
            hotel_price_bucket: string;
            hotel_state: string;
            hour: string;
            interaction_on_this_extension: string;
            keyword: {
                ad_group_criterion: string;
                info: {
                    text: string;
                    match_type: string;
                };
            };
            month: string;
            month_of_year: string;
            partner_hotel_id: string;
            placeholder_type: string;
            product_aggregator_id: string;
            product_bidding_category_level1: string;
            product_bidding_category_level2: string;
            product_bidding_category_level3: string;
            product_bidding_category_level4: string;
            product_bidding_category_level5: string;
            product_brand: string;
            product_channel: string;
            product_channel_exclusivity: string;
            product_condition: string;
            product_country: string;
            product_custom_attribute0: string;
            product_custom_attribute1: string;
            product_custom_attribute2: string;
            product_custom_attribute3: string;
            product_custom_attribute4: string;
            product_item_id: string;
            product_language: string;
            product_merchant_id: string;
            product_store_id: string;
            product_title: string;
            product_type_l1: string;
            product_type_l2: string;
            product_type_l3: string;
            product_type_l4: string;
            product_type_l5: string;
            quarter: string;
            search_engine_results_page_type: string;
            search_term_match_type: string;
            slot: string;
            webpage: string;
            week: string;
            year: string;
        };
    };
};
export declare const SearchGoogleAdsStreamRequest: {
    customer_id: string;
    query: string;
    summary_row_setting: string;
};
export declare const SearchGoogleAdsStreamResponse: {
    results: {
        account_budget: {
            resource_name: string;
            id: string;
            billing_setup: string;
            status: string;
            name: string;
            proposed_start_date_time: string;
            approved_start_date_time: string;
            total_adjustments_micros: string;
            amount_served_micros: string;
            purchase_order_number: string;
            notes: string;
            pending_proposal: {
                account_budget_proposal: string;
                proposal_type: string;
                name: string;
                start_date_time: string;
                purchase_order_number: string;
                notes: string;
                creation_date_time: string;
                end_date_time: string;
                end_time_type: string;
                spending_limit_micros: string;
                spending_limit_type: string;
            };
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
            adjusted_spending_limit_micros: string;
            adjusted_spending_limit_type: string;
        };
        account_budget_proposal: {
            resource_name: string;
            id: string;
            billing_setup: string;
            account_budget: string;
            proposal_type: string;
            status: string;
            proposed_name: string;
            approved_start_date_time: string;
            proposed_purchase_order_number: string;
            proposed_notes: string;
            creation_date_time: string;
            approval_date_time: string;
            proposed_start_date_time: string;
            proposed_start_time_type: string;
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
        };
        ad_group: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        ad_group_ad: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        ad_group_ad_asset_view: {
            resource_name: string;
            ad_group_ad: string;
            asset: string;
            field_type: string;
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            performance_label: string;
        };
        ad_group_ad_label: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        ad_group_audience_view: {
            resource_name: string;
        };
        ad_group_bid_modifier: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        ad_group_criterion: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        ad_group_criterion_label: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        ad_group_criterion_simulation: {
            resource_name: string;
            ad_group_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_group_extension_setting: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        ad_group_feed: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        ad_group_label: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        ad_group_simulation: {
            resource_name: string;
            ad_group_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
            cpv_bid_point_list: {
                points: {
                    cpv_bid_micros: string;
                    cost_micros: string;
                    impressions: string;
                    views: string;
                };
            };
            target_cpa_point_list: {
                points: {
                    target_cpa_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_parameter: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        age_range_view: {
            resource_name: string;
        };
        ad_schedule_view: {
            resource_name: string;
        };
        domain_category: {
            resource_name: string;
            campaign: string;
            category: string;
            language_code: string;
            domain: string;
            coverage_fraction: string;
            category_rank: string;
            has_children: string;
            recommended_cpc_bid_micros: string;
        };
        asset: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
        bidding_strategy: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        billing_setup: {
            resource_name: string;
            id: string;
            status: string;
            payments_account: string;
            payments_account_info: {
                payments_account_id: string;
                payments_account_name: string;
                payments_profile_id: string;
                payments_profile_name: string;
                secondary_payments_profile_id: string;
            };
            start_date_time: string;
            start_time_type: string;
            end_date_time: string;
            end_time_type: string;
        };
        campaign_budget: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        campaign: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        campaign_audience_view: {
            resource_name: string;
        };
        campaign_bid_modifier: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        campaign_criterion: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        campaign_criterion_simulation: {
            resource_name: string;
            campaign_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            bid_modifier_point_list: {
                points: {
                    bid_modifier: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                    parent_biddable_conversions: string;
                    parent_biddable_conversions_value: string;
                    parent_clicks: string;
                    parent_cost_micros: string;
                    parent_impressions: string;
                    parent_top_slot_impressions: string;
                    parent_required_budget_micros: string;
                };
            };
        };
        campaign_draft: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        campaign_experiment: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        campaign_extension_setting: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        campaign_feed: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        campaign_label: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        campaign_shared_set: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        carrier_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
        };
        change_status: {
            resource_name: string;
            last_change_date_time: string;
            resource_type: string;
            campaign: string;
            ad_group: string;
            resource_status: string;
            ad_group_ad: string;
            ad_group_criterion: string;
            campaign_criterion: string;
            feed: string;
            feed_item: string;
            ad_group_feed: string;
            campaign_feed: string;
            ad_group_bid_modifier: string;
        };
        conversion_action: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        click_view: {
            resource_name: string;
            gclid: string;
            area_of_interest: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            location_of_presence: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            page_number: string;
            ad_group_ad: string;
        };
        currency_constant: {
            resource_name: string;
            code: string;
            name: string;
            symbol: string;
            billable_unit_micros: string;
        };
        custom_interest: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
        customer: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        customer_manager_link: {
            resource_name: string;
            manager_customer: string;
            manager_link_id: string;
            status: string;
        };
        customer_client_link: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
        customer_client: {
            resource_name: string;
            client_customer: string;
            hidden: string;
            level: string;
            time_zone: string;
            test_account: string;
            manager: string;
            descriptive_name: string;
            currency_code: string;
            id: string;
        };
        customer_extension_setting: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        customer_feed: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        customer_label: {
            resource_name: string;
            customer: string;
            label: string;
        };
        customer_negative_criterion: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        detail_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            group_placement_target_url: string;
            target_url: string;
            placement_type: string;
        };
        display_keyword_view: {
            resource_name: string;
        };
        distance_view: {
            resource_name: string;
            distance_bucket: string;
            metric_system: string;
        };
        dynamic_search_ads_search_term_view: {
            resource_name: string;
            search_term: string;
            headline: string;
            landing_page: string;
            page_url: string;
            has_negative_keyword: string;
            has_matching_keyword: string;
            has_negative_url: string;
        };
        expanded_landing_page_view: {
            resource_name: string;
            expanded_final_url: string;
        };
        extension_feed_item: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        feed: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        feed_item: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        feed_item_target: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        feed_mapping: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        feed_placeholder_view: {
            resource_name: string;
            placeholder_type: string;
        };
        gender_view: {
            resource_name: string;
        };
        geo_target_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
        geographic_view: {
            resource_name: string;
            location_type: string;
            country_criterion_id: string;
        };
        group_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            target_url: string;
            placement_type: string;
        };
        hotel_group_view: {
            resource_name: string;
        };
        hotel_performance_view: {
            resource_name: string;
        };
        keyword_view: {
            resource_name: string;
        };
        keyword_plan: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        keyword_plan_campaign: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        keyword_plan_negative_keyword: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        keyword_plan_ad_group: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        keyword_plan_keyword: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        label: {};
        landing_page_view: {
            resource_name: string;
            unexpanded_final_url: string;
        };
        language_constant: {
            resource_name: string;
            id: string;
            code: string;
            name: string;
            targetable: string;
        };
        location_view: {
            resource_name: string;
        };
        managed_placement_view: {
            resource_name: string;
        };
        media_file: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
        mobile_app_category_constant: {
            resource_name: string;
            id: string;
            name: string;
        };
        mobile_device_constant: {
            resource_name: string;
            id: string;
            name: string;
            manufacturer_name: string;
            operating_system_name: string;
            type: string;
        };
        mutate_job: {
            resource_name: string;
            id: string;
            next_add_sequence_token: string;
            metadata: {
                creation_date_time: string;
                completion_date_time: string;
                estimated_completion_ratio: string;
                operation_count: string;
                executed_operation_count: string;
            };
            status: string;
            long_running_operation: string;
        };
        operating_system_version_constant: {
            resource_name: string;
            id: string;
            name: string;
            os_major_version: string;
            os_minor_version: string;
            operator_type: string;
        };
        paid_organic_search_term_view: {
            resource_name: string;
            search_term: string;
        };
        parental_status_view: {
            resource_name: string;
        };
        product_bidding_category_constant: {
            resource_name: string;
            id: string;
            country_code: string;
            product_bidding_category_constant_parent: string;
            level: string;
            status: string;
            language_code: string;
            localized_name: string;
        };
        product_group_view: {
            resource_name: string;
        };
        recommendation: {
            resource_name: string;
            type: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
            campaign_budget: string;
            campaign: string;
            ad_group: string;
            dismissed: string;
            campaign_budget_recommendation: {
                current_budget_amount_micros: string;
                recommended_budget_amount_micros: string;
                budget_options: {
                    budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
            };
            keyword_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_cpc_bid_micros: string;
            };
            text_ad_recommendation: {
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                creation_date: string;
                auto_apply_date: string;
            };
            target_cpa_opt_in_recommendation: {
                options: {
                    goal: string;
                    target_cpa_micros: string;
                    required_campaign_budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
                recommended_target_cpa_micros: string;
            };
            maximize_conversions_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            enhanced_cpc_opt_in_recommendation: {};
            search_partners_opt_in_recommendation: {};
            maximize_clicks_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            optimize_ad_rotation_recommendation: {};
            callout_extension_recommendation: {
                recommended_extensions: {
                    callout_text: string;
                };
            };
            sitelink_extension_recommendation: {
                recommended_extensions: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
            };
            call_extension_recommendation: {
                recommended_extensions: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
            };
            keyword_match_type_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_match_type: string;
            };
            move_unused_budget_recommendation: {
                excess_campaign_budget: string;
                budget_recommendation: {
                    current_budget_amount_micros: string;
                    recommended_budget_amount_micros: string;
                    budget_options: {
                        budget_amount_micros: string;
                        impact: {
                            base_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                            potential_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                        };
                    };
                };
            };
        };
        search_term_view: {
            resource_name: string;
            search_term: string;
            ad_group: string;
            status: string;
        };
        shared_criterion: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        shared_set: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        shopping_performance_view: {
            resource_name: string;
        };
        topic_view: {
            resource_name: string;
        };
        user_interest: {
            resource_name: string;
            taxonomy_type: string;
            user_interest_id: string;
            name: string;
            user_interest_parent: string;
            launched_to_all: string;
            availabilities: {
                channel: {
                    availability_mode: string;
                    advertising_channel_type: string;
                    advertising_channel_sub_type: string;
                    include_default_channel_sub_type: string;
                };
                locale: {
                    availability_mode: string;
                    country_code: string;
                    language_code: string;
                };
            };
        };
        user_list: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        user_location_view: {
            resource_name: string;
            country_criterion_id: string;
            targeting_location: string;
        };
        remarketing_action: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        topic_constant: {
            resource_name: string;
            id: string;
            topic_constant_parent: string;
            path: string;
        };
        video: {
            resource_name: string;
            id: string;
            channel_id: string;
            duration_millis: string;
            title: string;
        };
        metrics: {
            absolute_top_impression_percentage: string;
            active_view_cpm: string;
            active_view_ctr: string;
            active_view_impressions: string;
            active_view_measurability: string;
            active_view_measurable_cost_micros: string;
            active_view_measurable_impressions: string;
            active_view_viewability: string;
            all_conversions_from_interactions_rate: string;
            all_conversions_value: string;
            all_conversions: string;
            all_conversions_value_per_cost: string;
            all_conversions_from_click_to_call: string;
            all_conversions_from_directions: string;
            all_conversions_from_interactions_value_per_interaction: string;
            all_conversions_from_menu: string;
            all_conversions_from_order: string;
            all_conversions_from_other_engagement: string;
            all_conversions_from_store_visit: string;
            all_conversions_from_store_website: string;
            average_cost: string;
            average_cpc: string;
            average_cpe: string;
            average_cpm: string;
            average_cpv: string;
            average_page_views: string;
            average_time_on_site: string;
            benchmark_average_max_cpc: string;
            benchmark_ctr: string;
            bounce_rate: string;
            clicks: string;
            combined_clicks: string;
            combined_clicks_per_query: string;
            combined_queries: string;
            content_budget_lost_impression_share: string;
            content_impression_share: string;
            conversion_last_received_request_date_time: string;
            conversion_last_conversion_date: string;
            content_rank_lost_impression_share: string;
            conversions_from_interactions_rate: string;
            conversions_value: string;
            conversions_value_per_cost: string;
            conversions_from_interactions_value_per_interaction: string;
            conversions: string;
            cost_micros: string;
            cost_per_all_conversions: string;
            cost_per_conversion: string;
            cost_per_current_model_attributed_conversion: string;
            cross_device_conversions: string;
            ctr: string;
            current_model_attributed_conversions: string;
            current_model_attributed_conversions_from_interactions_rate: string;
            current_model_attributed_conversions_from_interactions_value_per_interaction: string;
            current_model_attributed_conversions_value: string;
            current_model_attributed_conversions_value_per_cost: string;
            engagement_rate: string;
            engagements: string;
            hotel_average_lead_value_micros: string;
            hotel_price_difference_percentage: string;
            historical_creative_quality_score: string;
            historical_landing_page_quality_score: string;
            historical_quality_score: string;
            historical_search_predicted_ctr: string;
            gmail_forwards: string;
            gmail_saves: string;
            gmail_secondary_clicks: string;
            impressions_from_store_reach: string;
            impressions: string;
            interaction_rate: string;
            interactions: string;
            interaction_event_types: string;
            invalid_click_rate: string;
            invalid_clicks: string;
            message_chats: string;
            message_impressions: string;
            message_chat_rate: string;
            mobile_friendly_clicks_percentage: string;
            organic_clicks: string;
            organic_clicks_per_query: string;
            organic_impressions: string;
            organic_impressions_per_query: string;
            organic_queries: string;
            percent_new_visitors: string;
            phone_calls: string;
            phone_impressions: string;
            phone_through_rate: string;
            relative_ctr: string;
            search_absolute_top_impression_share: string;
            search_budget_lost_absolute_top_impression_share: string;
            search_budget_lost_impression_share: string;
            search_budget_lost_top_impression_share: string;
            search_click_share: string;
            search_exact_match_impression_share: string;
            search_impression_share: string;
            search_rank_lost_absolute_top_impression_share: string;
            search_rank_lost_impression_share: string;
            search_rank_lost_top_impression_share: string;
            search_top_impression_share: string;
            speed_score: string;
            top_impression_percentage: string;
            valid_accelerated_mobile_pages_clicks_percentage: string;
            value_per_all_conversions: string;
            value_per_conversion: string;
            value_per_current_model_attributed_conversion: string;
            video_quartile_100_rate: string;
            video_quartile_25_rate: string;
            video_quartile_50_rate: string;
            video_quartile_75_rate: string;
            video_view_rate: string;
            video_views: string;
            view_through_conversions: string;
        };
        segments: {
            ad_network_type: string;
            click_type: string;
            conversion_action: string;
            conversion_action_category: string;
            conversion_action_name: string;
            conversion_adjustment: string;
            conversion_attribution_event_type: string;
            conversion_lag_bucket: string;
            conversion_or_adjustment_lag_bucket: string;
            date: string;
            day_of_week: string;
            device: string;
            external_conversion_source: string;
            geo_target_airport: string;
            geo_target_canton: string;
            geo_target_city: string;
            geo_target_country: string;
            geo_target_county: string;
            geo_target_district: string;
            geo_target_metro: string;
            geo_target_most_specific_location: string;
            geo_target_postal_code: string;
            geo_target_province: string;
            geo_target_region: string;
            geo_target_state: string;
            hotel_booking_window_days: string;
            hotel_center_id: string;
            hotel_check_in_date: string;
            hotel_check_in_day_of_week: string;
            hotel_city: string;
            hotel_class: string;
            hotel_country: string;
            hotel_date_selection_type: string;
            hotel_length_of_stay: string;
            hotel_rate_rule_id: string;
            hotel_rate_type: string;
            hotel_price_bucket: string;
            hotel_state: string;
            hour: string;
            interaction_on_this_extension: string;
            keyword: {
                ad_group_criterion: string;
                info: {
                    text: string;
                    match_type: string;
                };
            };
            month: string;
            month_of_year: string;
            partner_hotel_id: string;
            placeholder_type: string;
            product_aggregator_id: string;
            product_bidding_category_level1: string;
            product_bidding_category_level2: string;
            product_bidding_category_level3: string;
            product_bidding_category_level4: string;
            product_bidding_category_level5: string;
            product_brand: string;
            product_channel: string;
            product_channel_exclusivity: string;
            product_condition: string;
            product_country: string;
            product_custom_attribute0: string;
            product_custom_attribute1: string;
            product_custom_attribute2: string;
            product_custom_attribute3: string;
            product_custom_attribute4: string;
            product_item_id: string;
            product_language: string;
            product_merchant_id: string;
            product_store_id: string;
            product_title: string;
            product_type_l1: string;
            product_type_l2: string;
            product_type_l3: string;
            product_type_l4: string;
            product_type_l5: string;
            quarter: string;
            search_engine_results_page_type: string;
            search_term_match_type: string;
            slot: string;
            webpage: string;
            week: string;
            year: string;
        };
    };
    field_mask: {
        paths: string;
    };
    summary_row: {
        account_budget: {
            resource_name: string;
            id: string;
            billing_setup: string;
            status: string;
            name: string;
            proposed_start_date_time: string;
            approved_start_date_time: string;
            total_adjustments_micros: string;
            amount_served_micros: string;
            purchase_order_number: string;
            notes: string;
            pending_proposal: {
                account_budget_proposal: string;
                proposal_type: string;
                name: string;
                start_date_time: string;
                purchase_order_number: string;
                notes: string;
                creation_date_time: string;
                end_date_time: string;
                end_time_type: string;
                spending_limit_micros: string;
                spending_limit_type: string;
            };
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
            adjusted_spending_limit_micros: string;
            adjusted_spending_limit_type: string;
        };
        account_budget_proposal: {
            resource_name: string;
            id: string;
            billing_setup: string;
            account_budget: string;
            proposal_type: string;
            status: string;
            proposed_name: string;
            approved_start_date_time: string;
            proposed_purchase_order_number: string;
            proposed_notes: string;
            creation_date_time: string;
            approval_date_time: string;
            proposed_start_date_time: string;
            proposed_start_time_type: string;
            proposed_end_date_time: string;
            proposed_end_time_type: string;
            approved_end_date_time: string;
            approved_end_time_type: string;
            proposed_spending_limit_micros: string;
            proposed_spending_limit_type: string;
            approved_spending_limit_micros: string;
            approved_spending_limit_type: string;
        };
        ad_group: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            ad_rotation_mode: string;
            base_ad_group: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            campaign: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            target_cpa_micros: string;
            cpv_bid_micros: string;
            target_cpm_micros: string;
            target_roas: string;
            percent_cpc_bid_micros: string;
            explorer_auto_optimizer_setting: {
                opt_in: string;
            };
            display_custom_bid_dimension: string;
            final_url_suffix: string;
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            effective_target_cpa_micros: string;
            effective_target_cpa_source: string;
            effective_target_roas: string;
            effective_target_roas_source: string;
            labels: string;
        };
        ad_group_ad: {
            resource_name: string;
            status: string;
            ad_group: string;
            ad: {
                resource_name: string;
                id: string;
                final_urls: string;
                final_app_urls: {
                    os_type: string;
                    url: string;
                };
                final_mobile_urls: string;
                tracking_url_template: string;
                final_url_suffix: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                display_url: string;
                type: string;
                added_by_google_ads: string;
                device_preference: string;
                url_collections: {
                    url_collection_id: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                };
                name: string;
                system_managed_resource_source: string;
                text_ad: {
                    headline: string;
                    description1: string;
                    description2: string;
                };
                expanded_text_ad: {
                    headline_part1: string;
                    headline_part2: string;
                    headline_part3: string;
                    description: string;
                    description2: string;
                    path1: string;
                    path2: string;
                };
                call_only_ad: {
                    country_code: string;
                    phone_number: string;
                    business_name: string;
                    headline1: string;
                    headline2: string;
                    description1: string;
                    description2: string;
                    call_tracked: string;
                    disable_call_conversion: string;
                    phone_number_verification_url: string;
                    conversion_action: string;
                    conversion_reporting_state: string;
                };
                expanded_dynamic_search_ad: {
                    description: string;
                    description2: string;
                };
                hotel_ad: {};
                shopping_smart_ad: {};
                shopping_product_ad: {};
                gmail_ad: {
                    teaser: {
                        headline: string;
                        description: string;
                        business_name: string;
                        logo_image: string;
                    };
                    header_image: string;
                    marketing_image: string;
                    marketing_image_headline: string;
                    marketing_image_description: string;
                    marketing_image_display_call_to_action: {
                        text: string;
                        text_color: string;
                        url_collection_id: string;
                    };
                    product_images: {
                        product_image: string;
                        description: string;
                        display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                    };
                    product_videos: {
                        product_video: string;
                    };
                };
                image_ad: {
                    pixel_width: string;
                    pixel_height: string;
                    image_url: string;
                    preview_pixel_width: string;
                    preview_pixel_height: string;
                    preview_image_url: string;
                    mime_type: string;
                    name: string;
                    media_file: string;
                    data: string;
                    ad_id_to_copy_image_from: string;
                };
                video_ad: {
                    media_file: string;
                    in_stream: {
                        action_button_label: string;
                        action_headline: string;
                        companion_banner: string;
                    };
                    bumper: {
                        companion_banner: string;
                    };
                    out_stream: {
                        headline: string;
                        description: string;
                    };
                    non_skippable: {
                        companion_banner: string;
                    };
                    discovery: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                };
                responsive_search_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    path1: string;
                    path2: string;
                };
                legacy_responsive_display_ad: {
                    short_headline: string;
                    long_headline: string;
                    description: string;
                    business_name: string;
                    allow_flexible_color: string;
                    accent_color: string;
                    main_color: string;
                    call_to_action_text: string;
                    logo_image: string;
                    square_logo_image: string;
                    marketing_image: string;
                    square_marketing_image: string;
                    format_setting: string;
                    price_prefix: string;
                    promo_text: string;
                };
                app_ad: {
                    mandatory_ad_text: {
                        text: string;
                        pinned_field: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    html_5_media_bundles: {
                        asset: string;
                    };
                };
                legacy_app_install_ad: {
                    app_id: string;
                    app_store: string;
                    headline: string;
                    description1: string;
                    description2: string;
                };
                responsive_display_ad: {
                    marketing_images: {
                        asset: string;
                    };
                    square_marketing_images: {
                        asset: string;
                    };
                    logo_images: {
                        asset: string;
                    };
                    square_logo_images: {
                        asset: string;
                    };
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    long_headline: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    youtube_videos: {
                        asset: string;
                    };
                    business_name: string;
                    main_color: string;
                    accent_color: string;
                    allow_flexible_color: string;
                    call_to_action_text: string;
                    price_prefix: string;
                    promo_text: string;
                    format_setting: string;
                };
                display_upload_ad: {
                    display_upload_product_type: string;
                    media_bundle: {
                        asset: string;
                    };
                };
                app_engagement_ad: {
                    headlines: {
                        text: string;
                        pinned_field: string;
                    };
                    descriptions: {
                        text: string;
                        pinned_field: string;
                    };
                    images: {
                        asset: string;
                    };
                    videos: {
                        asset: string;
                    };
                };
                shopping_comparison_listing_ad: {
                    headline: string;
                };
            };
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            ad_strength: string;
        };
        ad_group_ad_asset_view: {
            resource_name: string;
            ad_group_ad: string;
            asset: string;
            field_type: string;
            policy_summary: {
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                review_status: string;
                approval_status: string;
            };
            performance_label: string;
        };
        ad_group_ad_label: {
            resource_name: string;
            ad_group_ad: string;
            label: string;
        };
        ad_group_audience_view: {
            resource_name: string;
        };
        ad_group_bid_modifier: {
            resource_name: string;
            ad_group: string;
            criterion_id: string;
            bid_modifier: string;
            base_ad_group: string;
            bid_modifier_source: string;
            hotel_date_selection_type: {
                type: string;
            };
            hotel_advance_booking_window: {
                min_days: string;
                max_days: string;
            };
            hotel_length_of_stay: {
                min_nights: string;
                max_nights: string;
            };
            hotel_check_in_day: {
                day_of_week: string;
            };
            device: {
                type: string;
            };
            preferred_content: {
                type: string;
            };
        };
        ad_group_criterion: {
            resource_name: string;
            criterion_id: string;
            status: string;
            quality_info: {
                quality_score: string;
                creative_quality_score: string;
                post_click_quality_score: string;
                search_predicted_ctr: string;
            };
            ad_group: string;
            type: string;
            negative: string;
            system_serving_status: string;
            approval_status: string;
            bid_modifier: string;
            cpc_bid_micros: string;
            cpm_bid_micros: string;
            cpv_bid_micros: string;
            percent_cpc_bid_micros: string;
            effective_cpc_bid_micros: string;
            effective_cpm_bid_micros: string;
            effective_cpv_bid_micros: string;
            effective_percent_cpc_bid_micros: string;
            effective_cpc_bid_source: string;
            effective_cpm_bid_source: string;
            effective_cpv_bid_source: string;
            effective_percent_cpc_bid_source: string;
            position_estimates: {
                first_page_cpc_micros: string;
                first_position_cpc_micros: string;
                top_of_page_cpc_micros: string;
                estimated_add_clicks_at_first_position_cpc: string;
                estimated_add_cost_at_first_position_cpc: string;
            };
            final_urls: string;
            final_mobile_urls: string;
            final_url_suffix: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            listing_group: {
                type: string;
                case_value: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
                parent_ad_group_criterion: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            app_payment_model: {
                type: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
            custom_intent: {
                custom_intent: string;
            };
        };
        ad_group_criterion_label: {
            resource_name: string;
            ad_group_criterion: string;
            label: string;
        };
        ad_group_criterion_simulation: {
            resource_name: string;
            ad_group_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_group_extension_setting: {
            resource_name: string;
            extension_type: string;
            ad_group: string;
            extension_feed_items: string;
            device: string;
        };
        ad_group_feed: {
            resource_name: string;
            feed: string;
            ad_group: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        ad_group_label: {
            resource_name: string;
            ad_group: string;
            label: string;
        };
        ad_group_simulation: {
            resource_name: string;
            ad_group_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            cpc_bid_point_list: {
                points: {
                    cpc_bid_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
            cpv_bid_point_list: {
                points: {
                    cpv_bid_micros: string;
                    cost_micros: string;
                    impressions: string;
                    views: string;
                };
            };
            target_cpa_point_list: {
                points: {
                    target_cpa_micros: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                };
            };
        };
        ad_parameter: {
            resource_name: string;
            ad_group_criterion: string;
            parameter_index: string;
            insertion_text: string;
        };
        age_range_view: {
            resource_name: string;
        };
        ad_schedule_view: {
            resource_name: string;
        };
        domain_category: {
            resource_name: string;
            campaign: string;
            category: string;
            language_code: string;
            domain: string;
            coverage_fraction: string;
            category_rank: string;
            has_children: string;
            recommended_cpc_bid_micros: string;
        };
        asset: {
            resource_name: string;
            id: string;
            name: string;
            type: string;
            youtube_video_asset: {
                youtube_video_id: string;
            };
            media_bundle_asset: {
                data: string;
            };
            image_asset: {
                data: string;
                file_size: string;
                mime_type: string;
                full_size: {
                    height_pixels: string;
                    width_pixels: string;
                    url: string;
                };
            };
            text_asset: {
                text: string;
            };
        };
        bidding_strategy: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            campaign_count: string;
            non_removed_campaign_count: string;
            enhanced_cpc: {};
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
        };
        billing_setup: {
            resource_name: string;
            id: string;
            status: string;
            payments_account: string;
            payments_account_info: {
                payments_account_id: string;
                payments_account_name: string;
                payments_profile_id: string;
                payments_profile_name: string;
                secondary_payments_profile_id: string;
            };
            start_date_time: string;
            start_time_type: string;
            end_date_time: string;
            end_time_type: string;
        };
        campaign_budget: {
            resource_name: string;
            id: string;
            name: string;
            amount_micros: string;
            total_amount_micros: string;
            status: string;
            delivery_method: string;
            explicitly_shared: string;
            reference_count: string;
            has_recommended_budget: string;
            recommended_budget_amount_micros: string;
            period: string;
            recommended_budget_estimated_change_weekly_clicks: string;
            recommended_budget_estimated_change_weekly_cost_micros: string;
            recommended_budget_estimated_change_weekly_interactions: string;
            recommended_budget_estimated_change_weekly_views: string;
            type: string;
        };
        campaign: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            serving_status: string;
            ad_serving_optimization_status: string;
            advertising_channel_type: string;
            advertising_channel_sub_type: string;
            tracking_url_template: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            real_time_bidding_setting: {
                opt_in: string;
            };
            network_settings: {
                target_google_search: string;
                target_search_network: string;
                target_content_network: string;
                target_partner_search_network: string;
            };
            hotel_setting: {
                hotel_center_id: string;
            };
            dynamic_search_ads_setting: {
                domain_name: string;
                language_code: string;
                use_supplied_urls_only: string;
                feeds: string;
            };
            shopping_setting: {
                merchant_id: string;
                sales_country: string;
                campaign_priority: string;
                enable_local: string;
            };
            targeting_setting: {
                target_restrictions: {
                    targeting_dimension: string;
                    bid_only: string;
                };
                target_restriction_operations: {
                    operator: {};
                    value: {
                        targeting_dimension: string;
                        bid_only: string;
                    };
                };
            };
            geo_target_type_setting: {
                positive_geo_target_type: string;
                negative_geo_target_type: string;
            };
            app_campaign_setting: {
                bidding_strategy_goal_type: string;
                app_id: string;
                app_store: string;
            };
            labels: string;
            experiment_type: string;
            base_campaign: string;
            campaign_budget: string;
            bidding_strategy_type: string;
            start_date: string;
            end_date: string;
            final_url_suffix: string;
            frequency_caps: {
                key: {
                    level: string;
                    event_type: string;
                    time_unit: string;
                    time_length: string;
                };
                cap: string;
            };
            video_brand_safety_suitability: string;
            vanity_pharma: {
                vanity_pharma_display_url_mode: string;
                vanity_pharma_text: string;
            };
            selective_optimization: {
                conversion_actions: string;
            };
            tracking_setting: {
                tracking_url: string;
            };
            payment_mode: string;
            bidding_strategy: string;
            commission: {
                commission_rate_micros: string;
            };
            manual_cpc: {
                enhanced_cpc_enabled: string;
            };
            manual_cpm: {};
            manual_cpv: {};
            maximize_conversions: {};
            maximize_conversion_value: {
                target_roas: string;
            };
            target_cpa: {
                target_cpa_micros: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_impression_share: {
                location: string;
                location_fraction_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            target_roas: {
                target_roas: string;
                cpc_bid_ceiling_micros: string;
                cpc_bid_floor_micros: string;
            };
            target_spend: {
                target_spend_micros: string;
                cpc_bid_ceiling_micros: string;
            };
            percent_cpc: {
                cpc_bid_ceiling_micros: string;
                enhanced_cpc_enabled: string;
            };
            target_cpm: {};
        };
        campaign_audience_view: {
            resource_name: string;
        };
        campaign_bid_modifier: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            interaction_type: {
                type: string;
            };
        };
        campaign_criterion: {
            resource_name: string;
            campaign: string;
            criterion_id: string;
            bid_modifier: string;
            negative: string;
            type: string;
            status: string;
            keyword: {
                text: string;
                match_type: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            location: {
                geo_target_constant: string;
            };
            device: {
                type: string;
            };
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            age_range: {
                type: string;
            };
            gender: {
                type: string;
            };
            income_range: {
                type: string;
            };
            parental_status: {
                type: string;
            };
            user_list: {
                user_list: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            proximity: {
                geo_point: {
                    longitude_in_micro_degrees: string;
                    latitude_in_micro_degrees: string;
                };
                radius: string;
                radius_units: string;
                address: {
                    postal_code: string;
                    province_code: string;
                    country_code: string;
                    province_name: string;
                    street_address: string;
                    street_address2: string;
                    city_name: string;
                };
            };
            topic: {
                topic_constant: string;
                path: string;
            };
            listing_scope: {
                dimensions: {
                    hotel_id: {
                        value: string;
                    };
                    hotel_class: {
                        value: string;
                    };
                    hotel_country_region: {
                        country_region_criterion: string;
                    };
                    hotel_state: {
                        state_criterion: string;
                    };
                    hotel_city: {
                        city_criterion: string;
                    };
                    product_bidding_category: {
                        id: string;
                        country_code: string;
                        level: string;
                    };
                    product_brand: {
                        value: string;
                    };
                    product_channel: {
                        channel: string;
                    };
                    product_channel_exclusivity: {
                        channel_exclusivity: string;
                    };
                    product_condition: {
                        condition: string;
                    };
                    product_custom_attribute: {
                        value: string;
                        index: string;
                    };
                    product_item_id: {
                        value: string;
                    };
                    product_type: {
                        value: string;
                        level: string;
                    };
                    unknown_listing_dimension: {};
                };
            };
            language: {
                language_constant: string;
            };
            ip_block: {
                ip_address: string;
            };
            content_label: {
                type: string;
            };
            carrier: {
                carrier_constant: string;
            };
            user_interest: {
                user_interest_category: string;
            };
            webpage: {
                criterion_name: string;
                conditions: {
                    operand: string;
                    operator: string;
                    argument: string;
                };
            };
            operating_system_version: {
                operating_system_version_constant: string;
            };
            mobile_device: {
                mobile_device_constant: string;
            };
            location_group: {
                feed: string;
                geo_target_constants: string;
                radius: string;
                radius_units: string;
            };
            custom_affinity: {
                custom_affinity: string;
            };
        };
        campaign_criterion_simulation: {
            resource_name: string;
            campaign_id: string;
            criterion_id: string;
            type: string;
            modification_method: string;
            start_date: string;
            end_date: string;
            bid_modifier_point_list: {
                points: {
                    bid_modifier: string;
                    biddable_conversions: string;
                    biddable_conversions_value: string;
                    clicks: string;
                    cost_micros: string;
                    impressions: string;
                    top_slot_impressions: string;
                    parent_biddable_conversions: string;
                    parent_biddable_conversions_value: string;
                    parent_clicks: string;
                    parent_cost_micros: string;
                    parent_impressions: string;
                    parent_top_slot_impressions: string;
                    parent_required_budget_micros: string;
                };
            };
        };
        campaign_draft: {
            resource_name: string;
            draft_id: string;
            base_campaign: string;
            name: string;
            draft_campaign: string;
            status: string;
            has_experiment_running: string;
            long_running_operation: string;
        };
        campaign_experiment: {
            resource_name: string;
            id: string;
            campaign_draft: string;
            name: string;
            description: string;
            traffic_split_percent: string;
            traffic_split_type: string;
            experiment_campaign: string;
            status: string;
            long_running_operation: string;
            start_date: string;
            end_date: string;
        };
        campaign_extension_setting: {
            resource_name: string;
            extension_type: string;
            campaign: string;
            extension_feed_items: string;
            device: string;
        };
        campaign_feed: {
            resource_name: string;
            feed: string;
            campaign: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        campaign_label: {
            resource_name: string;
            campaign: string;
            label: string;
        };
        campaign_shared_set: {
            resource_name: string;
            campaign: string;
            shared_set: string;
            status: string;
        };
        carrier_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
        };
        change_status: {
            resource_name: string;
            last_change_date_time: string;
            resource_type: string;
            campaign: string;
            ad_group: string;
            resource_status: string;
            ad_group_ad: string;
            ad_group_criterion: string;
            campaign_criterion: string;
            feed: string;
            feed_item: string;
            ad_group_feed: string;
            campaign_feed: string;
            ad_group_bid_modifier: string;
        };
        conversion_action: {
            resource_name: string;
            id: string;
            name: string;
            status: string;
            type: string;
            category: string;
            owner_customer: string;
            include_in_conversions_metric: string;
            click_through_lookback_window_days: string;
            view_through_lookback_window_days: string;
            value_settings: {
                default_value: string;
                default_currency_code: string;
                always_use_default_value: string;
            };
            counting_type: string;
            attribution_model_settings: {
                attribution_model: string;
                data_driven_model_status: string;
            };
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
            phone_call_duration_seconds: string;
            app_id: string;
        };
        click_view: {
            resource_name: string;
            gclid: string;
            area_of_interest: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            location_of_presence: {
                city: string;
                country: string;
                metro: string;
                most_specific: string;
                region: string;
            };
            page_number: string;
            ad_group_ad: string;
        };
        currency_constant: {
            resource_name: string;
            code: string;
            name: string;
            symbol: string;
            billable_unit_micros: string;
        };
        custom_interest: {
            resource_name: string;
            id: string;
            status: string;
            name: string;
            type: string;
            description: string;
            members: {
                member_type: string;
                parameter: string;
            };
        };
        customer: {
            resource_name: string;
            id: string;
            descriptive_name: string;
            currency_code: string;
            time_zone: string;
            tracking_url_template: string;
            final_url_suffix: string;
            auto_tagging_enabled: string;
            has_partners_badge: string;
            manager: string;
            test_account: string;
            call_reporting_setting: {
                call_reporting_enabled: string;
                call_conversion_reporting_enabled: string;
                call_conversion_action: string;
            };
            conversion_tracking_setting: {
                conversion_tracking_id: string;
                cross_account_conversion_tracking_id: string;
            };
            remarketing_setting: {
                google_global_site_tag: string;
            };
            pay_per_conversion_eligibility_failure_reasons: string;
        };
        customer_manager_link: {
            resource_name: string;
            manager_customer: string;
            manager_link_id: string;
            status: string;
        };
        customer_client_link: {
            resource_name: string;
            client_customer: string;
            manager_link_id: string;
            status: string;
            hidden: string;
        };
        customer_client: {
            resource_name: string;
            client_customer: string;
            hidden: string;
            level: string;
            time_zone: string;
            test_account: string;
            manager: string;
            descriptive_name: string;
            currency_code: string;
            id: string;
        };
        customer_extension_setting: {
            resource_name: string;
            extension_type: string;
            extension_feed_items: string;
            device: string;
        };
        customer_feed: {
            resource_name: string;
            feed: string;
            placeholder_types: string;
            matching_function: {
                function_string: string;
                operator: string;
                left_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
                right_operands: {
                    constant_operand: {
                        string_value: string;
                        long_value: string;
                        boolean_value: string;
                        double_value: string;
                    };
                    feed_attribute_operand: {
                        feed_id: string;
                        feed_attribute_id: string;
                    };
                    function_operand: null;
                    request_context_operand: {
                        context_type: string;
                    };
                };
            };
            status: string;
        };
        customer_label: {
            resource_name: string;
            customer: string;
            label: string;
        };
        customer_negative_criterion: {
            resource_name: string;
            id: string;
            type: string;
            content_label: {
                type: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            placement: {
                url: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
        };
        detail_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            group_placement_target_url: string;
            target_url: string;
            placement_type: string;
        };
        display_keyword_view: {
            resource_name: string;
        };
        distance_view: {
            resource_name: string;
            distance_bucket: string;
            metric_system: string;
        };
        dynamic_search_ads_search_term_view: {
            resource_name: string;
            search_term: string;
            headline: string;
            landing_page: string;
            page_url: string;
            has_negative_keyword: string;
            has_matching_keyword: string;
            has_negative_url: string;
        };
        expanded_landing_page_view: {
            resource_name: string;
            expanded_final_url: string;
        };
        extension_feed_item: {
            resource_name: string;
            id: string;
            extension_type: string;
            start_date_time: string;
            end_date_time: string;
            ad_schedules: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
            device: string;
            targeted_geo_target_constant: string;
            targeted_keyword: {
                text: string;
                match_type: string;
            };
            status: string;
            sitelink_feed_item: {
                link_text: string;
                line1: string;
                line2: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            structured_snippet_feed_item: {
                header: string;
                values: string;
            };
            app_feed_item: {
                link_text: string;
                app_id: string;
                app_store: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
            };
            call_feed_item: {
                phone_number: string;
                country_code: string;
                call_tracking_enabled: string;
                call_conversion_action: string;
                call_conversion_tracking_disabled: string;
                call_conversion_reporting_state: string;
            };
            callout_feed_item: {
                callout_text: string;
            };
            text_message_feed_item: {
                business_name: string;
                country_code: string;
                phone_number: string;
                text: string;
                extension_text: string;
            };
            price_feed_item: {
                type: string;
                price_qualifier: string;
                tracking_url_template: string;
                language_code: string;
                price_offerings: {
                    header: string;
                    description: string;
                    price: {
                        currency_code: string;
                        amount_micros: string;
                    };
                    unit: string;
                    final_urls: string;
                    final_mobile_urls: string;
                };
                final_url_suffix: string;
            };
            promotion_feed_item: {
                promotion_target: string;
                discount_modifier: string;
                promotion_start_date: string;
                promotion_end_date: string;
                occasion: string;
                final_urls: string;
                final_mobile_urls: string;
                tracking_url_template: string;
                url_custom_parameters: {
                    key: string;
                    value: string;
                };
                final_url_suffix: string;
                language_code: string;
                percent_off: string;
                money_amount_off: {
                    currency_code: string;
                    amount_micros: string;
                };
                promotion_code: string;
                orders_over_amount: {
                    currency_code: string;
                    amount_micros: string;
                };
            };
            location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
            };
            affiliate_location_feed_item: {
                business_name: string;
                address_line1: string;
                address_line2: string;
                city: string;
                province: string;
                postal_code: string;
                country_code: string;
                phone_number: string;
                chain_id: string;
                chain_name: string;
            };
            hotel_callout_feed_item: {
                text: string;
                language_code: string;
            };
            targeted_campaign: string;
            targeted_ad_group: string;
        };
        feed: {
            resource_name: string;
            id: string;
            name: string;
            attributes: {
                id: string;
                name: string;
                type: string;
                is_part_of_key: string;
            };
            attribute_operations: {
                operator: {};
                value: {
                    id: string;
                    name: string;
                    type: string;
                    is_part_of_key: string;
                };
            };
            origin: string;
            status: string;
            places_location_feed_data: {
                oauth_info: {
                    http_method: string;
                    http_request_url: string;
                    http_authorization_header: string;
                };
                email_address: string;
                business_account_id: string;
                business_name_filter: string;
                category_filters: string;
                label_filters: string;
            };
            affiliate_location_feed_data: {
                chain_ids: string;
                relationship_type: string;
            };
        };
        feed_item: {
            resource_name: string;
            feed: string;
            id: string;
            start_date_time: string;
            end_date_time: string;
            attribute_values: {
                feed_attribute_id: string;
                integer_value: string;
                boolean_value: string;
                string_value: string;
                double_value: string;
                price_value: {
                    currency_code: string;
                    amount_micros: string;
                };
                integer_values: string;
                boolean_values: string;
                string_values: string;
                double_values: string;
            };
            geo_targeting_restriction: string;
            url_custom_parameters: {
                key: string;
                value: string;
            };
            status: string;
            policy_infos: {
                placeholder_type_enum: string;
                feed_mapping_resource_name: string;
                review_status: string;
                approval_status: string;
                policy_topic_entries: {
                    topic: string;
                    type: string;
                    evidences: {
                        website_list: {
                            websites: string;
                        };
                        text_list: {
                            texts: string;
                        };
                        language_code: string;
                        destination_text_list: {
                            destination_texts: string;
                        };
                        destination_mismatch: {
                            url_types: string;
                        };
                        destination_not_working: {
                            expanded_url: string;
                            device: string;
                            last_checked_date_time: string;
                            dns_error_type: string;
                            http_error_code: string;
                        };
                    };
                    constraints: {
                        country_constraint_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        reseller_constraint: {};
                        certificate_missing_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                        certificate_domain_mismatch_in_country_list: {
                            total_targeted_countries: string;
                            countries: {
                                country_criterion: string;
                            };
                        };
                    };
                };
                validation_status: string;
                validation_errors: {};
                quality_approval_status: string;
                quality_disapproval_reasons: string;
            };
        };
        feed_item_target: {
            resource_name: string;
            feed_item: string;
            feed_item_target_type: string;
            feed_item_target_id: string;
            status: string;
            campaign: string;
            ad_group: string;
            keyword: {
                text: string;
                match_type: string;
            };
            geo_target_constant: string;
            device: string;
            ad_schedule: {
                start_minute: string;
                end_minute: string;
                start_hour: string;
                end_hour: string;
                day_of_week: string;
            };
        };
        feed_mapping: {
            resource_name: string;
            feed: string;
            attribute_field_mappings: {
                feed_attribute_id: string;
                field_id: string;
                sitelink_field: string;
                call_field: string;
                app_field: string;
                location_field: string;
                affiliate_location_field: string;
                callout_field: string;
                structured_snippet_field: string;
                message_field: string;
                price_field: string;
                promotion_field: string;
                ad_customizer_field: string;
                dsa_page_feed_field: string;
                location_extension_targeting_field: string;
                education_field: string;
                flight_field: string;
                custom_field: string;
                hotel_field: string;
                real_estate_field: string;
                travel_field: string;
                local_field: string;
                job_field: string;
            };
            status: string;
            placeholder_type: string;
            criterion_type: string;
        };
        feed_placeholder_view: {
            resource_name: string;
            placeholder_type: string;
        };
        gender_view: {
            resource_name: string;
        };
        geo_target_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
        geographic_view: {
            resource_name: string;
            location_type: string;
            country_criterion_id: string;
        };
        group_placement_view: {
            resource_name: string;
            placement: string;
            display_name: string;
            target_url: string;
            placement_type: string;
        };
        hotel_group_view: {
            resource_name: string;
        };
        hotel_performance_view: {
            resource_name: string;
        };
        keyword_view: {
            resource_name: string;
        };
        keyword_plan: {
            resource_name: string;
            id: string;
            name: string;
            forecast_period: {
                date_interval: string;
                date_range: {
                    start_date: string;
                    end_date: string;
                };
            };
        };
        keyword_plan_campaign: {
            resource_name: string;
            keyword_plan: string;
            id: string;
            name: string;
            language_constants: string;
            keyword_plan_network: string;
            cpc_bid_micros: string;
            geo_targets: {
                geo_target_constant: string;
            };
        };
        keyword_plan_negative_keyword: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            text: string;
            match_type: string;
        };
        keyword_plan_ad_group: {
            resource_name: string;
            keyword_plan_campaign: string;
            id: string;
            name: string;
            cpc_bid_micros: string;
        };
        keyword_plan_keyword: {
            resource_name: string;
            keyword_plan_ad_group: string;
            id: string;
            text: string;
            match_type: string;
            cpc_bid_micros: string;
        };
        label: {};
        landing_page_view: {
            resource_name: string;
            unexpanded_final_url: string;
        };
        language_constant: {
            resource_name: string;
            id: string;
            code: string;
            name: string;
            targetable: string;
        };
        location_view: {
            resource_name: string;
        };
        managed_placement_view: {
            resource_name: string;
        };
        media_file: {
            resource_name: string;
            id: string;
            type: string;
            mime_type: string;
            source_url: string;
            name: string;
            file_size: string;
            image: {
                data: string;
            };
            media_bundle: {
                data: string;
            };
            audio: {
                ad_duration_millis: string;
            };
            video: {
                ad_duration_millis: string;
                youtube_video_id: string;
                advertising_id_code: string;
                isci_code: string;
            };
        };
        mobile_app_category_constant: {
            resource_name: string;
            id: string;
            name: string;
        };
        mobile_device_constant: {
            resource_name: string;
            id: string;
            name: string;
            manufacturer_name: string;
            operating_system_name: string;
            type: string;
        };
        mutate_job: {
            resource_name: string;
            id: string;
            next_add_sequence_token: string;
            metadata: {
                creation_date_time: string;
                completion_date_time: string;
                estimated_completion_ratio: string;
                operation_count: string;
                executed_operation_count: string;
            };
            status: string;
            long_running_operation: string;
        };
        operating_system_version_constant: {
            resource_name: string;
            id: string;
            name: string;
            os_major_version: string;
            os_minor_version: string;
            operator_type: string;
        };
        paid_organic_search_term_view: {
            resource_name: string;
            search_term: string;
        };
        parental_status_view: {
            resource_name: string;
        };
        product_bidding_category_constant: {
            resource_name: string;
            id: string;
            country_code: string;
            product_bidding_category_constant_parent: string;
            level: string;
            status: string;
            language_code: string;
            localized_name: string;
        };
        product_group_view: {
            resource_name: string;
        };
        recommendation: {
            resource_name: string;
            type: string;
            impact: {
                base_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
                potential_metrics: {
                    impressions: string;
                    clicks: string;
                    cost_micros: string;
                    conversions: string;
                    video_views: string;
                };
            };
            campaign_budget: string;
            campaign: string;
            ad_group: string;
            dismissed: string;
            campaign_budget_recommendation: {
                current_budget_amount_micros: string;
                recommended_budget_amount_micros: string;
                budget_options: {
                    budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
            };
            keyword_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_cpc_bid_micros: string;
            };
            text_ad_recommendation: {
                ad: {
                    resource_name: string;
                    id: string;
                    final_urls: string;
                    final_app_urls: {
                        os_type: string;
                        url: string;
                    };
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    final_url_suffix: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    display_url: string;
                    type: string;
                    added_by_google_ads: string;
                    device_preference: string;
                    url_collections: {
                        url_collection_id: string;
                        final_urls: string;
                        final_mobile_urls: string;
                        tracking_url_template: string;
                    };
                    name: string;
                    system_managed_resource_source: string;
                    text_ad: {
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    expanded_text_ad: {
                        headline_part1: string;
                        headline_part2: string;
                        headline_part3: string;
                        description: string;
                        description2: string;
                        path1: string;
                        path2: string;
                    };
                    call_only_ad: {
                        country_code: string;
                        phone_number: string;
                        business_name: string;
                        headline1: string;
                        headline2: string;
                        description1: string;
                        description2: string;
                        call_tracked: string;
                        disable_call_conversion: string;
                        phone_number_verification_url: string;
                        conversion_action: string;
                        conversion_reporting_state: string;
                    };
                    expanded_dynamic_search_ad: {
                        description: string;
                        description2: string;
                    };
                    hotel_ad: {};
                    shopping_smart_ad: {};
                    shopping_product_ad: {};
                    gmail_ad: {
                        teaser: {
                            headline: string;
                            description: string;
                            business_name: string;
                            logo_image: string;
                        };
                        header_image: string;
                        marketing_image: string;
                        marketing_image_headline: string;
                        marketing_image_description: string;
                        marketing_image_display_call_to_action: {
                            text: string;
                            text_color: string;
                            url_collection_id: string;
                        };
                        product_images: {
                            product_image: string;
                            description: string;
                            display_call_to_action: {
                                text: string;
                                text_color: string;
                                url_collection_id: string;
                            };
                        };
                        product_videos: {
                            product_video: string;
                        };
                    };
                    image_ad: {
                        pixel_width: string;
                        pixel_height: string;
                        image_url: string;
                        preview_pixel_width: string;
                        preview_pixel_height: string;
                        preview_image_url: string;
                        mime_type: string;
                        name: string;
                        media_file: string;
                        data: string;
                        ad_id_to_copy_image_from: string;
                    };
                    video_ad: {
                        media_file: string;
                        in_stream: {
                            action_button_label: string;
                            action_headline: string;
                            companion_banner: string;
                        };
                        bumper: {
                            companion_banner: string;
                        };
                        out_stream: {
                            headline: string;
                            description: string;
                        };
                        non_skippable: {
                            companion_banner: string;
                        };
                        discovery: {
                            headline: string;
                            description1: string;
                            description2: string;
                        };
                    };
                    responsive_search_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        path1: string;
                        path2: string;
                    };
                    legacy_responsive_display_ad: {
                        short_headline: string;
                        long_headline: string;
                        description: string;
                        business_name: string;
                        allow_flexible_color: string;
                        accent_color: string;
                        main_color: string;
                        call_to_action_text: string;
                        logo_image: string;
                        square_logo_image: string;
                        marketing_image: string;
                        square_marketing_image: string;
                        format_setting: string;
                        price_prefix: string;
                        promo_text: string;
                    };
                    app_ad: {
                        mandatory_ad_text: {
                            text: string;
                            pinned_field: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        html_5_media_bundles: {
                            asset: string;
                        };
                    };
                    legacy_app_install_ad: {
                        app_id: string;
                        app_store: string;
                        headline: string;
                        description1: string;
                        description2: string;
                    };
                    responsive_display_ad: {
                        marketing_images: {
                            asset: string;
                        };
                        square_marketing_images: {
                            asset: string;
                        };
                        logo_images: {
                            asset: string;
                        };
                        square_logo_images: {
                            asset: string;
                        };
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        long_headline: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        youtube_videos: {
                            asset: string;
                        };
                        business_name: string;
                        main_color: string;
                        accent_color: string;
                        allow_flexible_color: string;
                        call_to_action_text: string;
                        price_prefix: string;
                        promo_text: string;
                        format_setting: string;
                    };
                    display_upload_ad: {
                        display_upload_product_type: string;
                        media_bundle: {
                            asset: string;
                        };
                    };
                    app_engagement_ad: {
                        headlines: {
                            text: string;
                            pinned_field: string;
                        };
                        descriptions: {
                            text: string;
                            pinned_field: string;
                        };
                        images: {
                            asset: string;
                        };
                        videos: {
                            asset: string;
                        };
                    };
                    shopping_comparison_listing_ad: {
                        headline: string;
                    };
                };
                creation_date: string;
                auto_apply_date: string;
            };
            target_cpa_opt_in_recommendation: {
                options: {
                    goal: string;
                    target_cpa_micros: string;
                    required_campaign_budget_amount_micros: string;
                    impact: {
                        base_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                        potential_metrics: {
                            impressions: string;
                            clicks: string;
                            cost_micros: string;
                            conversions: string;
                            video_views: string;
                        };
                    };
                };
                recommended_target_cpa_micros: string;
            };
            maximize_conversions_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            enhanced_cpc_opt_in_recommendation: {};
            search_partners_opt_in_recommendation: {};
            maximize_clicks_opt_in_recommendation: {
                recommended_budget_amount_micros: string;
            };
            optimize_ad_rotation_recommendation: {};
            callout_extension_recommendation: {
                recommended_extensions: {
                    callout_text: string;
                };
            };
            sitelink_extension_recommendation: {
                recommended_extensions: {
                    link_text: string;
                    line1: string;
                    line2: string;
                    final_urls: string;
                    final_mobile_urls: string;
                    tracking_url_template: string;
                    url_custom_parameters: {
                        key: string;
                        value: string;
                    };
                    final_url_suffix: string;
                };
            };
            call_extension_recommendation: {
                recommended_extensions: {
                    phone_number: string;
                    country_code: string;
                    call_tracking_enabled: string;
                    call_conversion_action: string;
                    call_conversion_tracking_disabled: string;
                    call_conversion_reporting_state: string;
                };
            };
            keyword_match_type_recommendation: {
                keyword: {
                    text: string;
                    match_type: string;
                };
                recommended_match_type: string;
            };
            move_unused_budget_recommendation: {
                excess_campaign_budget: string;
                budget_recommendation: {
                    current_budget_amount_micros: string;
                    recommended_budget_amount_micros: string;
                    budget_options: {
                        budget_amount_micros: string;
                        impact: {
                            base_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                            potential_metrics: {
                                impressions: string;
                                clicks: string;
                                cost_micros: string;
                                conversions: string;
                                video_views: string;
                            };
                        };
                    };
                };
            };
        };
        search_term_view: {
            resource_name: string;
            search_term: string;
            ad_group: string;
            status: string;
        };
        shared_criterion: {
            resource_name: string;
            shared_set: string;
            criterion_id: string;
            type: string;
            keyword: {
                text: string;
                match_type: string;
            };
            youtube_video: {
                video_id: string;
            };
            youtube_channel: {
                channel_id: string;
            };
            placement: {
                url: string;
            };
            mobile_app_category: {
                mobile_app_category_constant: string;
            };
            mobile_application: {
                app_id: string;
                name: string;
            };
        };
        shared_set: {
            resource_name: string;
            id: string;
            type: string;
            name: string;
            status: string;
            member_count: string;
            reference_count: string;
        };
        shopping_performance_view: {
            resource_name: string;
        };
        topic_view: {
            resource_name: string;
        };
        user_interest: {
            resource_name: string;
            taxonomy_type: string;
            user_interest_id: string;
            name: string;
            user_interest_parent: string;
            launched_to_all: string;
            availabilities: {
                channel: {
                    availability_mode: string;
                    advertising_channel_type: string;
                    advertising_channel_sub_type: string;
                    include_default_channel_sub_type: string;
                };
                locale: {
                    availability_mode: string;
                    country_code: string;
                    language_code: string;
                };
            };
        };
        user_list: {
            resource_name: string;
            id: string;
            read_only: string;
            name: string;
            description: string;
            membership_status: string;
            integration_code: string;
            membership_life_span: string;
            size_for_display: string;
            size_range_for_display: string;
            size_for_search: string;
            size_range_for_search: string;
            type: string;
            closing_reason: string;
            access_reason: string;
            account_user_list_status: string;
            eligible_for_search: string;
            eligible_for_display: string;
            crm_based_user_list: {
                app_id: string;
                upload_key_type: string;
                data_source_type: string;
            };
            similar_user_list: {
                seed_user_list: string;
            };
            rule_based_user_list: {
                prepopulation_status: string;
                combined_rule_user_list: {
                    left_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    right_operand: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    rule_operator: string;
                };
                date_specific_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                    start_date: string;
                    end_date: string;
                };
                expression_rule_user_list: {
                    rule: {
                        rule_type: string;
                        rule_item_groups: {
                            rule_items: {
                                name: string;
                                number_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                string_rule_item: {
                                    operator: string;
                                    value: string;
                                };
                                date_rule_item: {
                                    operator: string;
                                    value: string;
                                    offset_in_days: string;
                                };
                            };
                        };
                    };
                };
            };
            logical_user_list: {
                rules: {
                    operator: string;
                    rule_operands: {
                        user_list: string;
                    };
                };
            };
            basic_user_list: {
                actions: {
                    conversion_action: string;
                    remarketing_action: string;
                };
            };
        };
        user_location_view: {
            resource_name: string;
            country_criterion_id: string;
            targeting_location: string;
        };
        remarketing_action: {
            resource_name: string;
            id: string;
            name: string;
            tag_snippets: {
                type: string;
                page_format: string;
                global_site_tag: string;
                event_snippet: string;
            };
        };
        topic_constant: {
            resource_name: string;
            id: string;
            topic_constant_parent: string;
            path: string;
        };
        video: {
            resource_name: string;
            id: string;
            channel_id: string;
            duration_millis: string;
            title: string;
        };
        metrics: {
            absolute_top_impression_percentage: string;
            active_view_cpm: string;
            active_view_ctr: string;
            active_view_impressions: string;
            active_view_measurability: string;
            active_view_measurable_cost_micros: string;
            active_view_measurable_impressions: string;
            active_view_viewability: string;
            all_conversions_from_interactions_rate: string;
            all_conversions_value: string;
            all_conversions: string;
            all_conversions_value_per_cost: string;
            all_conversions_from_click_to_call: string;
            all_conversions_from_directions: string;
            all_conversions_from_interactions_value_per_interaction: string;
            all_conversions_from_menu: string;
            all_conversions_from_order: string;
            all_conversions_from_other_engagement: string;
            all_conversions_from_store_visit: string;
            all_conversions_from_store_website: string;
            average_cost: string;
            average_cpc: string;
            average_cpe: string;
            average_cpm: string;
            average_cpv: string;
            average_page_views: string;
            average_time_on_site: string;
            benchmark_average_max_cpc: string;
            benchmark_ctr: string;
            bounce_rate: string;
            clicks: string;
            combined_clicks: string;
            combined_clicks_per_query: string;
            combined_queries: string;
            content_budget_lost_impression_share: string;
            content_impression_share: string;
            conversion_last_received_request_date_time: string;
            conversion_last_conversion_date: string;
            content_rank_lost_impression_share: string;
            conversions_from_interactions_rate: string;
            conversions_value: string;
            conversions_value_per_cost: string;
            conversions_from_interactions_value_per_interaction: string;
            conversions: string;
            cost_micros: string;
            cost_per_all_conversions: string;
            cost_per_conversion: string;
            cost_per_current_model_attributed_conversion: string;
            cross_device_conversions: string;
            ctr: string;
            current_model_attributed_conversions: string;
            current_model_attributed_conversions_from_interactions_rate: string;
            current_model_attributed_conversions_from_interactions_value_per_interaction: string;
            current_model_attributed_conversions_value: string;
            current_model_attributed_conversions_value_per_cost: string;
            engagement_rate: string;
            engagements: string;
            hotel_average_lead_value_micros: string;
            hotel_price_difference_percentage: string;
            historical_creative_quality_score: string;
            historical_landing_page_quality_score: string;
            historical_quality_score: string;
            historical_search_predicted_ctr: string;
            gmail_forwards: string;
            gmail_saves: string;
            gmail_secondary_clicks: string;
            impressions_from_store_reach: string;
            impressions: string;
            interaction_rate: string;
            interactions: string;
            interaction_event_types: string;
            invalid_click_rate: string;
            invalid_clicks: string;
            message_chats: string;
            message_impressions: string;
            message_chat_rate: string;
            mobile_friendly_clicks_percentage: string;
            organic_clicks: string;
            organic_clicks_per_query: string;
            organic_impressions: string;
            organic_impressions_per_query: string;
            organic_queries: string;
            percent_new_visitors: string;
            phone_calls: string;
            phone_impressions: string;
            phone_through_rate: string;
            relative_ctr: string;
            search_absolute_top_impression_share: string;
            search_budget_lost_absolute_top_impression_share: string;
            search_budget_lost_impression_share: string;
            search_budget_lost_top_impression_share: string;
            search_click_share: string;
            search_exact_match_impression_share: string;
            search_impression_share: string;
            search_rank_lost_absolute_top_impression_share: string;
            search_rank_lost_impression_share: string;
            search_rank_lost_top_impression_share: string;
            search_top_impression_share: string;
            speed_score: string;
            top_impression_percentage: string;
            valid_accelerated_mobile_pages_clicks_percentage: string;
            value_per_all_conversions: string;
            value_per_conversion: string;
            value_per_current_model_attributed_conversion: string;
            video_quartile_100_rate: string;
            video_quartile_25_rate: string;
            video_quartile_50_rate: string;
            video_quartile_75_rate: string;
            video_view_rate: string;
            video_views: string;
            view_through_conversions: string;
        };
        segments: {
            ad_network_type: string;
            click_type: string;
            conversion_action: string;
            conversion_action_category: string;
            conversion_action_name: string;
            conversion_adjustment: string;
            conversion_attribution_event_type: string;
            conversion_lag_bucket: string;
            conversion_or_adjustment_lag_bucket: string;
            date: string;
            day_of_week: string;
            device: string;
            external_conversion_source: string;
            geo_target_airport: string;
            geo_target_canton: string;
            geo_target_city: string;
            geo_target_country: string;
            geo_target_county: string;
            geo_target_district: string;
            geo_target_metro: string;
            geo_target_most_specific_location: string;
            geo_target_postal_code: string;
            geo_target_province: string;
            geo_target_region: string;
            geo_target_state: string;
            hotel_booking_window_days: string;
            hotel_center_id: string;
            hotel_check_in_date: string;
            hotel_check_in_day_of_week: string;
            hotel_city: string;
            hotel_class: string;
            hotel_country: string;
            hotel_date_selection_type: string;
            hotel_length_of_stay: string;
            hotel_rate_rule_id: string;
            hotel_rate_type: string;
            hotel_price_bucket: string;
            hotel_state: string;
            hour: string;
            interaction_on_this_extension: string;
            keyword: {
                ad_group_criterion: string;
                info: {
                    text: string;
                    match_type: string;
                };
            };
            month: string;
            month_of_year: string;
            partner_hotel_id: string;
            placeholder_type: string;
            product_aggregator_id: string;
            product_bidding_category_level1: string;
            product_bidding_category_level2: string;
            product_bidding_category_level3: string;
            product_bidding_category_level4: string;
            product_bidding_category_level5: string;
            product_brand: string;
            product_channel: string;
            product_channel_exclusivity: string;
            product_condition: string;
            product_country: string;
            product_custom_attribute0: string;
            product_custom_attribute1: string;
            product_custom_attribute2: string;
            product_custom_attribute3: string;
            product_custom_attribute4: string;
            product_item_id: string;
            product_language: string;
            product_merchant_id: string;
            product_store_id: string;
            product_title: string;
            product_type_l1: string;
            product_type_l2: string;
            product_type_l3: string;
            product_type_l4: string;
            product_type_l5: string;
            quarter: string;
            search_engine_results_page_type: string;
            search_term_match_type: string;
            slot: string;
            webpage: string;
            week: string;
            year: string;
        };
    };
};
export declare const SearchTermViewService: {};
export declare const SharedCriterionService: {};
export declare const SharedSetService: {};
export declare const ShoppingPerformanceViewService: {};
export declare const LocationNames: {
    names: string;
};
export declare const GeoTargets: {
    geo_target_constants: string;
};
export declare const LocationNames: {
    names: string;
};
export declare const GeoTargets: {
    geo_target_constants: string;
};
export declare const SuggestGeoTargetConstantsRequest: {
    locale: string;
    country_code: string;
    location_names: {
        names: string;
    };
    geo_targets: {
        geo_target_constants: string;
    };
};
export declare const GeoTargetConstantSuggestion: {
    locale: string;
    reach: string;
    search_term: string;
    geo_target_constant: {
        resource_name: string;
        id: string;
        name: string;
        country_code: string;
        target_type: string;
        status: string;
        canonical_name: string;
    };
    geo_target_constant_parents: {
        resource_name: string;
        id: string;
        name: string;
        country_code: string;
        target_type: string;
        status: string;
        canonical_name: string;
    };
};
export declare const SuggestGeoTargetConstantsResponse: {
    geo_target_constant_suggestions: {
        locale: string;
        reach: string;
        search_term: string;
        geo_target_constant: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
        geo_target_constant_parents: {
            resource_name: string;
            id: string;
            name: string;
            country_code: string;
            target_type: string;
            status: string;
            canonical_name: string;
        };
    };
};
export declare const TopicConstantService: {};
export declare const TopicViewService: {};
export declare const CallConversion: {
    caller_id: string;
    call_start_date_time: string;
    conversion_action: string;
    conversion_date_time: string;
    conversion_value: string;
    currency_code: string;
};
export declare const UploadCallConversionsRequest: {
    customer_id: string;
    conversions: {
        caller_id: string;
        call_start_date_time: string;
        conversion_action: string;
        conversion_date_time: string;
        conversion_value: string;
        currency_code: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const CallConversionResult: {
    caller_id: string;
    call_start_date_time: string;
    conversion_action: string;
    conversion_date_time: string;
};
export declare const UploadCallConversionsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        caller_id: string;
        call_start_date_time: string;
        conversion_action: string;
        conversion_date_time: string;
    };
};
export declare const ExternalAttributionData: {
    external_attribution_credit: string;
    external_attribution_model: string;
};
export declare const ClickConversion: {
    gclid: string;
    conversion_action: string;
    conversion_date_time: string;
    conversion_value: string;
    currency_code: string;
    order_id: string;
    external_attribution_data: {
        external_attribution_credit: string;
        external_attribution_model: string;
    };
};
export declare const UploadClickConversionsRequest: {
    customer_id: string;
    conversions: {
        gclid: string;
        conversion_action: string;
        conversion_date_time: string;
        conversion_value: string;
        currency_code: string;
        order_id: string;
        external_attribution_data: {
            external_attribution_credit: string;
            external_attribution_model: string;
        };
    };
    partial_failure: string;
    validate_only: string;
};
export declare const ClickConversionResult: {
    gclid: string;
    conversion_action: string;
    conversion_date_time: string;
};
export declare const UploadClickConversionsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        gclid: string;
        conversion_action: string;
        conversion_date_time: string;
    };
};
export declare const RestatementValue: {
    adjusted_value: string;
    currency_code: string;
};
export declare const GclidDateTimePair: {
    gclid: string;
    conversion_date_time: string;
};
export declare const ConversionAdjustment: {
    conversion_action: string;
    adjustment_date_time: string;
    adjustment_type: string;
    restatement_value: {
        adjusted_value: string;
        currency_code: string;
    };
    gclid_date_time_pair: {
        gclid: string;
        conversion_date_time: string;
    };
    order_id: string;
};
export declare const UploadConversionAdjustmentsRequest: {
    customer_id: string;
    conversion_adjustments: {
        conversion_action: string;
        adjustment_date_time: string;
        adjustment_type: string;
        restatement_value: {
            adjusted_value: string;
            currency_code: string;
        };
        gclid_date_time_pair: {
            gclid: string;
            conversion_date_time: string;
        };
        order_id: string;
    };
    partial_failure: string;
    validate_only: string;
};
export declare const ConversionAdjustmentResult: {
    conversion_action: string;
    adjustment_date_time: string;
    adjustment_type: string;
    gclid_date_time_pair: {
        gclid: string;
        conversion_date_time: string;
    };
    order_id: string;
};
export declare const UploadConversionAdjustmentsResponse: {
    partial_failure_error: {
        code: string;
        message: string;
        details: {
            type_url: string;
            value: string;
        };
    };
    results: {
        conversion_action: string;
        adjustment_date_time: string;
        adjustment_type: string;
        gclid_date_time_pair: {
            gclid: string;
            conversion_date_time: string;
        };
        order_id: string;
    };
};
export declare const UserInterestService: {};
export declare const UserListService: {};
export declare const UserLocationViewService: {};
export declare const VideoService: {};
